'use strict';

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref59) {
  var t = _ref59.types;
  var template = _ref59.template;

  // constants used when statically verifying types
  var TYPE_INVALID = 0;
  var TYPE_VALID = 1;
  var TYPE_UNKNOWN = 2;

  /**
   * Binary Operators that can only produce boolean results.
   */
  var BOOLEAN_BINARY_OPERATORS = ['==', '===', '>=', '<=', '>', '<', 'instanceof'];

  if (!(Array.isArray(BOOLEAN_BINARY_OPERATORS) && BOOLEAN_BINARY_OPERATORS.every(function (item) {
    return typeof item === 'string';
  }))) {
    throw new TypeError('Value of variable "BOOLEAN_BINARY_OPERATORS" violates contract, expected string[] got ' + (BOOLEAN_BINARY_OPERATORS === null ? 'null' : (typeof BOOLEAN_BINARY_OPERATORS === 'undefined' ? 'undefined' : _typeof(BOOLEAN_BINARY_OPERATORS)) === 'object' && BOOLEAN_BINARY_OPERATORS.constructor ? BOOLEAN_BINARY_OPERATORS.constructor.name || '[Unknown Object]' : typeof BOOLEAN_BINARY_OPERATORS === 'undefined' ? 'undefined' : _typeof(BOOLEAN_BINARY_OPERATORS)));
  }

  var checks = createChecks();
  var staticChecks = createStaticChecks();

  var checkIsArray = expression('Array.isArray(input)');

  if (!(typeof checkIsArray === 'function')) {
    throw new TypeError('Value of variable "checkIsArray" violates contract, expected () => Node got ' + (checkIsArray === null ? 'null' : (typeof checkIsArray === 'undefined' ? 'undefined' : _typeof(checkIsArray)) === 'object' && checkIsArray.constructor ? checkIsArray.constructor.name || '[Unknown Object]' : typeof checkIsArray === 'undefined' ? 'undefined' : _typeof(checkIsArray)));
  }

  var checkIsMap = expression('input instanceof Map');

  if (!(typeof checkIsMap === 'function')) {
    throw new TypeError('Value of variable "checkIsMap" violates contract, expected () => Node got ' + (checkIsMap === null ? 'null' : (typeof checkIsMap === 'undefined' ? 'undefined' : _typeof(checkIsMap)) === 'object' && checkIsMap.constructor ? checkIsMap.constructor.name || '[Unknown Object]' : typeof checkIsMap === 'undefined' ? 'undefined' : _typeof(checkIsMap)));
  }

  var checkIsSet = expression('input instanceof Set');

  if (!(typeof checkIsSet === 'function')) {
    throw new TypeError('Value of variable "checkIsSet" violates contract, expected () => Node got ' + (checkIsSet === null ? 'null' : (typeof checkIsSet === 'undefined' ? 'undefined' : _typeof(checkIsSet)) === 'object' && checkIsSet.constructor ? checkIsSet.constructor.name || '[Unknown Object]' : typeof checkIsSet === 'undefined' ? 'undefined' : _typeof(checkIsSet)));
  }

  var checkIsObject = expression('input != null && typeof input === \'object\'');

  if (!(typeof checkIsObject === 'function')) {
    throw new TypeError('Value of variable "checkIsObject" violates contract, expected () => Node got ' + (checkIsObject === null ? 'null' : (typeof checkIsObject === 'undefined' ? 'undefined' : _typeof(checkIsObject)) === 'object' && checkIsObject.constructor ? checkIsObject.constructor.name || '[Unknown Object]' : typeof checkIsObject === 'undefined' ? 'undefined' : _typeof(checkIsObject)));
  }

  var checkNotNull = expression('input != null');

  if (!(typeof checkNotNull === 'function')) {
    throw new TypeError('Value of variable "checkNotNull" violates contract, expected () => Node got ' + (checkNotNull === null ? 'null' : (typeof checkNotNull === 'undefined' ? 'undefined' : _typeof(checkNotNull)) === 'object' && checkNotNull.constructor ? checkNotNull.constructor.name || '[Unknown Object]' : typeof checkNotNull === 'undefined' ? 'undefined' : _typeof(checkNotNull)));
  }

  var declareTypeChecker = template('\n    const id = function id (input) {\n      return check;\n    };\n  ');

  if (!(typeof declareTypeChecker === 'function')) {
    throw new TypeError('Value of variable "declareTypeChecker" violates contract, expected () => Node got ' + (declareTypeChecker === null ? 'null' : (typeof declareTypeChecker === 'undefined' ? 'undefined' : _typeof(declareTypeChecker)) === 'object' && declareTypeChecker.constructor ? declareTypeChecker.constructor.name || '[Unknown Object]' : typeof declareTypeChecker === 'undefined' ? 'undefined' : _typeof(declareTypeChecker)));
  }

  var guard = template('\n    if (!check) {\n      throw new TypeError(message);\n    }\n  ');

  if (!(typeof guard === 'function')) {
    throw new TypeError('Value of variable "guard" violates contract, expected () => Node got ' + (guard === null ? 'null' : (typeof guard === 'undefined' ? 'undefined' : _typeof(guard)) === 'object' && guard.constructor ? guard.constructor.name || '[Unknown Object]' : typeof guard === 'undefined' ? 'undefined' : _typeof(guard)));
  }

  var thrower = template('\n    if (check) {\n      ret;\n    }\n    else {\n      throw new TypeError(message);\n    }\n  ');

  if (!(typeof thrower === 'function')) {
    throw new TypeError('Value of variable "thrower" violates contract, expected () => Node got ' + (thrower === null ? 'null' : (typeof thrower === 'undefined' ? 'undefined' : _typeof(thrower)) === 'object' && thrower.constructor ? thrower.constructor.name || '[Unknown Object]' : typeof thrower === 'undefined' ? 'undefined' : _typeof(thrower)));
  }

  var readableName = expression('\n    input === null ? \'null\' : typeof input === \'object\' && input.constructor ? input.constructor.name || \'[Unknown Object]\' : typeof input\n  ');

  if (!(typeof readableName === 'function')) {
    throw new TypeError('Value of variable "readableName" violates contract, expected () => Node got ' + (readableName === null ? 'null' : (typeof readableName === 'undefined' ? 'undefined' : _typeof(readableName)) === 'object' && readableName.constructor ? readableName.constructor.name || '[Unknown Object]' : typeof readableName === 'undefined' ? 'undefined' : _typeof(readableName)));
  }

  var checkMapKeys = expression('\n    input instanceof Map && Array.from(input.keys()).every(key => keyCheck)\n  ');

  if (!(typeof checkMapKeys === 'function')) {
    throw new TypeError('Value of variable "checkMapKeys" violates contract, expected () => Node got ' + (checkMapKeys === null ? 'null' : (typeof checkMapKeys === 'undefined' ? 'undefined' : _typeof(checkMapKeys)) === 'object' && checkMapKeys.constructor ? checkMapKeys.constructor.name || '[Unknown Object]' : typeof checkMapKeys === 'undefined' ? 'undefined' : _typeof(checkMapKeys)));
  }

  var checkMapValues = expression('\n    input instanceof Map && Array.from(input.values()).every(value => valueCheck)\n  ');

  if (!(typeof checkMapValues === 'function')) {
    throw new TypeError('Value of variable "checkMapValues" violates contract, expected () => Node got ' + (checkMapValues === null ? 'null' : (typeof checkMapValues === 'undefined' ? 'undefined' : _typeof(checkMapValues)) === 'object' && checkMapValues.constructor ? checkMapValues.constructor.name || '[Unknown Object]' : typeof checkMapValues === 'undefined' ? 'undefined' : _typeof(checkMapValues)));
  }

  var checkMapEntries = expression('\n    input instanceof Map && Array.from(input).every(([key, value]) => keyCheck && valueCheck)\n  ');

  if (!(typeof checkMapEntries === 'function')) {
    throw new TypeError('Value of variable "checkMapEntries" violates contract, expected () => Node got ' + (checkMapEntries === null ? 'null' : (typeof checkMapEntries === 'undefined' ? 'undefined' : _typeof(checkMapEntries)) === 'object' && checkMapEntries.constructor ? checkMapEntries.constructor.name || '[Unknown Object]' : typeof checkMapEntries === 'undefined' ? 'undefined' : _typeof(checkMapEntries)));
  }

  var checkSetEntries = expression('\n    input instanceof Set && Array.from(input).every(value => valueCheck)\n  ');

  if (!(typeof checkSetEntries === 'function')) {
    throw new TypeError('Value of variable "checkSetEntries" violates contract, expected () => Node got ' + (checkSetEntries === null ? 'null' : (typeof checkSetEntries === 'undefined' ? 'undefined' : _typeof(checkSetEntries)) === 'object' && checkSetEntries.constructor ? checkSetEntries.constructor.name || '[Unknown Object]' : typeof checkSetEntries === 'undefined' ? 'undefined' : _typeof(checkSetEntries)));
  }

  var visitors = {
    TypeAlias: function TypeAlias(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      path.replaceWith(createTypeAliasChecks(path));
    },
    InterfaceDeclaration: function InterfaceDeclaration(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      path.replaceWith(createInterfaceChecks(path));
    },
    ExportNamedDeclaration: function ExportNamedDeclaration(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      var node = path.node;
      var scope = path.scope;

      if (node.declaration && node.declaration.type === 'TypeAlias') {
        path.replaceWith(t.exportNamedDeclaration(createTypeAliasChecks(path.get('declaration')), [], null));
      }
    },
    ImportDeclaration: function ImportDeclaration(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      if (path.node.importKind !== 'type') {
        return;
      }

      var _path$get$map$reduce = path.get('specifiers').map(function (specifier) {
        var local = specifier.get('local');
        var tmpId = path.scope.generateUidIdentifierBasedOnNode(local.node);
        var replacement = t.importSpecifier(tmpId, specifier.node.imported);
        var id = t.identifier(local.node.name);

        id.isTypeChecker = true;
        var declarator = t.variableDeclarator(id, tmpId);
        declarator.isTypeChecker = true;
        return [declarator, replacement];
      }).reduce(function (_ref60, _ref61) {
        var _ref63 = _slicedToArray(_ref60, 2);

        var declarators = _ref63[0];
        var specifiers = _ref63[1];

        var _ref62 = _slicedToArray(_ref61, 2);

        var declarator = _ref62[0];
        var specifier = _ref62[1];

        declarators.push(declarator);
        specifiers.push(specifier);
        return [declarators, specifiers];
      }, [[], []]);

      var _path$get$map$reduce2 = _slicedToArray(_path$get$map$reduce, 2);

      var declarators = _path$get$map$reduce2[0];
      var specifiers = _path$get$map$reduce2[1];

      var declaration = t.variableDeclaration('var', declarators);
      declaration.isTypeChecker = true;

      path.replaceWithMultiple([t.importDeclaration(specifiers, path.node.source), declaration]);
    },

    Function: {
      enter: function enter(path) {
        var _node$body$body;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        var node = path.node;
        var scope = path.scope;

        var paramChecks = collectParamChecks(path);
        if (node.type === "ArrowFunctionExpression" && node.expression) {
          node.expression = false;
          node.body = t.blockStatement([t.returnStatement(node.body)]);
        }
        (_node$body$body = node.body.body).unshift.apply(_node$body$body, _toConsumableArray(paramChecks));
        node.savedTypeAnnotation = node.returnType;
        node.returnCount = 0;
      },
      exit: function exit(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        var node = path.node;
        var scope = path.scope;

        var isVoid = node.savedTypeAnnotation ? maybeNullableAnnotation(node.savedTypeAnnotation) : null;
        if (!node.returnCount && isVoid === false) {
          throw path.buildCodeFrameError('Function ' + (node.id ? '"' + node.id.name + '" ' : '') + 'did not return a value, expected ' + humanReadableType(node.savedTypeAnnotation, scope));
        }
      }
    },

    ReturnStatement: function ReturnStatement(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      var node = path.node;
      var parent = path.parent;
      var scope = path.scope;

      var fn = path.getFunctionParent();
      if (!fn) {
        return;
      }
      fn.node.returnCount++;
      if (node.isTypeChecked) {
        return;
      }
      var returnType = fn.node.returnType;

      if (!returnType) {
        return;
      }
      if (!node.argument) {
        if (maybeNullableAnnotation(returnType) === false) {
          throw path.buildCodeFrameError('Function ' + (fn.node.id ? '"' + fn.node.id.name + '" ' : '') + 'did not return a value, expected ' + humanReadableType(returnType, path.scope));
        }
        return;
      }
      var id = undefined;
      if (node.argument.type === 'Identifier') {
        id = node.argument;
      } else {
        id = scope.generateUidIdentifierBasedOnNode(node.argument);
      }
      var ok = staticCheckAnnotation(path.get("argument"), returnType);
      if (ok === true) {
        return;
      } else if (ok === false) {
        throw path.buildCodeFrameError('Invalid return type, expected ' + humanReadableType(returnType, scope));
      }
      var check = checkAnnotation(id, returnType, scope);
      if (!check) {
        return;
      }
      if (parent.type !== 'BlockStatement' && parent.type !== 'Program') {
        var block = [];
        if (node.argument.type !== 'Identifier') {
          scope.push({ id: id });
          block.push(t.expressionStatement(t.assignmentExpression('=', id, node.argument)));
        }
        var ret = t.returnStatement(id);
        ret.isTypeChecked = true;
        block.push(thrower({
          check: check,
          ret: ret,
          message: returnTypeErrorMessage(path, fn.node, id)
        }));
        path.replaceWith(t.blockStatement(block));
      } else {
        if (node.argument.type !== 'Identifier') {
          scope.push({ id: id });
          path.insertBefore(t.expressionStatement(t.assignmentExpression('=', id, node.argument)));
        }
        var ret = t.returnStatement(id);
        ret.isTypeChecked = true;
        path.replaceWith(thrower({
          check: check,
          ret: ret,
          message: returnTypeErrorMessage(path, fn.node, id)
        }));
      }
    },
    VariableDeclaration: function VariableDeclaration(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      var node = path.node;
      var scope = path.scope;

      var collected = [];
      var declarations = path.get("declarations");
      for (var i = 0; i < node.declarations.length; i++) {
        var declaration = node.declarations[i];
        var _id = declaration.id;
        var init = declaration.init;

        if (!_id.typeAnnotation || _id.hasBeenTypeChecked) {
          continue;
        }
        _id.savedTypeAnnotation = _id.typeAnnotation;
        _id.hasBeenTypeChecked = true;
        var ok = staticCheckAnnotation(declarations[i], _id.typeAnnotation);
        if (ok === true) {
          continue;
        } else if (ok === false) {
          throw path.buildCodeFrameError('Invalid assignment value, expected ' + humanReadableType(_id.typeAnnotation, scope));
        }
        var check = checkAnnotation(_id, _id.typeAnnotation, scope);
        if (check) {
          collected.push(guard({
            check: check,
            message: varTypeErrorMessage(_id, scope)
          }));
        }
      }
      if (collected.length > 0) {
        var check = collected.reduce(function (check, branch) {
          branch.alternate = check;
          return branch;
        });
        if (path.parent.type === 'Program' || path.parent.type === 'BlockStatement') {
          path.insertAfter(check);
        } else if (path.parent.type === 'ExportNamedDeclaration' || path.parent.type === 'ExportDefaultDeclaration' || path.parent.type === 'ExportAllDeclaration' || path.parentPath.isForXStatement()) {
          path.parentPath.insertAfter(check);
        } else {
          path.replaceWith(t.blockStatement([node, check]));
        }
      }
    },
    AssignmentExpression: function AssignmentExpression(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      var node = path.node;
      var scope = path.scope;

      if (node.hasBeenTypeChecked || node.left.hasBeenTypeChecked || !t.isIdentifier(node.left)) {
        return;
      }
      var binding = scope.getBinding(node.left.name);
      if (!binding) {
        return;
      } else if (binding.path.type !== 'VariableDeclarator') {
        return;
      }
      var annotation = path.get('left').getTypeAnnotation();
      if (annotation.type === 'AnyTypeAnnotation') {
        var item = binding.path.get('id');
        annotation = item.node.savedTypeAnnotation || item.getTypeAnnotation();
      }

      node.hasBeenTypeChecked = true;
      node.left.hasBeenTypeChecked = true;
      if (annotation.type === 'AnyTypeAnnotation') {
        annotation = getAnnotation(path.get('right'));

        if (!TypeAnnotation(annotation)) {
          throw new TypeError('Value of variable "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
        }

        if (allowsAny(annotation)) {
          return;
        }
      }
      var id = node.left;
      var right = path.get('right');
      var ok = staticCheckAnnotation(right, annotation);
      if (ok === true) {
        return;
      } else if (ok === false) {
        throw path.buildCodeFrameError('Invalid assignment value, expected ' + humanReadableType(annotation, scope));
      }
      var check = checkAnnotation(id, annotation, scope);
      if (!id.typeAnnotation) {
        id.typeAnnotation = annotation;
      }
      id.hasBeenTypeChecked = true;
      if (check) {
        path.getStatementParent().insertAfter(guard({
          check: check,
          message: varTypeErrorMessage(id, scope)
        }));
      }
    },
    TypeCastExpression: function TypeCastExpression(path) {
      if (!NodePath(path)) {
        throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
      }

      var node = path.node;

      var target = undefined;
      switch (node.expression.type) {
        case 'Identifier':
          target = node.expression;
          break;
        case 'AssignmentExpression':
          target = node.expression.left;
          break;
        default:
          // unsupported.
          return;
      }
      var id = path.scope.getBindingIdentifier(target.name);
      if (!id) {
        return;
      }
      id.savedTypeAnnotation = path.getTypeAnnotation();
    }
  };

  return {
    visitor: {
      Program: function Program(path) {
        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        return path.traverse(visitors);
      }
    }
  };

  function createChecks() {
    return {
      number: expression('typeof input === \'number\''),
      boolean: expression('typeof input === \'boolean\''),
      function: expression('typeof input === \'function\''),
      string: expression('typeof input === \'string\''),
      symbol: expression('typeof input === \'symbol\''),
      undefined: expression('input === undefined'),
      null: expression('input === null'),
      void: expression('input == null'),
      instanceof: expression('input instanceof type'),
      type: expression('type(input)'),
      mixed: function mixed() {
        return null;
      },
      any: function any() {
        return null;
      },
      union: checkUnion,
      intersection: checkIntersection,
      array: checkArray,
      map: checkMap,
      set: checkSet,
      tuple: checkTuple,
      object: checkObject,
      nullable: checkNullable,
      typeof: checkTypeof
    };
  }

  function createStaticChecks() {
    return {
      string: function string(path) {
        var _maybeStringAnnotatio;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        _maybeStringAnnotatio = maybeStringAnnotation(getAnnotation(path));

        if (!(_maybeStringAnnotatio == null || typeof _maybeStringAnnotatio === 'boolean')) {
          throw new TypeError('Value of variable "_maybeStringAnnotatio" violates contract, expected ?bool got ' + (_maybeStringAnnotatio === null ? 'null' : (typeof _maybeStringAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio)) === 'object' && _maybeStringAnnotatio.constructor ? _maybeStringAnnotatio.constructor.name || '[Unknown Object]' : typeof _maybeStringAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio)));
        }

        if (_maybeStringAnnotatio == null || typeof _maybeStringAnnotatio === 'boolean') {
          return _maybeStringAnnotatio;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_maybeStringAnnotatio === null ? 'null' : (typeof _maybeStringAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio)) === 'object' && _maybeStringAnnotatio.constructor ? _maybeStringAnnotatio.constructor.name || '[Unknown Object]' : typeof _maybeStringAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio)));
        }
      },
      symbol: function symbol(path) {
        var _maybeSymbolAnnotatio;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        _maybeSymbolAnnotatio = maybeSymbolAnnotation(getAnnotation(path));

        if (!(_maybeSymbolAnnotatio == null || typeof _maybeSymbolAnnotatio === 'boolean')) {
          throw new TypeError('Value of variable "_maybeSymbolAnnotatio" violates contract, expected ?bool got ' + (_maybeSymbolAnnotatio === null ? 'null' : (typeof _maybeSymbolAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio)) === 'object' && _maybeSymbolAnnotatio.constructor ? _maybeSymbolAnnotatio.constructor.name || '[Unknown Object]' : typeof _maybeSymbolAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio)));
        }

        if (_maybeSymbolAnnotatio == null || typeof _maybeSymbolAnnotatio === 'boolean') {
          return _maybeSymbolAnnotatio;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_maybeSymbolAnnotatio === null ? 'null' : (typeof _maybeSymbolAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio)) === 'object' && _maybeSymbolAnnotatio.constructor ? _maybeSymbolAnnotatio.constructor.name || '[Unknown Object]' : typeof _maybeSymbolAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio)));
        }
      },
      number: function number(path) {
        var _maybeNumberAnnotatio;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        _maybeNumberAnnotatio = maybeNumberAnnotation(getAnnotation(path));

        if (!(_maybeNumberAnnotatio == null || typeof _maybeNumberAnnotatio === 'boolean')) {
          throw new TypeError('Value of variable "_maybeNumberAnnotatio" violates contract, expected ?bool got ' + (_maybeNumberAnnotatio === null ? 'null' : (typeof _maybeNumberAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio)) === 'object' && _maybeNumberAnnotatio.constructor ? _maybeNumberAnnotatio.constructor.name || '[Unknown Object]' : typeof _maybeNumberAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio)));
        }

        if (_maybeNumberAnnotatio == null || typeof _maybeNumberAnnotatio === 'boolean') {
          return _maybeNumberAnnotatio;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_maybeNumberAnnotatio === null ? 'null' : (typeof _maybeNumberAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio)) === 'object' && _maybeNumberAnnotatio.constructor ? _maybeNumberAnnotatio.constructor.name || '[Unknown Object]' : typeof _maybeNumberAnnotatio === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio)));
        }
      },
      boolean: function boolean(path) {
        var _maybeBooleanAnnotati;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        _maybeBooleanAnnotati = maybeBooleanAnnotation(getAnnotation(path));

        if (!(_maybeBooleanAnnotati == null || typeof _maybeBooleanAnnotati === 'boolean')) {
          throw new TypeError('Value of variable "_maybeBooleanAnnotati" violates contract, expected ?bool got ' + (_maybeBooleanAnnotati === null ? 'null' : (typeof _maybeBooleanAnnotati === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati)) === 'object' && _maybeBooleanAnnotati.constructor ? _maybeBooleanAnnotati.constructor.name || '[Unknown Object]' : typeof _maybeBooleanAnnotati === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati)));
        }

        if (_maybeBooleanAnnotati == null || typeof _maybeBooleanAnnotati === 'boolean') {
          return _maybeBooleanAnnotati;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_maybeBooleanAnnotati === null ? 'null' : (typeof _maybeBooleanAnnotati === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati)) === 'object' && _maybeBooleanAnnotati.constructor ? _maybeBooleanAnnotati.constructor.name || '[Unknown Object]' : typeof _maybeBooleanAnnotati === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati)));
        }
      },
      function: function _function(path) {
        var _maybeFunctionAnnotat;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        _maybeFunctionAnnotat = maybeFunctionAnnotation(getAnnotation(path));

        if (!(_maybeFunctionAnnotat == null || typeof _maybeFunctionAnnotat === 'boolean')) {
          throw new TypeError('Value of variable "_maybeFunctionAnnotat" violates contract, expected ?bool got ' + (_maybeFunctionAnnotat === null ? 'null' : (typeof _maybeFunctionAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat)) === 'object' && _maybeFunctionAnnotat.constructor ? _maybeFunctionAnnotat.constructor.name || '[Unknown Object]' : typeof _maybeFunctionAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat)));
        }

        if (_maybeFunctionAnnotat == null || typeof _maybeFunctionAnnotat === 'boolean') {
          return _maybeFunctionAnnotat;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_maybeFunctionAnnotat === null ? 'null' : (typeof _maybeFunctionAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat)) === 'object' && _maybeFunctionAnnotat.constructor ? _maybeFunctionAnnotat.constructor.name || '[Unknown Object]' : typeof _maybeFunctionAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat)));
        }
      },
      any: function any(path) {
        var _ref;

        if (!NodePath(path)) {
          throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
        }

        _ref = null;

        if (!(_ref == null)) {
          throw new TypeError('Value of variable "_ref" violates contract, expected void got ' + (_ref === null ? 'null' : (typeof _ref === 'undefined' ? 'undefined' : _typeof(_ref)) === 'object' && _ref.constructor ? _ref.constructor.name || '[Unknown Object]' : typeof _ref === 'undefined' ? 'undefined' : _typeof(_ref)));
        }

        if (_ref == null || typeof _ref === 'boolean') {
          return _ref;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_ref === null ? 'null' : (typeof _ref === 'undefined' ? 'undefined' : _typeof(_ref)) === 'object' && _ref.constructor ? _ref.constructor.name || '[Unknown Object]' : typeof _ref === 'undefined' ? 'undefined' : _typeof(_ref)));
        }
      },
      instanceof: function _instanceof(_ref64) {
        var _maybeInstanceOfAnnot;

        var path = _ref64.path;
        var type = _ref64.type;
        var node = path.node;
        var scope = path.scope;

        if (type.name === 'Object' && node.type === 'ObjectExpression' && !scope.hasBinding('Object')) {
          return true;
        } else if (type.name === 'Map' && !scope.hasBinding('Map')) {
          var _ref2;

          _ref2 = null;

          if (!(_ref2 == null)) {
            throw new TypeError('Value of variable "_ref2" violates contract, expected void got ' + (_ref2 === null ? 'null' : (typeof _ref2 === 'undefined' ? 'undefined' : _typeof(_ref2)) === 'object' && _ref2.constructor ? _ref2.constructor.name || '[Unknown Object]' : typeof _ref2 === 'undefined' ? 'undefined' : _typeof(_ref2)));
          }

          if (_ref2 == null || typeof _ref2 === 'boolean') {
            return _ref2;
          } else {
            throw new TypeError('Function return value violates contract, expected ?bool got ' + (_ref2 === null ? 'null' : (typeof _ref2 === 'undefined' ? 'undefined' : _typeof(_ref2)) === 'object' && _ref2.constructor ? _ref2.constructor.name || '[Unknown Object]' : typeof _ref2 === 'undefined' ? 'undefined' : _typeof(_ref2)));
          }
        } else if (type.name === 'Set' && !scope.hasBinding('Set')) {
          var _ref3;

          _ref3 = null;

          if (!(_ref3 == null)) {
            throw new TypeError('Value of variable "_ref3" violates contract, expected void got ' + (_ref3 === null ? 'null' : (typeof _ref3 === 'undefined' ? 'undefined' : _typeof(_ref3)) === 'object' && _ref3.constructor ? _ref3.constructor.name || '[Unknown Object]' : typeof _ref3 === 'undefined' ? 'undefined' : _typeof(_ref3)));
          }

          if (_ref3 == null || typeof _ref3 === 'boolean') {
            return _ref3;
          } else {
            throw new TypeError('Function return value violates contract, expected ?bool got ' + (_ref3 === null ? 'null' : (typeof _ref3 === 'undefined' ? 'undefined' : _typeof(_ref3)) === 'object' && _ref3.constructor ? _ref3.constructor.name || '[Unknown Object]' : typeof _ref3 === 'undefined' ? 'undefined' : _typeof(_ref3)));
          }
        }
        _maybeInstanceOfAnnot = maybeInstanceOfAnnotation(getAnnotation(path), type);

        if (!(_maybeInstanceOfAnnot == null || typeof _maybeInstanceOfAnnot === 'boolean')) {
          throw new TypeError('Value of variable "_maybeInstanceOfAnnot" violates contract, expected ?bool got ' + (_maybeInstanceOfAnnot === null ? 'null' : (typeof _maybeInstanceOfAnnot === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot)) === 'object' && _maybeInstanceOfAnnot.constructor ? _maybeInstanceOfAnnot.constructor.name || '[Unknown Object]' : typeof _maybeInstanceOfAnnot === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot)));
        }

        if (_maybeInstanceOfAnnot == null || typeof _maybeInstanceOfAnnot === 'boolean') {
          return _maybeInstanceOfAnnot;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_maybeInstanceOfAnnot === null ? 'null' : (typeof _maybeInstanceOfAnnot === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot)) === 'object' && _maybeInstanceOfAnnot.constructor ? _maybeInstanceOfAnnot.constructor.name || '[Unknown Object]' : typeof _maybeInstanceOfAnnot === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot)));
        }
      },
      type: (function (_type) {
        function type(_x) {
          return _type.apply(this, arguments);
        }

        type.toString = function () {
          return _type.toString();
        };

        return type;
      })(function (_ref65) {
        var _ref4;

        var path = _ref65.path;
        var type = _ref65.type;
        _ref4 = null;

        if (!(_ref4 == null)) {
          throw new TypeError('Value of variable "_ref4" violates contract, expected void got ' + (_ref4 === null ? 'null' : (typeof _ref4 === 'undefined' ? 'undefined' : _typeof(_ref4)) === 'object' && _ref4.constructor ? _ref4.constructor.name || '[Unknown Object]' : typeof _ref4 === 'undefined' ? 'undefined' : _typeof(_ref4)));
        }

        if (_ref4 == null || typeof _ref4 === 'boolean') {
          return _ref4;
        } else {
          throw new TypeError('Function return value violates contract, expected ?bool got ' + (_ref4 === null ? 'null' : (typeof _ref4 === 'undefined' ? 'undefined' : _typeof(_ref4)) === 'object' && _ref4.constructor ? _ref4.constructor.name || '[Unknown Object]' : typeof _ref4 === 'undefined' ? 'undefined' : _typeof(_ref4)));
        }
      }),
      array: function array(_ref66) {
        var path = _ref66.path;
        var types = _ref66.types;
        var node = path.node;

        if (node.type === 'ArrayExpression') {
          if (types.length === 0) {
            return true;
          } else if (node.elements.length < types.length) {
            return false;
          } else {
            var _ref5;

            _ref5 = null;

            if (!(_ref5 == null)) {
              throw new TypeError('Value of variable "_ref5" violates contract, expected void got ' + (_ref5 === null ? 'null' : (typeof _ref5 === 'undefined' ? 'undefined' : _typeof(_ref5)) === 'object' && _ref5.constructor ? _ref5.constructor.name || '[Unknown Object]' : typeof _ref5 === 'undefined' ? 'undefined' : _typeof(_ref5)));
            }

            if (_ref5 == null || typeof _ref5 === 'boolean') {
              return _ref5;
            } else {
              throw new TypeError('Function return value violates contract, expected ?bool got ' + (_ref5 === null ? 'null' : (typeof _ref5 === 'undefined' ? 'undefined' : _typeof(_ref5)) === 'object' && _ref5.constructor ? _ref5.constructor.name || '[Unknown Object]' : typeof _ref5 === 'undefined' ? 'undefined' : _typeof(_ref5)));
            }
          }
        } else if (maybeArrayAnnotation(getAnnotation(path)) === false) {
          return false;
        } else {
          var _ref6;

          _ref6 = null;

          if (!(_ref6 == null)) {
            throw new TypeError('Value of variable "_ref6" violates contract, expected void got ' + (_ref6 === null ? 'null' : (typeof _ref6 === 'undefined' ? 'undefined' : _typeof(_ref6)) === 'object' && _ref6.constructor ? _ref6.constructor.name || '[Unknown Object]' : typeof _ref6 === 'undefined' ? 'undefined' : _typeof(_ref6)));
          }

          if (_ref6 == null || typeof _ref6 === 'boolean') {
            return _ref6;
          } else {
            throw new TypeError('Function return value violates contract, expected ?bool got ' + (_ref6 === null ? 'null' : (typeof _ref6 === 'undefined' ? 'undefined' : _typeof(_ref6)) === 'object' && _ref6.constructor ? _ref6.constructor.name || '[Unknown Object]' : typeof _ref6 === 'undefined' ? 'undefined' : _typeof(_ref6)));
          }
        }
      },
      tuple: function tuple(_ref67) {
        var path = _ref67.path;
        var types = _ref67.types;
        var node = path.node;

        var annotation = getAnnotation(path);
        if (annotation.type === 'TypeAnnotation' || annotation.type === 'NullableTypeAnnotation') {
          annotation = annotation.typeAnnotation;
        }
        return maybeTupleAnnotation(annotation);
      },

      union: checkStaticUnion,
      intersection: checkStaticIntersection,
      object: checkStaticObject,
      nullable: checkStaticNullable
    };
  }

  function compareAnnotations(a, b) {
    var _maybeStringAnnotatio2, _maybeNumberAnnotatio2, _maybeBooleanAnnotati2, _maybeFunctionAnnotat2, _ref7, _ref8, _compareObjectAnnotat, _compareArrayAnnotati, _compareGenericAnnota, _compareTupleAnnotati, _compareUnionAnnotati, _compareIntersectionA, _compareNullableAnnot, _ref9;

    if (!TypeAnnotation(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected TypeAnnotation got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!TypeAnnotation(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected TypeAnnotation got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (a.type === 'TypeAnnotation') {
      a = a.typeAnnotation;
    }
    if (b.type === 'TypeAnnotation') {
      b = b.typeAnnotation;
    }
    switch (a.type) {
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
        {
          _maybeStringAnnotatio2 = maybeStringAnnotation(b);

          if (!(_maybeStringAnnotatio2 == null || typeof _maybeStringAnnotatio2 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeStringAnnotatio2" violates contract, expected ?bool got ' + (_maybeStringAnnotatio2 === null ? 'null' : (typeof _maybeStringAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio2)) === 'object' && _maybeStringAnnotatio2.constructor ? _maybeStringAnnotatio2.constructor.name || '[Unknown Object]' : typeof _maybeStringAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio2)));
          }

          if (_maybeStringAnnotatio2 == null || typeof _maybeStringAnnotatio2 === 'boolean') {
            return _maybeStringAnnotatio2;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_maybeStringAnnotatio2 === null ? 'null' : (typeof _maybeStringAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio2)) === 'object' && _maybeStringAnnotatio2.constructor ? _maybeStringAnnotatio2.constructor.name || '[Unknown Object]' : typeof _maybeStringAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio2)));
          }
        }

      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
        {
          _maybeNumberAnnotatio2 = maybeNumberAnnotation(b);

          if (!(_maybeNumberAnnotatio2 == null || typeof _maybeNumberAnnotatio2 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeNumberAnnotatio2" violates contract, expected ?bool got ' + (_maybeNumberAnnotatio2 === null ? 'null' : (typeof _maybeNumberAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio2)) === 'object' && _maybeNumberAnnotatio2.constructor ? _maybeNumberAnnotatio2.constructor.name || '[Unknown Object]' : typeof _maybeNumberAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio2)));
          }

          if (_maybeNumberAnnotatio2 == null || typeof _maybeNumberAnnotatio2 === 'boolean') {
            return _maybeNumberAnnotatio2;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_maybeNumberAnnotatio2 === null ? 'null' : (typeof _maybeNumberAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio2)) === 'object' && _maybeNumberAnnotatio2.constructor ? _maybeNumberAnnotatio2.constructor.name || '[Unknown Object]' : typeof _maybeNumberAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio2)));
          }
        }

      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
        {
          _maybeBooleanAnnotati2 = maybeBooleanAnnotation(b);

          if (!(_maybeBooleanAnnotati2 == null || typeof _maybeBooleanAnnotati2 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeBooleanAnnotati2" violates contract, expected ?bool got ' + (_maybeBooleanAnnotati2 === null ? 'null' : (typeof _maybeBooleanAnnotati2 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati2)) === 'object' && _maybeBooleanAnnotati2.constructor ? _maybeBooleanAnnotati2.constructor.name || '[Unknown Object]' : typeof _maybeBooleanAnnotati2 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati2)));
          }

          if (_maybeBooleanAnnotati2 == null || typeof _maybeBooleanAnnotati2 === 'boolean') {
            return _maybeBooleanAnnotati2;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_maybeBooleanAnnotati2 === null ? 'null' : (typeof _maybeBooleanAnnotati2 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati2)) === 'object' && _maybeBooleanAnnotati2.constructor ? _maybeBooleanAnnotati2.constructor.name || '[Unknown Object]' : typeof _maybeBooleanAnnotati2 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati2)));
          }
        }

      case 'FunctionTypeAnnotation':
        {
          _maybeFunctionAnnotat2 = maybeFunctionAnnotation(b);

          if (!(_maybeFunctionAnnotat2 == null || typeof _maybeFunctionAnnotat2 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeFunctionAnnotat2" violates contract, expected ?bool got ' + (_maybeFunctionAnnotat2 === null ? 'null' : (typeof _maybeFunctionAnnotat2 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat2)) === 'object' && _maybeFunctionAnnotat2.constructor ? _maybeFunctionAnnotat2.constructor.name || '[Unknown Object]' : typeof _maybeFunctionAnnotat2 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat2)));
          }

          if (_maybeFunctionAnnotat2 == null || typeof _maybeFunctionAnnotat2 === 'boolean') {
            return _maybeFunctionAnnotat2;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_maybeFunctionAnnotat2 === null ? 'null' : (typeof _maybeFunctionAnnotat2 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat2)) === 'object' && _maybeFunctionAnnotat2.constructor ? _maybeFunctionAnnotat2.constructor.name || '[Unknown Object]' : typeof _maybeFunctionAnnotat2 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat2)));
          }
        }

      case 'AnyTypeAnnotation':
        {
          _ref7 = null;

          if (!(_ref7 == null)) {
            throw new TypeError('Value of variable "_ref7" violates contract, expected void got ' + (_ref7 === null ? 'null' : (typeof _ref7 === 'undefined' ? 'undefined' : _typeof(_ref7)) === 'object' && _ref7.constructor ? _ref7.constructor.name || '[Unknown Object]' : typeof _ref7 === 'undefined' ? 'undefined' : _typeof(_ref7)));
          }

          if (_ref7 == null || typeof _ref7 === 'boolean') {
            return _ref7;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_ref7 === null ? 'null' : (typeof _ref7 === 'undefined' ? 'undefined' : _typeof(_ref7)) === 'object' && _ref7.constructor ? _ref7.constructor.name || '[Unknown Object]' : typeof _ref7 === 'undefined' ? 'undefined' : _typeof(_ref7)));
          }
        }

      case 'MixedTypeAnnotation':
        {
          _ref8 = null;

          if (!(_ref8 == null)) {
            throw new TypeError('Value of variable "_ref8" violates contract, expected void got ' + (_ref8 === null ? 'null' : (typeof _ref8 === 'undefined' ? 'undefined' : _typeof(_ref8)) === 'object' && _ref8.constructor ? _ref8.constructor.name || '[Unknown Object]' : typeof _ref8 === 'undefined' ? 'undefined' : _typeof(_ref8)));
          }

          if (_ref8 == null || typeof _ref8 === 'boolean') {
            return _ref8;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_ref8 === null ? 'null' : (typeof _ref8 === 'undefined' ? 'undefined' : _typeof(_ref8)) === 'object' && _ref8.constructor ? _ref8.constructor.name || '[Unknown Object]' : typeof _ref8 === 'undefined' ? 'undefined' : _typeof(_ref8)));
          }
        }

      case 'ObjectTypeAnnotation':
        {
          _compareObjectAnnotat = compareObjectAnnotation(a, b);

          if (!(_compareObjectAnnotat == null || typeof _compareObjectAnnotat === 'boolean')) {
            throw new TypeError('Value of variable "_compareObjectAnnotat" violates contract, expected ?bool got ' + (_compareObjectAnnotat === null ? 'null' : (typeof _compareObjectAnnotat === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat)) === 'object' && _compareObjectAnnotat.constructor ? _compareObjectAnnotat.constructor.name || '[Unknown Object]' : typeof _compareObjectAnnotat === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat)));
          }

          if (_compareObjectAnnotat == null || typeof _compareObjectAnnotat === 'boolean') {
            return _compareObjectAnnotat;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_compareObjectAnnotat === null ? 'null' : (typeof _compareObjectAnnotat === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat)) === 'object' && _compareObjectAnnotat.constructor ? _compareObjectAnnotat.constructor.name || '[Unknown Object]' : typeof _compareObjectAnnotat === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat)));
          }
        }

      case 'ArrayTypeAnnotation':
        {
          _compareArrayAnnotati = compareArrayAnnotation(a, b);

          if (!(_compareArrayAnnotati == null || typeof _compareArrayAnnotati === 'boolean')) {
            throw new TypeError('Value of variable "_compareArrayAnnotati" violates contract, expected ?bool got ' + (_compareArrayAnnotati === null ? 'null' : (typeof _compareArrayAnnotati === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati)) === 'object' && _compareArrayAnnotati.constructor ? _compareArrayAnnotati.constructor.name || '[Unknown Object]' : typeof _compareArrayAnnotati === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati)));
          }

          if (_compareArrayAnnotati == null || typeof _compareArrayAnnotati === 'boolean') {
            return _compareArrayAnnotati;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_compareArrayAnnotati === null ? 'null' : (typeof _compareArrayAnnotati === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati)) === 'object' && _compareArrayAnnotati.constructor ? _compareArrayAnnotati.constructor.name || '[Unknown Object]' : typeof _compareArrayAnnotati === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati)));
          }
        }

      case 'GenericTypeAnnotation':
        {
          _compareGenericAnnota = compareGenericAnnotation(a, b);

          if (!(_compareGenericAnnota == null || typeof _compareGenericAnnota === 'boolean')) {
            throw new TypeError('Value of variable "_compareGenericAnnota" violates contract, expected ?bool got ' + (_compareGenericAnnota === null ? 'null' : (typeof _compareGenericAnnota === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota)) === 'object' && _compareGenericAnnota.constructor ? _compareGenericAnnota.constructor.name || '[Unknown Object]' : typeof _compareGenericAnnota === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota)));
          }

          if (_compareGenericAnnota == null || typeof _compareGenericAnnota === 'boolean') {
            return _compareGenericAnnota;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_compareGenericAnnota === null ? 'null' : (typeof _compareGenericAnnota === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota)) === 'object' && _compareGenericAnnota.constructor ? _compareGenericAnnota.constructor.name || '[Unknown Object]' : typeof _compareGenericAnnota === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota)));
          }
        }

      case 'TupleTypeAnnotation':
        {
          _compareTupleAnnotati = compareTupleAnnotation(a, b);

          if (!(_compareTupleAnnotati == null || typeof _compareTupleAnnotati === 'boolean')) {
            throw new TypeError('Value of variable "_compareTupleAnnotati" violates contract, expected ?bool got ' + (_compareTupleAnnotati === null ? 'null' : (typeof _compareTupleAnnotati === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati)) === 'object' && _compareTupleAnnotati.constructor ? _compareTupleAnnotati.constructor.name || '[Unknown Object]' : typeof _compareTupleAnnotati === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati)));
          }

          if (_compareTupleAnnotati == null || typeof _compareTupleAnnotati === 'boolean') {
            return _compareTupleAnnotati;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_compareTupleAnnotati === null ? 'null' : (typeof _compareTupleAnnotati === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati)) === 'object' && _compareTupleAnnotati.constructor ? _compareTupleAnnotati.constructor.name || '[Unknown Object]' : typeof _compareTupleAnnotati === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati)));
          }
        }

      case 'UnionTypeAnnotation':
        {
          _compareUnionAnnotati = compareUnionAnnotation(a, b);

          if (!(_compareUnionAnnotati == null || typeof _compareUnionAnnotati === 'boolean')) {
            throw new TypeError('Value of variable "_compareUnionAnnotati" violates contract, expected ?bool got ' + (_compareUnionAnnotati === null ? 'null' : (typeof _compareUnionAnnotati === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati)) === 'object' && _compareUnionAnnotati.constructor ? _compareUnionAnnotati.constructor.name || '[Unknown Object]' : typeof _compareUnionAnnotati === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati)));
          }

          if (_compareUnionAnnotati == null || typeof _compareUnionAnnotati === 'boolean') {
            return _compareUnionAnnotati;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_compareUnionAnnotati === null ? 'null' : (typeof _compareUnionAnnotati === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati)) === 'object' && _compareUnionAnnotati.constructor ? _compareUnionAnnotati.constructor.name || '[Unknown Object]' : typeof _compareUnionAnnotati === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati)));
          }
        }

      case 'IntersectionTypeAnnotation':
        {
          _compareIntersectionA = compareIntersectionAnnotation(a, b);

          if (_compareIntersectionA == null || typeof _compareIntersectionA === 'boolean') {
            return _compareIntersectionA;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_compareIntersectionA === null ? 'null' : (typeof _compareIntersectionA === 'undefined' ? 'undefined' : _typeof(_compareIntersectionA)) === 'object' && _compareIntersectionA.constructor ? _compareIntersectionA.constructor.name || '[Unknown Object]' : typeof _compareIntersectionA === 'undefined' ? 'undefined' : _typeof(_compareIntersectionA)));
          }
        }

      case 'NullableTypeAnnotation':
        {
          _compareNullableAnnot = compareNullableAnnotation(a, b);

          if (!(_compareNullableAnnot == null || typeof _compareNullableAnnot === 'boolean')) {
            throw new TypeError('Value of variable "_compareNullableAnnot" violates contract, expected ?bool got ' + (_compareNullableAnnot === null ? 'null' : (typeof _compareNullableAnnot === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot)) === 'object' && _compareNullableAnnot.constructor ? _compareNullableAnnot.constructor.name || '[Unknown Object]' : typeof _compareNullableAnnot === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot)));
          }

          if (_compareNullableAnnot == null || typeof _compareNullableAnnot === 'boolean') {
            return _compareNullableAnnot;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_compareNullableAnnot === null ? 'null' : (typeof _compareNullableAnnot === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot)) === 'object' && _compareNullableAnnot.constructor ? _compareNullableAnnot.constructor.name || '[Unknown Object]' : typeof _compareNullableAnnot === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot)));
          }
        }

      default:
        {
          _ref9 = null;

          if (!(_ref9 == null)) {
            throw new TypeError('Value of variable "_ref9" violates contract, expected void got ' + (_ref9 === null ? 'null' : (typeof _ref9 === 'undefined' ? 'undefined' : _typeof(_ref9)) === 'object' && _ref9.constructor ? _ref9.constructor.name || '[Unknown Object]' : typeof _ref9 === 'undefined' ? 'undefined' : _typeof(_ref9)));
          }

          if (_ref9 == null || typeof _ref9 === 'boolean') {
            return _ref9;
          } else {
            throw new TypeError('Function "compareAnnotations" return value violates contract, expected ?bool got ' + (_ref9 === null ? 'null' : (typeof _ref9 === 'undefined' ? 'undefined' : _typeof(_ref9)) === 'object' && _ref9.constructor ? _ref9.constructor.name || '[Unknown Object]' : typeof _ref9 === 'undefined' ? 'undefined' : _typeof(_ref9)));
          }
        }

    }
  }

  function unionComparer(a, b, comparator) {
    if (!TypeAnnotation(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected TypeAnnotation got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!TypeAnnotation(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected TypeAnnotation got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (!(typeof comparator === 'function')) {
      throw new TypeError('Value of argument "comparator" violates contract, expected (a: TypeAnnotation, b: TypeAnnotation) => ?bool got ' + (comparator === null ? 'null' : (typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)) === 'object' && comparator.constructor ? comparator.constructor.name || '[Unknown Object]' : typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)));
    }

    var falseCount = 0;
    var trueCount = 0;
    if (!a.types) {
      var _ref10;

      _ref10 = null;

      if (!(_ref10 == null)) {
        throw new TypeError('Value of variable "_ref10" violates contract, expected void got ' + (_ref10 === null ? 'null' : (typeof _ref10 === 'undefined' ? 'undefined' : _typeof(_ref10)) === 'object' && _ref10.constructor ? _ref10.constructor.name || '[Unknown Object]' : typeof _ref10 === 'undefined' ? 'undefined' : _typeof(_ref10)));
      }

      if (_ref10 == null || typeof _ref10 === 'boolean') {
        return _ref10;
      } else {
        throw new TypeError('Function "unionComparer" return value violates contract, expected ?bool got ' + (_ref10 === null ? 'null' : (typeof _ref10 === 'undefined' ? 'undefined' : _typeof(_ref10)) === 'object' && _ref10.constructor ? _ref10.constructor.name || '[Unknown Object]' : typeof _ref10 === 'undefined' ? 'undefined' : _typeof(_ref10)));
      }
    }
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = a.types[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _type2 = _step.value;

        var result = comparator(_type2, b);
        if (result === true) {
          if (b.type !== 'UnionTypeAnnotation') {
            return true;
          }
          trueCount++;
        } else if (result === false) {
          if (b.type === 'UnionTypeAnnotation') {
            return false;
          }
          falseCount++;
        }
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    if (falseCount === a.types.length) {
      return false;
    } else if (trueCount === a.types.length) {
      return true;
    } else {
      var _ref11;

      _ref11 = null;

      if (!(_ref11 == null)) {
        throw new TypeError('Value of variable "_ref11" violates contract, expected void got ' + (_ref11 === null ? 'null' : (typeof _ref11 === 'undefined' ? 'undefined' : _typeof(_ref11)) === 'object' && _ref11.constructor ? _ref11.constructor.name || '[Unknown Object]' : typeof _ref11 === 'undefined' ? 'undefined' : _typeof(_ref11)));
      }

      if (_ref11 == null || typeof _ref11 === 'boolean') {
        return _ref11;
      } else {
        throw new TypeError('Function "unionComparer" return value violates contract, expected ?bool got ' + (_ref11 === null ? 'null' : (typeof _ref11 === 'undefined' ? 'undefined' : _typeof(_ref11)) === 'object' && _ref11.constructor ? _ref11.constructor.name || '[Unknown Object]' : typeof _ref11 === 'undefined' ? 'undefined' : _typeof(_ref11)));
      }
    }
  }

  function intersectionComparer(a, b, comparator) {
    if (!TypeAnnotation(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected TypeAnnotation got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!TypeAnnotation(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected TypeAnnotation got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (!(typeof comparator === 'function')) {
      throw new TypeError('Value of argument "comparator" violates contract, expected (a: TypeAnnotation, b: TypeAnnotation) => ?bool got ' + (comparator === null ? 'null' : (typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)) === 'object' && comparator.constructor ? comparator.constructor.name || '[Unknown Object]' : typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)));
    }

    var falseCount = 0;
    var trueCount = 0;
    if (!a.types) {
      var _ref12;

      _ref12 = null;

      if (!(_ref12 == null)) {
        throw new TypeError('Value of variable "_ref12" violates contract, expected void got ' + (_ref12 === null ? 'null' : (typeof _ref12 === 'undefined' ? 'undefined' : _typeof(_ref12)) === 'object' && _ref12.constructor ? _ref12.constructor.name || '[Unknown Object]' : typeof _ref12 === 'undefined' ? 'undefined' : _typeof(_ref12)));
      }

      if (_ref12 == null || typeof _ref12 === 'boolean') {
        return _ref12;
      } else {
        throw new TypeError('Function "intersectionComparer" return value violates contract, expected ?bool got ' + (_ref12 === null ? 'null' : (typeof _ref12 === 'undefined' ? 'undefined' : _typeof(_ref12)) === 'object' && _ref12.constructor ? _ref12.constructor.name || '[Unknown Object]' : typeof _ref12 === 'undefined' ? 'undefined' : _typeof(_ref12)));
      }
    }
    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = a.types[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var _type3 = _step2.value;

        var result = comparator(_type3, b);
        if (result === true) {
          trueCount++;
        } else if (result === false) {
          return false;
        }
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }

    if (trueCount === a.types.length) {
      return true;
    } else {
      var _ref13;

      _ref13 = null;

      if (!(_ref13 == null)) {
        throw new TypeError('Value of variable "_ref13" violates contract, expected void got ' + (_ref13 === null ? 'null' : (typeof _ref13 === 'undefined' ? 'undefined' : _typeof(_ref13)) === 'object' && _ref13.constructor ? _ref13.constructor.name || '[Unknown Object]' : typeof _ref13 === 'undefined' ? 'undefined' : _typeof(_ref13)));
      }

      if (_ref13 == null || typeof _ref13 === 'boolean') {
        return _ref13;
      } else {
        throw new TypeError('Function "intersectionComparer" return value violates contract, expected ?bool got ' + (_ref13 === null ? 'null' : (typeof _ref13 === 'undefined' ? 'undefined' : _typeof(_ref13)) === 'object' && _ref13.constructor ? _ref13.constructor.name || '[Unknown Object]' : typeof _ref13 === 'undefined' ? 'undefined' : _typeof(_ref13)));
      }
    }
  }

  function compareObjectAnnotation(a, b) {
    var _compareObjectAnnotat2, _unionComparer, _intersectionComparer, _ref14;

    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _compareObjectAnnotat2 = compareObjectAnnotation(a, b.typeAnnotation);

          if (!(_compareObjectAnnotat2 == null || typeof _compareObjectAnnotat2 === 'boolean')) {
            throw new TypeError('Value of variable "_compareObjectAnnotat2" violates contract, expected ?bool got ' + (_compareObjectAnnotat2 === null ? 'null' : (typeof _compareObjectAnnotat2 === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat2)) === 'object' && _compareObjectAnnotat2.constructor ? _compareObjectAnnotat2.constructor.name || '[Unknown Object]' : typeof _compareObjectAnnotat2 === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat2)));
          }

          if (_compareObjectAnnotat2 == null || typeof _compareObjectAnnotat2 === 'boolean') {
            return _compareObjectAnnotat2;
          } else {
            throw new TypeError('Function "compareObjectAnnotation" return value violates contract, expected ?bool got ' + (_compareObjectAnnotat2 === null ? 'null' : (typeof _compareObjectAnnotat2 === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat2)) === 'object' && _compareObjectAnnotat2.constructor ? _compareObjectAnnotat2.constructor.name || '[Unknown Object]' : typeof _compareObjectAnnotat2 === 'undefined' ? 'undefined' : _typeof(_compareObjectAnnotat2)));
          }
        }

      case 'UnionTypeAnnotation':
        {
          _unionComparer = unionComparer(a, b, compareObjectAnnotation);

          if (!(_unionComparer == null || typeof _unionComparer === 'boolean')) {
            throw new TypeError('Value of variable "_unionComparer" violates contract, expected ?bool got ' + (_unionComparer === null ? 'null' : (typeof _unionComparer === 'undefined' ? 'undefined' : _typeof(_unionComparer)) === 'object' && _unionComparer.constructor ? _unionComparer.constructor.name || '[Unknown Object]' : typeof _unionComparer === 'undefined' ? 'undefined' : _typeof(_unionComparer)));
          }

          if (_unionComparer == null || typeof _unionComparer === 'boolean') {
            return _unionComparer;
          } else {
            throw new TypeError('Function "compareObjectAnnotation" return value violates contract, expected ?bool got ' + (_unionComparer === null ? 'null' : (typeof _unionComparer === 'undefined' ? 'undefined' : _typeof(_unionComparer)) === 'object' && _unionComparer.constructor ? _unionComparer.constructor.name || '[Unknown Object]' : typeof _unionComparer === 'undefined' ? 'undefined' : _typeof(_unionComparer)));
          }
        }

      case 'IntersectionTypeAnnotation':
        {
          _intersectionComparer = intersectionComparer(a, b, compareObjectAnnotation);

          if (!(_intersectionComparer == null || typeof _intersectionComparer === 'boolean')) {
            throw new TypeError('Value of variable "_intersectionComparer" violates contract, expected ?bool got ' + (_intersectionComparer === null ? 'null' : (typeof _intersectionComparer === 'undefined' ? 'undefined' : _typeof(_intersectionComparer)) === 'object' && _intersectionComparer.constructor ? _intersectionComparer.constructor.name || '[Unknown Object]' : typeof _intersectionComparer === 'undefined' ? 'undefined' : _typeof(_intersectionComparer)));
          }

          if (_intersectionComparer == null || typeof _intersectionComparer === 'boolean') {
            return _intersectionComparer;
          } else {
            throw new TypeError('Function "compareObjectAnnotation" return value violates contract, expected ?bool got ' + (_intersectionComparer === null ? 'null' : (typeof _intersectionComparer === 'undefined' ? 'undefined' : _typeof(_intersectionComparer)) === 'object' && _intersectionComparer.constructor ? _intersectionComparer.constructor.name || '[Unknown Object]' : typeof _intersectionComparer === 'undefined' ? 'undefined' : _typeof(_intersectionComparer)));
          }
        }

      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        {
          _ref14 = null;

          if (!(_ref14 == null)) {
            throw new TypeError('Value of variable "_ref14" violates contract, expected void got ' + (_ref14 === null ? 'null' : (typeof _ref14 === 'undefined' ? 'undefined' : _typeof(_ref14)) === 'object' && _ref14.constructor ? _ref14.constructor.name || '[Unknown Object]' : typeof _ref14 === 'undefined' ? 'undefined' : _typeof(_ref14)));
          }

          if (_ref14 == null || typeof _ref14 === 'boolean') {
            return _ref14;
          } else {
            throw new TypeError('Function "compareObjectAnnotation" return value violates contract, expected ?bool got ' + (_ref14 === null ? 'null' : (typeof _ref14 === 'undefined' ? 'undefined' : _typeof(_ref14)) === 'object' && _ref14.constructor ? _ref14.constructor.name || '[Unknown Object]' : typeof _ref14 === 'undefined' ? 'undefined' : _typeof(_ref14)));
          }
        }

    }
  }

  function compareArrayAnnotation(a, b) {
    var _compareArrayAnnotati2, _unionComparer2, _intersectionComparer2, _ref15;

    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _compareArrayAnnotati2 = compareArrayAnnotation(a, b.typeAnnotation);

          if (!(_compareArrayAnnotati2 == null || typeof _compareArrayAnnotati2 === 'boolean')) {
            throw new TypeError('Value of variable "_compareArrayAnnotati2" violates contract, expected ?bool got ' + (_compareArrayAnnotati2 === null ? 'null' : (typeof _compareArrayAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati2)) === 'object' && _compareArrayAnnotati2.constructor ? _compareArrayAnnotati2.constructor.name || '[Unknown Object]' : typeof _compareArrayAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati2)));
          }

          if (_compareArrayAnnotati2 == null || typeof _compareArrayAnnotati2 === 'boolean') {
            return _compareArrayAnnotati2;
          } else {
            throw new TypeError('Function "compareArrayAnnotation" return value violates contract, expected ?bool got ' + (_compareArrayAnnotati2 === null ? 'null' : (typeof _compareArrayAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati2)) === 'object' && _compareArrayAnnotati2.constructor ? _compareArrayAnnotati2.constructor.name || '[Unknown Object]' : typeof _compareArrayAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareArrayAnnotati2)));
          }
        }

      case 'UnionTypeAnnotation':
        {
          _unionComparer2 = unionComparer(a, b, compareArrayAnnotation);

          if (!(_unionComparer2 == null || typeof _unionComparer2 === 'boolean')) {
            throw new TypeError('Value of variable "_unionComparer2" violates contract, expected ?bool got ' + (_unionComparer2 === null ? 'null' : (typeof _unionComparer2 === 'undefined' ? 'undefined' : _typeof(_unionComparer2)) === 'object' && _unionComparer2.constructor ? _unionComparer2.constructor.name || '[Unknown Object]' : typeof _unionComparer2 === 'undefined' ? 'undefined' : _typeof(_unionComparer2)));
          }

          if (_unionComparer2 == null || typeof _unionComparer2 === 'boolean') {
            return _unionComparer2;
          } else {
            throw new TypeError('Function "compareArrayAnnotation" return value violates contract, expected ?bool got ' + (_unionComparer2 === null ? 'null' : (typeof _unionComparer2 === 'undefined' ? 'undefined' : _typeof(_unionComparer2)) === 'object' && _unionComparer2.constructor ? _unionComparer2.constructor.name || '[Unknown Object]' : typeof _unionComparer2 === 'undefined' ? 'undefined' : _typeof(_unionComparer2)));
          }
        }

      case 'IntersectionTypeAnnotation':
        {
          _intersectionComparer2 = intersectionComparer(a, b, compareArrayAnnotation);

          if (!(_intersectionComparer2 == null || typeof _intersectionComparer2 === 'boolean')) {
            throw new TypeError('Value of variable "_intersectionComparer2" violates contract, expected ?bool got ' + (_intersectionComparer2 === null ? 'null' : (typeof _intersectionComparer2 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer2)) === 'object' && _intersectionComparer2.constructor ? _intersectionComparer2.constructor.name || '[Unknown Object]' : typeof _intersectionComparer2 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer2)));
          }

          if (_intersectionComparer2 == null || typeof _intersectionComparer2 === 'boolean') {
            return _intersectionComparer2;
          } else {
            throw new TypeError('Function "compareArrayAnnotation" return value violates contract, expected ?bool got ' + (_intersectionComparer2 === null ? 'null' : (typeof _intersectionComparer2 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer2)) === 'object' && _intersectionComparer2.constructor ? _intersectionComparer2.constructor.name || '[Unknown Object]' : typeof _intersectionComparer2 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer2)));
          }
        }

      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        {
          _ref15 = null;

          if (!(_ref15 == null)) {
            throw new TypeError('Value of variable "_ref15" violates contract, expected void got ' + (_ref15 === null ? 'null' : (typeof _ref15 === 'undefined' ? 'undefined' : _typeof(_ref15)) === 'object' && _ref15.constructor ? _ref15.constructor.name || '[Unknown Object]' : typeof _ref15 === 'undefined' ? 'undefined' : _typeof(_ref15)));
          }

          if (_ref15 == null || typeof _ref15 === 'boolean') {
            return _ref15;
          } else {
            throw new TypeError('Function "compareArrayAnnotation" return value violates contract, expected ?bool got ' + (_ref15 === null ? 'null' : (typeof _ref15 === 'undefined' ? 'undefined' : _typeof(_ref15)) === 'object' && _ref15.constructor ? _ref15.constructor.name || '[Unknown Object]' : typeof _ref15 === 'undefined' ? 'undefined' : _typeof(_ref15)));
          }
        }

    }
  }

  function compareGenericAnnotation(a, b) {
    var _compareGenericAnnota2, _unionComparer3, _intersectionComparer3, _ref17;

    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _compareGenericAnnota2 = compareGenericAnnotation(a, b.typeAnnotation);

          if (!(_compareGenericAnnota2 == null || typeof _compareGenericAnnota2 === 'boolean')) {
            throw new TypeError('Value of variable "_compareGenericAnnota2" violates contract, expected ?bool got ' + (_compareGenericAnnota2 === null ? 'null' : (typeof _compareGenericAnnota2 === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota2)) === 'object' && _compareGenericAnnota2.constructor ? _compareGenericAnnota2.constructor.name || '[Unknown Object]' : typeof _compareGenericAnnota2 === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota2)));
          }

          if (_compareGenericAnnota2 == null || typeof _compareGenericAnnota2 === 'boolean') {
            return _compareGenericAnnota2;
          } else {
            throw new TypeError('Function "compareGenericAnnotation" return value violates contract, expected ?bool got ' + (_compareGenericAnnota2 === null ? 'null' : (typeof _compareGenericAnnota2 === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota2)) === 'object' && _compareGenericAnnota2.constructor ? _compareGenericAnnota2.constructor.name || '[Unknown Object]' : typeof _compareGenericAnnota2 === 'undefined' ? 'undefined' : _typeof(_compareGenericAnnota2)));
          }
        }

      case 'GenericTypeAnnotation':
        if (b.id.name === a.id.name) {
          return true;
        } else {
          var _ref16;

          _ref16 = null;

          if (!(_ref16 == null)) {
            throw new TypeError('Value of variable "_ref16" violates contract, expected void got ' + (_ref16 === null ? 'null' : (typeof _ref16 === 'undefined' ? 'undefined' : _typeof(_ref16)) === 'object' && _ref16.constructor ? _ref16.constructor.name || '[Unknown Object]' : typeof _ref16 === 'undefined' ? 'undefined' : _typeof(_ref16)));
          }

          if (_ref16 == null || typeof _ref16 === 'boolean') {
            return _ref16;
          } else {
            throw new TypeError('Function "compareGenericAnnotation" return value violates contract, expected ?bool got ' + (_ref16 === null ? 'null' : (typeof _ref16 === 'undefined' ? 'undefined' : _typeof(_ref16)) === 'object' && _ref16.constructor ? _ref16.constructor.name || '[Unknown Object]' : typeof _ref16 === 'undefined' ? 'undefined' : _typeof(_ref16)));
          }
        }
      case 'UnionTypeAnnotation':
        {
          _unionComparer3 = unionComparer(a, b, compareGenericAnnotation);

          if (!(_unionComparer3 == null || typeof _unionComparer3 === 'boolean')) {
            throw new TypeError('Value of variable "_unionComparer3" violates contract, expected ?bool got ' + (_unionComparer3 === null ? 'null' : (typeof _unionComparer3 === 'undefined' ? 'undefined' : _typeof(_unionComparer3)) === 'object' && _unionComparer3.constructor ? _unionComparer3.constructor.name || '[Unknown Object]' : typeof _unionComparer3 === 'undefined' ? 'undefined' : _typeof(_unionComparer3)));
          }

          if (_unionComparer3 == null || typeof _unionComparer3 === 'boolean') {
            return _unionComparer3;
          } else {
            throw new TypeError('Function "compareGenericAnnotation" return value violates contract, expected ?bool got ' + (_unionComparer3 === null ? 'null' : (typeof _unionComparer3 === 'undefined' ? 'undefined' : _typeof(_unionComparer3)) === 'object' && _unionComparer3.constructor ? _unionComparer3.constructor.name || '[Unknown Object]' : typeof _unionComparer3 === 'undefined' ? 'undefined' : _typeof(_unionComparer3)));
          }
        }

      case 'IntersectionTypeAnnotation':
        {
          _intersectionComparer3 = intersectionComparer(a, b, compareGenericAnnotation);

          if (!(_intersectionComparer3 == null || typeof _intersectionComparer3 === 'boolean')) {
            throw new TypeError('Value of variable "_intersectionComparer3" violates contract, expected ?bool got ' + (_intersectionComparer3 === null ? 'null' : (typeof _intersectionComparer3 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer3)) === 'object' && _intersectionComparer3.constructor ? _intersectionComparer3.constructor.name || '[Unknown Object]' : typeof _intersectionComparer3 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer3)));
          }

          if (_intersectionComparer3 == null || typeof _intersectionComparer3 === 'boolean') {
            return _intersectionComparer3;
          } else {
            throw new TypeError('Function "compareGenericAnnotation" return value violates contract, expected ?bool got ' + (_intersectionComparer3 === null ? 'null' : (typeof _intersectionComparer3 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer3)) === 'object' && _intersectionComparer3.constructor ? _intersectionComparer3.constructor.name || '[Unknown Object]' : typeof _intersectionComparer3 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer3)));
          }
        }

      default:
        {
          _ref17 = null;

          if (!(_ref17 == null)) {
            throw new TypeError('Value of variable "_ref17" violates contract, expected void got ' + (_ref17 === null ? 'null' : (typeof _ref17 === 'undefined' ? 'undefined' : _typeof(_ref17)) === 'object' && _ref17.constructor ? _ref17.constructor.name || '[Unknown Object]' : typeof _ref17 === 'undefined' ? 'undefined' : _typeof(_ref17)));
          }

          if (_ref17 == null || typeof _ref17 === 'boolean') {
            return _ref17;
          } else {
            throw new TypeError('Function "compareGenericAnnotation" return value violates contract, expected ?bool got ' + (_ref17 === null ? 'null' : (typeof _ref17 === 'undefined' ? 'undefined' : _typeof(_ref17)) === 'object' && _ref17.constructor ? _ref17.constructor.name || '[Unknown Object]' : typeof _ref17 === 'undefined' ? 'undefined' : _typeof(_ref17)));
          }
        }

    }
  }

  function compareTupleAnnotation(a, b) {
    var _compareTupleAnnotati2, _unionComparer4, _intersectionComparer4, _ref19;

    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    if (b.type === 'TupleTypeAnnotation') {
      var _a$types$every;

      if (b.types.length === 0) {
        var _ref18;

        _ref18 = null;

        if (!(_ref18 == null)) {
          throw new TypeError('Value of variable "_ref18" violates contract, expected void got ' + (_ref18 === null ? 'null' : (typeof _ref18 === 'undefined' ? 'undefined' : _typeof(_ref18)) === 'object' && _ref18.constructor ? _ref18.constructor.name || '[Unknown Object]' : typeof _ref18 === 'undefined' ? 'undefined' : _typeof(_ref18)));
        }

        if (_ref18 == null || typeof _ref18 === 'boolean') {
          return _ref18;
        } else {
          throw new TypeError('Function "compareTupleAnnotation" return value violates contract, expected ?bool got ' + (_ref18 === null ? 'null' : (typeof _ref18 === 'undefined' ? 'undefined' : _typeof(_ref18)) === 'object' && _ref18.constructor ? _ref18.constructor.name || '[Unknown Object]' : typeof _ref18 === 'undefined' ? 'undefined' : _typeof(_ref18)));
        }
      } else if (b.types.length < a.types.length) {
        return false;
      }
      _a$types$every = a.types.every(function (type, index) {
        return compareAnnotations(type, b.types[index]);
      });

      if (_a$types$every == null || typeof _a$types$every === 'boolean') {
        return _a$types$every;
      } else {
        throw new TypeError('Function "compareTupleAnnotation" return value violates contract, expected ?bool got ' + (_a$types$every === null ? 'null' : (typeof _a$types$every === 'undefined' ? 'undefined' : _typeof(_a$types$every)) === 'object' && _a$types$every.constructor ? _a$types$every.constructor.name || '[Unknown Object]' : typeof _a$types$every === 'undefined' ? 'undefined' : _typeof(_a$types$every)));
      }
    }
    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _compareTupleAnnotati2 = compareTupleAnnotation(a, b.typeAnnotation);

          if (!(_compareTupleAnnotati2 == null || typeof _compareTupleAnnotati2 === 'boolean')) {
            throw new TypeError('Value of variable "_compareTupleAnnotati2" violates contract, expected ?bool got ' + (_compareTupleAnnotati2 === null ? 'null' : (typeof _compareTupleAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati2)) === 'object' && _compareTupleAnnotati2.constructor ? _compareTupleAnnotati2.constructor.name || '[Unknown Object]' : typeof _compareTupleAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati2)));
          }

          if (_compareTupleAnnotati2 == null || typeof _compareTupleAnnotati2 === 'boolean') {
            return _compareTupleAnnotati2;
          } else {
            throw new TypeError('Function "compareTupleAnnotation" return value violates contract, expected ?bool got ' + (_compareTupleAnnotati2 === null ? 'null' : (typeof _compareTupleAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati2)) === 'object' && _compareTupleAnnotati2.constructor ? _compareTupleAnnotati2.constructor.name || '[Unknown Object]' : typeof _compareTupleAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareTupleAnnotati2)));
          }
        }

      case 'UnionTypeAnnotation':
        {
          _unionComparer4 = unionComparer(a, b, compareTupleAnnotation);

          if (!(_unionComparer4 == null || typeof _unionComparer4 === 'boolean')) {
            throw new TypeError('Value of variable "_unionComparer4" violates contract, expected ?bool got ' + (_unionComparer4 === null ? 'null' : (typeof _unionComparer4 === 'undefined' ? 'undefined' : _typeof(_unionComparer4)) === 'object' && _unionComparer4.constructor ? _unionComparer4.constructor.name || '[Unknown Object]' : typeof _unionComparer4 === 'undefined' ? 'undefined' : _typeof(_unionComparer4)));
          }

          if (_unionComparer4 == null || typeof _unionComparer4 === 'boolean') {
            return _unionComparer4;
          } else {
            throw new TypeError('Function "compareTupleAnnotation" return value violates contract, expected ?bool got ' + (_unionComparer4 === null ? 'null' : (typeof _unionComparer4 === 'undefined' ? 'undefined' : _typeof(_unionComparer4)) === 'object' && _unionComparer4.constructor ? _unionComparer4.constructor.name || '[Unknown Object]' : typeof _unionComparer4 === 'undefined' ? 'undefined' : _typeof(_unionComparer4)));
          }
        }

      case 'IntersectionTypeAnnotation':
        {
          _intersectionComparer4 = intersectionComparer(a, b, compareTupleAnnotation);

          if (!(_intersectionComparer4 == null || typeof _intersectionComparer4 === 'boolean')) {
            throw new TypeError('Value of variable "_intersectionComparer4" violates contract, expected ?bool got ' + (_intersectionComparer4 === null ? 'null' : (typeof _intersectionComparer4 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer4)) === 'object' && _intersectionComparer4.constructor ? _intersectionComparer4.constructor.name || '[Unknown Object]' : typeof _intersectionComparer4 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer4)));
          }

          if (_intersectionComparer4 == null || typeof _intersectionComparer4 === 'boolean') {
            return _intersectionComparer4;
          } else {
            throw new TypeError('Function "compareTupleAnnotation" return value violates contract, expected ?bool got ' + (_intersectionComparer4 === null ? 'null' : (typeof _intersectionComparer4 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer4)) === 'object' && _intersectionComparer4.constructor ? _intersectionComparer4.constructor.name || '[Unknown Object]' : typeof _intersectionComparer4 === 'undefined' ? 'undefined' : _typeof(_intersectionComparer4)));
          }
        }

      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        {
          _ref19 = null;

          if (!(_ref19 == null)) {
            throw new TypeError('Value of variable "_ref19" violates contract, expected void got ' + (_ref19 === null ? 'null' : (typeof _ref19 === 'undefined' ? 'undefined' : _typeof(_ref19)) === 'object' && _ref19.constructor ? _ref19.constructor.name || '[Unknown Object]' : typeof _ref19 === 'undefined' ? 'undefined' : _typeof(_ref19)));
          }

          if (_ref19 == null || typeof _ref19 === 'boolean') {
            return _ref19;
          } else {
            throw new TypeError('Function "compareTupleAnnotation" return value violates contract, expected ?bool got ' + (_ref19 === null ? 'null' : (typeof _ref19 === 'undefined' ? 'undefined' : _typeof(_ref19)) === 'object' && _ref19.constructor ? _ref19.constructor.name || '[Unknown Object]' : typeof _ref19 === 'undefined' ? 'undefined' : _typeof(_ref19)));
          }
        }

    }
  }

  function compareUnionAnnotation(a, b) {
    var _compareUnionAnnotati2, _ref20, _unionComparer5;

    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'NullableTypeAnnotation':
        {
          _compareUnionAnnotati2 = compareUnionAnnotation(a, b.typeAnnotation);

          if (!(_compareUnionAnnotati2 == null || typeof _compareUnionAnnotati2 === 'boolean')) {
            throw new TypeError('Value of variable "_compareUnionAnnotati2" violates contract, expected ?bool got ' + (_compareUnionAnnotati2 === null ? 'null' : (typeof _compareUnionAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati2)) === 'object' && _compareUnionAnnotati2.constructor ? _compareUnionAnnotati2.constructor.name || '[Unknown Object]' : typeof _compareUnionAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati2)));
          }

          if (_compareUnionAnnotati2 == null || typeof _compareUnionAnnotati2 === 'boolean') {
            return _compareUnionAnnotati2;
          } else {
            throw new TypeError('Function "compareUnionAnnotation" return value violates contract, expected ?bool got ' + (_compareUnionAnnotati2 === null ? 'null' : (typeof _compareUnionAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati2)) === 'object' && _compareUnionAnnotati2.constructor ? _compareUnionAnnotati2.constructor.name || '[Unknown Object]' : typeof _compareUnionAnnotati2 === 'undefined' ? 'undefined' : _typeof(_compareUnionAnnotati2)));
          }
        }

      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
        {
          _ref20 = null;

          if (!(_ref20 == null)) {
            throw new TypeError('Value of variable "_ref20" violates contract, expected void got ' + (_ref20 === null ? 'null' : (typeof _ref20 === 'undefined' ? 'undefined' : _typeof(_ref20)) === 'object' && _ref20.constructor ? _ref20.constructor.name || '[Unknown Object]' : typeof _ref20 === 'undefined' ? 'undefined' : _typeof(_ref20)));
          }

          if (_ref20 == null || typeof _ref20 === 'boolean') {
            return _ref20;
          } else {
            throw new TypeError('Function "compareUnionAnnotation" return value violates contract, expected ?bool got ' + (_ref20 === null ? 'null' : (typeof _ref20 === 'undefined' ? 'undefined' : _typeof(_ref20)) === 'object' && _ref20.constructor ? _ref20.constructor.name || '[Unknown Object]' : typeof _ref20 === 'undefined' ? 'undefined' : _typeof(_ref20)));
          }
        }

      default:
        {
          _unionComparer5 = unionComparer(a, b, compareAnnotations);

          if (!(_unionComparer5 == null || typeof _unionComparer5 === 'boolean')) {
            throw new TypeError('Value of variable "_unionComparer5" violates contract, expected ?bool got ' + (_unionComparer5 === null ? 'null' : (typeof _unionComparer5 === 'undefined' ? 'undefined' : _typeof(_unionComparer5)) === 'object' && _unionComparer5.constructor ? _unionComparer5.constructor.name || '[Unknown Object]' : typeof _unionComparer5 === 'undefined' ? 'undefined' : _typeof(_unionComparer5)));
          }

          if (_unionComparer5 == null || typeof _unionComparer5 === 'boolean') {
            return _unionComparer5;
          } else {
            throw new TypeError('Function "compareUnionAnnotation" return value violates contract, expected ?bool got ' + (_unionComparer5 === null ? 'null' : (typeof _unionComparer5 === 'undefined' ? 'undefined' : _typeof(_unionComparer5)) === 'object' && _unionComparer5.constructor ? _unionComparer5.constructor.name || '[Unknown Object]' : typeof _unionComparer5 === 'undefined' ? 'undefined' : _typeof(_unionComparer5)));
          }
        }

    }
  }

  function compareNullableAnnotation(a, b) {
    var _compareNullableAnnot2, _ref21;

    if (!Node(a)) {
      throw new TypeError('Value of argument "a" violates contract, expected Node got ' + (a === null ? 'null' : (typeof a === 'undefined' ? 'undefined' : _typeof(a)) === 'object' && a.constructor ? a.constructor.name || '[Unknown Object]' : typeof a === 'undefined' ? 'undefined' : _typeof(a)));
    }

    if (!Node(b)) {
      throw new TypeError('Value of argument "b" violates contract, expected Node got ' + (b === null ? 'null' : (typeof b === 'undefined' ? 'undefined' : _typeof(b)) === 'object' && b.constructor ? b.constructor.name || '[Unknown Object]' : typeof b === 'undefined' ? 'undefined' : _typeof(b)));
    }

    switch (b.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        {
          _compareNullableAnnot2 = compareNullableAnnotation(a, b.typeAnnotation);

          if (!(_compareNullableAnnot2 == null || typeof _compareNullableAnnot2 === 'boolean')) {
            throw new TypeError('Value of variable "_compareNullableAnnot2" violates contract, expected ?bool got ' + (_compareNullableAnnot2 === null ? 'null' : (typeof _compareNullableAnnot2 === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot2)) === 'object' && _compareNullableAnnot2.constructor ? _compareNullableAnnot2.constructor.name || '[Unknown Object]' : typeof _compareNullableAnnot2 === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot2)));
          }

          if (_compareNullableAnnot2 == null || typeof _compareNullableAnnot2 === 'boolean') {
            return _compareNullableAnnot2;
          } else {
            throw new TypeError('Function "compareNullableAnnotation" return value violates contract, expected ?bool got ' + (_compareNullableAnnot2 === null ? 'null' : (typeof _compareNullableAnnot2 === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot2)) === 'object' && _compareNullableAnnot2.constructor ? _compareNullableAnnot2.constructor.name || '[Unknown Object]' : typeof _compareNullableAnnot2 === 'undefined' ? 'undefined' : _typeof(_compareNullableAnnot2)));
          }
        }

      case 'NullableTypeAnnotation':
      case 'VoidTypeAnnotation':
        {
          _ref21 = null;

          if (!(_ref21 == null)) {
            throw new TypeError('Value of variable "_ref21" violates contract, expected void got ' + (_ref21 === null ? 'null' : (typeof _ref21 === 'undefined' ? 'undefined' : _typeof(_ref21)) === 'object' && _ref21.constructor ? _ref21.constructor.name || '[Unknown Object]' : typeof _ref21 === 'undefined' ? 'undefined' : _typeof(_ref21)));
          }

          if (_ref21 == null || typeof _ref21 === 'boolean') {
            return _ref21;
          } else {
            throw new TypeError('Function "compareNullableAnnotation" return value violates contract, expected ?bool got ' + (_ref21 === null ? 'null' : (typeof _ref21 === 'undefined' ? 'undefined' : _typeof(_ref21)) === 'object' && _ref21.constructor ? _ref21.constructor.name || '[Unknown Object]' : typeof _ref21 === 'undefined' ? 'undefined' : _typeof(_ref21)));
          }
        }

    }
    if (compareAnnotations(a.typeAnnotation, b) === true) {
      return true;
    } else {
      var _ref22;

      _ref22 = null;

      if (!(_ref22 == null)) {
        throw new TypeError('Value of variable "_ref22" violates contract, expected void got ' + (_ref22 === null ? 'null' : (typeof _ref22 === 'undefined' ? 'undefined' : _typeof(_ref22)) === 'object' && _ref22.constructor ? _ref22.constructor.name || '[Unknown Object]' : typeof _ref22 === 'undefined' ? 'undefined' : _typeof(_ref22)));
      }

      if (_ref22 == null || typeof _ref22 === 'boolean') {
        return _ref22;
      } else {
        throw new TypeError('Function "compareNullableAnnotation" return value violates contract, expected ?bool got ' + (_ref22 === null ? 'null' : (typeof _ref22 === 'undefined' ? 'undefined' : _typeof(_ref22)) === 'object' && _ref22.constructor ? _ref22.constructor.name || '[Unknown Object]' : typeof _ref22 === 'undefined' ? 'undefined' : _typeof(_ref22)));
      }
    }
  }

  function arrayExpressionToTupleAnnotation(path) {
    var _t$tupleTypeAnnotatio;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var elements = path.get('elements');
    _t$tupleTypeAnnotatio = t.tupleTypeAnnotation(elements.map(function (element) {
      return getAnnotation(element);
    }));

    if (TypeAnnotation(_t$tupleTypeAnnotatio)) {
      return _t$tupleTypeAnnotatio;
    } else {
      throw new TypeError('Function "arrayExpressionToTupleAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$tupleTypeAnnotatio === null ? 'null' : (typeof _t$tupleTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$tupleTypeAnnotatio)) === 'object' && _t$tupleTypeAnnotatio.constructor ? _t$tupleTypeAnnotatio.constructor.name || '[Unknown Object]' : typeof _t$tupleTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$tupleTypeAnnotatio)));
    }
  }

  function checkStaticUnion(_ref68) {
    var path = _ref68.path;
    var types = _ref68.types;

    var falseCount = 0;
    var nullCount = 0;
    var _iteratorNormalCompletion3 = true;
    var _didIteratorError3 = false;
    var _iteratorError3 = undefined;

    try {
      for (var _iterator3 = types[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
        var _type4 = _step3.value;

        var result = staticCheckAnnotation(path, _type4);
        if (result === true) {
          return true;
        } else if (result === false) {
          falseCount++;
        } else {
          nullCount++;
        }
      }
    } catch (err) {
      _didIteratorError3 = true;
      _iteratorError3 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion3 && _iterator3.return) {
          _iterator3.return();
        }
      } finally {
        if (_didIteratorError3) {
          throw _iteratorError3;
        }
      }
    }

    if (falseCount === types.length) {
      return false;
    } else {
      return null;
    }
  }

  function checkStaticIntersection(_ref69) {
    var path = _ref69.path;
    var types = _ref69.types;

    var trueCount = 0;
    var _iteratorNormalCompletion4 = true;
    var _didIteratorError4 = false;
    var _iteratorError4 = undefined;

    try {
      for (var _iterator4 = types[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
        var _type5 = _step4.value;

        var result = staticCheckAnnotation(path, _type5);
        if (result === true) {
          trueCount++;
        } else if (result === false) {
          return false;
        }
      }
    } catch (err) {
      _didIteratorError4 = true;
      _iteratorError4 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion4 && _iterator4.return) {
          _iterator4.return();
        }
      } finally {
        if (_didIteratorError4) {
          throw _iteratorError4;
        }
      }
    }

    if (trueCount === types.length) {
      return true;
    } else {
      return null;
    }
  }

  function checkStaticObject(_ref70) {
    var path = _ref70.path;
    var type = _ref70.type;
  }

  function checkStaticNullable(_ref71) {
    var path = _ref71.path;
    var type = _ref71.type;

    var annotation = getAnnotation(path);
    if (annotation.type === 'VoidTypeAnnotation' || annotation.type === 'NullableTypeAnnotation') {
      return true;
    } else {
      var _staticCheckAnnotatio;

      _staticCheckAnnotatio = staticCheckAnnotation(path, type);

      if (!(_staticCheckAnnotatio == null || typeof _staticCheckAnnotatio === 'boolean')) {
        throw new TypeError('Value of variable "_staticCheckAnnotatio" violates contract, expected ?bool got ' + (_staticCheckAnnotatio === null ? 'null' : (typeof _staticCheckAnnotatio === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio)) === 'object' && _staticCheckAnnotatio.constructor ? _staticCheckAnnotatio.constructor.name || '[Unknown Object]' : typeof _staticCheckAnnotatio === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio)));
      }

      if (_staticCheckAnnotatio == null || typeof _staticCheckAnnotatio === 'boolean') {
        return _staticCheckAnnotatio;
      } else {
        throw new TypeError('Function "checkStaticNullable" return value violates contract, expected ?bool got ' + (_staticCheckAnnotatio === null ? 'null' : (typeof _staticCheckAnnotatio === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio)) === 'object' && _staticCheckAnnotatio.constructor ? _staticCheckAnnotatio.constructor.name || '[Unknown Object]' : typeof _staticCheckAnnotatio === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio)));
      }
    }
  }

  function checkNullable(_ref72) {
    var _t$logicalExpression;

    var input = _ref72.input;
    var type = _ref72.type;
    var scope = _ref72.scope;

    var check = checkAnnotation(input, type, scope);
    if (!check) {
      return;
    }
    _t$logicalExpression = t.logicalExpression("||", checks.void({ input: input }), check);

    if (_t$logicalExpression == null || Node(_t$logicalExpression)) {
      return _t$logicalExpression;
    } else {
      throw new TypeError('Function "checkNullable" return value violates contract, expected ?Node got ' + (_t$logicalExpression === null ? 'null' : (typeof _t$logicalExpression === 'undefined' ? 'undefined' : _typeof(_t$logicalExpression)) === 'object' && _t$logicalExpression.constructor ? _t$logicalExpression.constructor.name || '[Unknown Object]' : typeof _t$logicalExpression === 'undefined' ? 'undefined' : _typeof(_t$logicalExpression)));
    }
  }

  function checkTypeof(_ref73) {
    var _checkAnnotation, _checkAnnotation2;

    var input = _ref73.input;
    var annotation = _ref73.annotation;
    var scope = _ref73.scope;

    switch (annotation.type) {
      case 'GenericTypeAnnotation':
        var id = annotation.id;

        var path = Object.assign({}, input, { type: id.type, node: id, scope: scope });
        {
          _checkAnnotation = checkAnnotation(input, getAnnotation(path), scope);

          if (!(_checkAnnotation == null || Node(_checkAnnotation))) {
            throw new TypeError('Value of variable "_checkAnnotation" violates contract, expected ?Node got ' + (_checkAnnotation === null ? 'null' : (typeof _checkAnnotation === 'undefined' ? 'undefined' : _typeof(_checkAnnotation)) === 'object' && _checkAnnotation.constructor ? _checkAnnotation.constructor.name || '[Unknown Object]' : typeof _checkAnnotation === 'undefined' ? 'undefined' : _typeof(_checkAnnotation)));
          }

          if (_checkAnnotation == null || Node(_checkAnnotation)) {
            return _checkAnnotation;
          } else {
            throw new TypeError('Function "checkTypeof" return value violates contract, expected ?Node got ' + (_checkAnnotation === null ? 'null' : (typeof _checkAnnotation === 'undefined' ? 'undefined' : _typeof(_checkAnnotation)) === 'object' && _checkAnnotation.constructor ? _checkAnnotation.constructor.name || '[Unknown Object]' : typeof _checkAnnotation === 'undefined' ? 'undefined' : _typeof(_checkAnnotation)));
          }
        }

      default:
        {
          _checkAnnotation2 = checkAnnotation(input, annotation, scope);

          if (!(_checkAnnotation2 == null || Node(_checkAnnotation2))) {
            throw new TypeError('Value of variable "_checkAnnotation2" violates contract, expected ?Node got ' + (_checkAnnotation2 === null ? 'null' : (typeof _checkAnnotation2 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation2)) === 'object' && _checkAnnotation2.constructor ? _checkAnnotation2.constructor.name || '[Unknown Object]' : typeof _checkAnnotation2 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation2)));
          }

          if (_checkAnnotation2 == null || Node(_checkAnnotation2)) {
            return _checkAnnotation2;
          } else {
            throw new TypeError('Function "checkTypeof" return value violates contract, expected ?Node got ' + (_checkAnnotation2 === null ? 'null' : (typeof _checkAnnotation2 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation2)) === 'object' && _checkAnnotation2.constructor ? _checkAnnotation2.constructor.name || '[Unknown Object]' : typeof _checkAnnotation2 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation2)));
          }
        }

    }
  }

  function checkUnion(_ref74) {
    var _checks$reduce;

    var input = _ref74.input;
    var types = _ref74.types;
    var scope = _ref74.scope;

    var checks = types.map(function (type) {
      return checkAnnotation(input, type, scope);
    }).filter(identity);
    _checks$reduce = checks.reduce(function (last, check, index) {
      if (last == null) {
        return check;
      }
      return t.logicalExpression("||", last, check);
    }, null);

    if (_checks$reduce == null || Node(_checks$reduce)) {
      return _checks$reduce;
    } else {
      throw new TypeError('Function "checkUnion" return value violates contract, expected ?Node got ' + (_checks$reduce === null ? 'null' : (typeof _checks$reduce === 'undefined' ? 'undefined' : _typeof(_checks$reduce)) === 'object' && _checks$reduce.constructor ? _checks$reduce.constructor.name || '[Unknown Object]' : typeof _checks$reduce === 'undefined' ? 'undefined' : _typeof(_checks$reduce)));
    }
  }

  function checkIntersection(_ref75) {
    var _checks$reduce2;

    var input = _ref75.input;
    var types = _ref75.types;
    var scope = _ref75.scope;

    var checks = types.map(function (type) {
      return checkAnnotation(input, type, scope);
    }).filter(identity);
    _checks$reduce2 = checks.reduce(function (last, check, index) {
      if (last == null) {
        return check;
      }
      return t.logicalExpression("&&", last, check);
    }, null);

    if (_checks$reduce2 == null || Node(_checks$reduce2)) {
      return _checks$reduce2;
    } else {
      throw new TypeError('Function "checkIntersection" return value violates contract, expected ?Node got ' + (_checks$reduce2 === null ? 'null' : (typeof _checks$reduce2 === 'undefined' ? 'undefined' : _typeof(_checks$reduce2)) === 'object' && _checks$reduce2.constructor ? _checks$reduce2.constructor.name || '[Unknown Object]' : typeof _checks$reduce2 === 'undefined' ? 'undefined' : _typeof(_checks$reduce2)));
    }
  }

  function checkMap(_ref76) {
    var input = _ref76.input;
    var types = _ref76.types;
    var scope = _ref76.scope;

    var _types = _slicedToArray(types, 2);

    var keyType = _types[0];
    var valueType = _types[1];

    var key = t.identifier('key');
    var value = t.identifier('value');
    var keyCheck = keyType ? checkAnnotation(key, keyType, scope) : null;
    var valueCheck = valueType ? checkAnnotation(value, valueType, scope) : null;
    if (!keyCheck) {
      if (!valueCheck) {
        var _checkIsMap;

        _checkIsMap = checkIsMap({ input: input });

        if (Node(_checkIsMap)) {
          return _checkIsMap;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkIsMap === null ? 'null' : (typeof _checkIsMap === 'undefined' ? 'undefined' : _typeof(_checkIsMap)) === 'object' && _checkIsMap.constructor ? _checkIsMap.constructor.name || '[Unknown Object]' : typeof _checkIsMap === 'undefined' ? 'undefined' : _typeof(_checkIsMap)));
        }
      } else {
        var _checkMapValues;

        _checkMapValues = checkMapValues({ input: input, value: value, valueCheck: valueCheck });

        if (Node(_checkMapValues)) {
          return _checkMapValues;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkMapValues === null ? 'null' : (typeof _checkMapValues === 'undefined' ? 'undefined' : _typeof(_checkMapValues)) === 'object' && _checkMapValues.constructor ? _checkMapValues.constructor.name || '[Unknown Object]' : typeof _checkMapValues === 'undefined' ? 'undefined' : _typeof(_checkMapValues)));
        }
      }
    } else {
      if (!valueCheck) {
        var _checkMapKeys;

        _checkMapKeys = checkMapKeys({ input: input, key: key, keyCheck: keyCheck });

        if (Node(_checkMapKeys)) {
          return _checkMapKeys;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkMapKeys === null ? 'null' : (typeof _checkMapKeys === 'undefined' ? 'undefined' : _typeof(_checkMapKeys)) === 'object' && _checkMapKeys.constructor ? _checkMapKeys.constructor.name || '[Unknown Object]' : typeof _checkMapKeys === 'undefined' ? 'undefined' : _typeof(_checkMapKeys)));
        }
      } else {
        var _checkMapEntries;

        _checkMapEntries = checkMapEntries({ input: input, key: key, value: value, keyCheck: keyCheck, valueCheck: valueCheck });

        if (Node(_checkMapEntries)) {
          return _checkMapEntries;
        } else {
          throw new TypeError('Function "checkMap" return value violates contract, expected Node got ' + (_checkMapEntries === null ? 'null' : (typeof _checkMapEntries === 'undefined' ? 'undefined' : _typeof(_checkMapEntries)) === 'object' && _checkMapEntries.constructor ? _checkMapEntries.constructor.name || '[Unknown Object]' : typeof _checkMapEntries === 'undefined' ? 'undefined' : _typeof(_checkMapEntries)));
        }
      }
    }
  }

  function checkSet(_ref77) {
    var input = _ref77.input;
    var types = _ref77.types;
    var scope = _ref77.scope;

    var _types2 = _slicedToArray(types, 1);

    var valueType = _types2[0];

    var value = t.identifier('value');
    var valueCheck = valueType ? checkAnnotation(value, valueType, scope) : null;
    if (!valueCheck) {
      var _checkIsSet;

      _checkIsSet = checkIsSet({ input: input });

      if (Node(_checkIsSet)) {
        return _checkIsSet;
      } else {
        throw new TypeError('Function "checkSet" return value violates contract, expected Node got ' + (_checkIsSet === null ? 'null' : (typeof _checkIsSet === 'undefined' ? 'undefined' : _typeof(_checkIsSet)) === 'object' && _checkIsSet.constructor ? _checkIsSet.constructor.name || '[Unknown Object]' : typeof _checkIsSet === 'undefined' ? 'undefined' : _typeof(_checkIsSet)));
      }
    } else {
      var _checkSetEntries;

      _checkSetEntries = checkSetEntries({ input: input, value: value, valueCheck: valueCheck });

      if (Node(_checkSetEntries)) {
        return _checkSetEntries;
      } else {
        throw new TypeError('Function "checkSet" return value violates contract, expected Node got ' + (_checkSetEntries === null ? 'null' : (typeof _checkSetEntries === 'undefined' ? 'undefined' : _typeof(_checkSetEntries)) === 'object' && _checkSetEntries.constructor ? _checkSetEntries.constructor.name || '[Unknown Object]' : typeof _checkSetEntries === 'undefined' ? 'undefined' : _typeof(_checkSetEntries)));
      }
    }
  }

  function checkArray(_ref78) {
    var input = _ref78.input;
    var types = _ref78.types;
    var scope = _ref78.scope;

    if (!types || types.length === 0) {
      var _checkIsArray;

      _checkIsArray = checkIsArray({ input: input });

      if (Node(_checkIsArray)) {
        return _checkIsArray;
      } else {
        throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_checkIsArray === null ? 'null' : (typeof _checkIsArray === 'undefined' ? 'undefined' : _typeof(_checkIsArray)) === 'object' && _checkIsArray.constructor ? _checkIsArray.constructor.name || '[Unknown Object]' : typeof _checkIsArray === 'undefined' ? 'undefined' : _typeof(_checkIsArray)));
      }
    } else if (types.length === 1) {
      var _t$logicalExpression2;

      var item = t.identifier('item');
      var _type6 = types[0];
      var check = checkAnnotation(item, _type6, scope);
      if (!check) {
        var _checkIsArray2;

        _checkIsArray2 = checkIsArray({ input: input });

        if (Node(_checkIsArray2)) {
          return _checkIsArray2;
        } else {
          throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_checkIsArray2 === null ? 'null' : (typeof _checkIsArray2 === 'undefined' ? 'undefined' : _typeof(_checkIsArray2)) === 'object' && _checkIsArray2.constructor ? _checkIsArray2.constructor.name || '[Unknown Object]' : typeof _checkIsArray2 === 'undefined' ? 'undefined' : _typeof(_checkIsArray2)));
        }
      }
      _t$logicalExpression2 = t.logicalExpression('&&', checkIsArray({ input: input }), t.callExpression(t.memberExpression(input, t.identifier('every')), [t.functionExpression(null, [item], t.blockStatement([t.returnStatement(check)]))]));

      if (Node(_t$logicalExpression2)) {
        return _t$logicalExpression2;
      } else {
        throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_t$logicalExpression2 === null ? 'null' : (typeof _t$logicalExpression2 === 'undefined' ? 'undefined' : _typeof(_t$logicalExpression2)) === 'object' && _t$logicalExpression2.constructor ? _t$logicalExpression2.constructor.name || '[Unknown Object]' : typeof _t$logicalExpression2 === 'undefined' ? 'undefined' : _typeof(_t$logicalExpression2)));
      }
    } else {
      var _checks$reduce3;

      // This is a tuple
      var _checks = types.map(function (type, index) {
        return checkAnnotation(t.memberExpression(input, t.numericLiteral(index), true), type, scope);
      }).filter(identity);

      var checkLength = t.binaryExpression('>=', t.memberExpression(input, t.identifier('length')), t.numericLiteral(types.length));

      _checks$reduce3 = _checks.reduce(function (last, check, index) {
        return t.logicalExpression("&&", last, check);
      }, t.logicalExpression('&&', checkIsArray({ input: input }), checkLength));

      if (Node(_checks$reduce3)) {
        return _checks$reduce3;
      } else {
        throw new TypeError('Function "checkArray" return value violates contract, expected Node got ' + (_checks$reduce3 === null ? 'null' : (typeof _checks$reduce3 === 'undefined' ? 'undefined' : _typeof(_checks$reduce3)) === 'object' && _checks$reduce3.constructor ? _checks$reduce3.constructor.name || '[Unknown Object]' : typeof _checks$reduce3 === 'undefined' ? 'undefined' : _typeof(_checks$reduce3)));
      }
    }
  }

  function checkTuple(_ref79) {
    var _checks$reduce4;

    var input = _ref79.input;
    var types = _ref79.types;
    var scope = _ref79.scope;

    if (types.length === 0) {
      var _checkIsArray3;

      _checkIsArray3 = checkIsArray({ input: input });

      if (Node(_checkIsArray3)) {
        return _checkIsArray3;
      } else {
        throw new TypeError('Function "checkTuple" return value violates contract, expected Node got ' + (_checkIsArray3 === null ? 'null' : (typeof _checkIsArray3 === 'undefined' ? 'undefined' : _typeof(_checkIsArray3)) === 'object' && _checkIsArray3.constructor ? _checkIsArray3.constructor.name || '[Unknown Object]' : typeof _checkIsArray3 === 'undefined' ? 'undefined' : _typeof(_checkIsArray3)));
      }
    }

    // This is a tuple
    var checks = types.map(function (type, index) {
      return checkAnnotation(t.memberExpression(input, t.numericLiteral(index), true), type, scope);
    }).filter(identity);

    var checkLength = t.binaryExpression('>=', t.memberExpression(input, t.identifier('length')), t.numericLiteral(types.length));

    _checks$reduce4 = checks.reduce(function (last, check, index) {
      return t.logicalExpression("&&", last, check);
    }, t.logicalExpression('&&', checkIsArray({ input: input }), checkLength));

    if (Node(_checks$reduce4)) {
      return _checks$reduce4;
    } else {
      throw new TypeError('Function "checkTuple" return value violates contract, expected Node got ' + (_checks$reduce4 === null ? 'null' : (typeof _checks$reduce4 === 'undefined' ? 'undefined' : _typeof(_checks$reduce4)) === 'object' && _checks$reduce4.constructor ? _checks$reduce4.constructor.name || '[Unknown Object]' : typeof _checks$reduce4 === 'undefined' ? 'undefined' : _typeof(_checks$reduce4)));
    }
  }

  function checkObject(_ref80) {
    var input = _ref80.input;
    var properties = _ref80.properties;
    var scope = _ref80.scope;

    var check = properties.reduce(function (expr, prop, index) {
      var target = t.memberExpression(input, prop.key);
      var check = checkAnnotation(target, prop.value, scope);
      if (check) {
        if (prop.optional) {
          check = t.logicalExpression('||', checks.undefined({ input: target }), check);
        }
        return t.logicalExpression("&&", expr, check);
      } else {
        return expr;
      }
    }, checkIsObject({ input: input }));

    if (Node(check)) {
      return check;
    } else {
      throw new TypeError('Function "checkObject" return value violates contract, expected Node got ' + (check === null ? 'null' : (typeof check === 'undefined' ? 'undefined' : _typeof(check)) === 'object' && check.constructor ? check.constructor.name || '[Unknown Object]' : typeof check === 'undefined' ? 'undefined' : _typeof(check)));
    }
  }

  function createTypeAliasChecks(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.id;
    var annotation = node.right;

    var input = t.identifier('input');
    var check = checkAnnotation(input, annotation, scope) || t.booleanLiteral(true);
    var declaration = declareTypeChecker({ id: id, check: check });
    declaration.isTypeChecker = true;

    if (Node(declaration)) {
      return declaration;
    } else {
      throw new TypeError('Function "createTypeAliasChecks" return value violates contract, expected Node got ' + (declaration === null ? 'null' : (typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)) === 'object' && declaration.constructor ? declaration.constructor.name || '[Unknown Object]' : typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)));
    }
  }

  function createInterfaceChecks(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.id;
    var annotation = node.body;

    var input = t.identifier('input');
    var check = node.extends.reduce(function (check, extender) {
      return t.logicalExpression('&&', check, checkAnnotation(input, t.genericTypeAnnotation(extender.id), path.scope));
      return check;
    }, checkAnnotation(input, annotation, scope) || t.booleanLiteral(true));

    var declaration = declareTypeChecker({ id: id, check: check });
    declaration.isTypeChecker = true;

    if (Node(declaration)) {
      return declaration;
    } else {
      throw new TypeError('Function "createInterfaceChecks" return value violates contract, expected Node got ' + (declaration === null ? 'null' : (typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)) === 'object' && declaration.constructor ? declaration.constructor.name || '[Unknown Object]' : typeof declaration === 'undefined' ? 'undefined' : _typeof(declaration)));
    }
  }

  function checkAnnotation(input, annotation, scope) {
    var _checkAnnotation3, _checks$typeof, _checks$tuple, _checks$number, _checks$boolean, _checks$string, _checks$union, _checks$intersection, _checks$object, _checks$array2, _checks$function2, _checks$mixed, _checks$any, _checks$nullable, _checks$void;

    if (!Node(input)) {
      throw new TypeError('Value of argument "input" violates contract, expected Node got ' + (input === null ? 'null' : (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && input.constructor ? input.constructor.name || '[Unknown Object]' : typeof input === 'undefined' ? 'undefined' : _typeof(input)));
    }

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        {
          _checkAnnotation3 = checkAnnotation(input, annotation.typeAnnotation, scope);

          if (!(_checkAnnotation3 == null || Node(_checkAnnotation3))) {
            throw new TypeError('Value of variable "_checkAnnotation3" violates contract, expected ?Node got ' + (_checkAnnotation3 === null ? 'null' : (typeof _checkAnnotation3 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation3)) === 'object' && _checkAnnotation3.constructor ? _checkAnnotation3.constructor.name || '[Unknown Object]' : typeof _checkAnnotation3 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation3)));
          }

          if (_checkAnnotation3 == null || Node(_checkAnnotation3)) {
            return _checkAnnotation3;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checkAnnotation3 === null ? 'null' : (typeof _checkAnnotation3 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation3)) === 'object' && _checkAnnotation3.constructor ? _checkAnnotation3.constructor.name || '[Unknown Object]' : typeof _checkAnnotation3 === 'undefined' ? 'undefined' : _typeof(_checkAnnotation3)));
          }
        }

      case 'TypeofTypeAnnotation':
        {
          _checks$typeof = checks.typeof({ input: input, annotation: annotation.argument, scope: scope });

          if (_checks$typeof == null || Node(_checks$typeof)) {
            return _checks$typeof;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$typeof === null ? 'null' : (typeof _checks$typeof === 'undefined' ? 'undefined' : _typeof(_checks$typeof)) === 'object' && _checks$typeof.constructor ? _checks$typeof.constructor.name || '[Unknown Object]' : typeof _checks$typeof === 'undefined' ? 'undefined' : _typeof(_checks$typeof)));
          }
        }

      case 'GenericTypeAnnotation':
        if (annotation.id.name === 'Array') {
          var _checks$array;

          _checks$array = checks.array({ input: input, types: annotation.typeParameters ? annotation.typeParameters.params : [], scope: scope });

          if (_checks$array == null || Node(_checks$array)) {
            return _checks$array;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$array === null ? 'null' : (typeof _checks$array === 'undefined' ? 'undefined' : _typeof(_checks$array)) === 'object' && _checks$array.constructor ? _checks$array.constructor.name || '[Unknown Object]' : typeof _checks$array === 'undefined' ? 'undefined' : _typeof(_checks$array)));
          }
        } else if (annotation.id.name === 'Map' && !scope.hasBinding('Map')) {
          var _checks$map;

          _checks$map = checks.map({ input: input, types: annotation.typeParameters ? annotation.typeParameters.params : [], scope: scope });

          if (_checks$map == null || Node(_checks$map)) {
            return _checks$map;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$map === null ? 'null' : (typeof _checks$map === 'undefined' ? 'undefined' : _typeof(_checks$map)) === 'object' && _checks$map.constructor ? _checks$map.constructor.name || '[Unknown Object]' : typeof _checks$map === 'undefined' ? 'undefined' : _typeof(_checks$map)));
          }
        } else if (annotation.id.name === 'Set' && !scope.hasBinding('Set')) {
          var _checks$set;

          _checks$set = checks.set({ input: input, types: annotation.typeParameters ? annotation.typeParameters.params : [], scope: scope });

          if (_checks$set == null || Node(_checks$set)) {
            return _checks$set;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$set === null ? 'null' : (typeof _checks$set === 'undefined' ? 'undefined' : _typeof(_checks$set)) === 'object' && _checks$set.constructor ? _checks$set.constructor.name || '[Unknown Object]' : typeof _checks$set === 'undefined' ? 'undefined' : _typeof(_checks$set)));
          }
        } else if (annotation.id.name === 'Function') {
          var _checks$function;

          _checks$function = checks.function({ input: input });

          if (_checks$function == null || Node(_checks$function)) {
            return _checks$function;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$function === null ? 'null' : (typeof _checks$function === 'undefined' ? 'undefined' : _typeof(_checks$function)) === 'object' && _checks$function.constructor ? _checks$function.constructor.name || '[Unknown Object]' : typeof _checks$function === 'undefined' ? 'undefined' : _typeof(_checks$function)));
          }
        } else if (annotation.id.name === 'Symbol') {
          var _checks$symbol;

          _checks$symbol = checks.symbol({ input: input });

          if (_checks$symbol == null || Node(_checks$symbol)) {
            return _checks$symbol;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$symbol === null ? 'null' : (typeof _checks$symbol === 'undefined' ? 'undefined' : _typeof(_checks$symbol)) === 'object' && _checks$symbol.constructor ? _checks$symbol.constructor.name || '[Unknown Object]' : typeof _checks$symbol === 'undefined' ? 'undefined' : _typeof(_checks$symbol)));
          }
        } else if (isTypeChecker(annotation.id, scope)) {
          var _checks$type;

          _checks$type = checks.type({ input: input, type: annotation.id });

          if (_checks$type == null || Node(_checks$type)) {
            return _checks$type;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$type === null ? 'null' : (typeof _checks$type === 'undefined' ? 'undefined' : _typeof(_checks$type)) === 'object' && _checks$type.constructor ? _checks$type.constructor.name || '[Unknown Object]' : typeof _checks$type === 'undefined' ? 'undefined' : _typeof(_checks$type)));
          }
        } else if (isPolymorphicType(annotation.id, scope)) {
          return;
        } else {
          var _checks$instanceof;

          _checks$instanceof = checks.instanceof({ input: input, type: createTypeExpression(annotation.id) });

          if (_checks$instanceof == null || Node(_checks$instanceof)) {
            return _checks$instanceof;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$instanceof === null ? 'null' : (typeof _checks$instanceof === 'undefined' ? 'undefined' : _typeof(_checks$instanceof)) === 'object' && _checks$instanceof.constructor ? _checks$instanceof.constructor.name || '[Unknown Object]' : typeof _checks$instanceof === 'undefined' ? 'undefined' : _typeof(_checks$instanceof)));
          }
        }
      case 'TupleTypeAnnotation':
        {
          _checks$tuple = checks.tuple({ input: input, types: annotation.types, scope: scope });

          if (_checks$tuple == null || Node(_checks$tuple)) {
            return _checks$tuple;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$tuple === null ? 'null' : (typeof _checks$tuple === 'undefined' ? 'undefined' : _typeof(_checks$tuple)) === 'object' && _checks$tuple.constructor ? _checks$tuple.constructor.name || '[Unknown Object]' : typeof _checks$tuple === 'undefined' ? 'undefined' : _typeof(_checks$tuple)));
          }
        }

      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
        {
          _checks$number = checks.number({ input: input });

          if (_checks$number == null || Node(_checks$number)) {
            return _checks$number;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$number === null ? 'null' : (typeof _checks$number === 'undefined' ? 'undefined' : _typeof(_checks$number)) === 'object' && _checks$number.constructor ? _checks$number.constructor.name || '[Unknown Object]' : typeof _checks$number === 'undefined' ? 'undefined' : _typeof(_checks$number)));
          }
        }

      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
        {
          _checks$boolean = checks.boolean({ input: input });

          if (_checks$boolean == null || Node(_checks$boolean)) {
            return _checks$boolean;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$boolean === null ? 'null' : (typeof _checks$boolean === 'undefined' ? 'undefined' : _typeof(_checks$boolean)) === 'object' && _checks$boolean.constructor ? _checks$boolean.constructor.name || '[Unknown Object]' : typeof _checks$boolean === 'undefined' ? 'undefined' : _typeof(_checks$boolean)));
          }
        }

      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
        {
          _checks$string = checks.string({ input: input });

          if (_checks$string == null || Node(_checks$string)) {
            return _checks$string;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$string === null ? 'null' : (typeof _checks$string === 'undefined' ? 'undefined' : _typeof(_checks$string)) === 'object' && _checks$string.constructor ? _checks$string.constructor.name || '[Unknown Object]' : typeof _checks$string === 'undefined' ? 'undefined' : _typeof(_checks$string)));
          }
        }

      case 'UnionTypeAnnotation':
        {
          _checks$union = checks.union({ input: input, types: annotation.types, scope: scope });

          if (_checks$union == null || Node(_checks$union)) {
            return _checks$union;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$union === null ? 'null' : (typeof _checks$union === 'undefined' ? 'undefined' : _typeof(_checks$union)) === 'object' && _checks$union.constructor ? _checks$union.constructor.name || '[Unknown Object]' : typeof _checks$union === 'undefined' ? 'undefined' : _typeof(_checks$union)));
          }
        }

      case 'IntersectionTypeAnnotation':
        {
          _checks$intersection = checks.intersection({ input: input, types: annotation.types, scope: scope });

          if (_checks$intersection == null || Node(_checks$intersection)) {
            return _checks$intersection;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$intersection === null ? 'null' : (typeof _checks$intersection === 'undefined' ? 'undefined' : _typeof(_checks$intersection)) === 'object' && _checks$intersection.constructor ? _checks$intersection.constructor.name || '[Unknown Object]' : typeof _checks$intersection === 'undefined' ? 'undefined' : _typeof(_checks$intersection)));
          }
        }

      case 'ObjectTypeAnnotation':
        {
          _checks$object = checks.object({ input: input, properties: annotation.properties, indexers: annotation.indexers, scope: scope });

          if (_checks$object == null || Node(_checks$object)) {
            return _checks$object;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$object === null ? 'null' : (typeof _checks$object === 'undefined' ? 'undefined' : _typeof(_checks$object)) === 'object' && _checks$object.constructor ? _checks$object.constructor.name || '[Unknown Object]' : typeof _checks$object === 'undefined' ? 'undefined' : _typeof(_checks$object)));
          }
        }

      case 'ArrayTypeAnnotation':
        {
          _checks$array2 = checks.array({ input: input, types: [annotation.elementType || t.anyTypeAnnotation()], scope: scope });

          if (_checks$array2 == null || Node(_checks$array2)) {
            return _checks$array2;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$array2 === null ? 'null' : (typeof _checks$array2 === 'undefined' ? 'undefined' : _typeof(_checks$array2)) === 'object' && _checks$array2.constructor ? _checks$array2.constructor.name || '[Unknown Object]' : typeof _checks$array2 === 'undefined' ? 'undefined' : _typeof(_checks$array2)));
          }
        }

      case 'FunctionTypeAnnotation':
        {
          _checks$function2 = checks.function({ input: input, params: annotation.params, returnType: annotation.returnType });

          if (_checks$function2 == null || Node(_checks$function2)) {
            return _checks$function2;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$function2 === null ? 'null' : (typeof _checks$function2 === 'undefined' ? 'undefined' : _typeof(_checks$function2)) === 'object' && _checks$function2.constructor ? _checks$function2.constructor.name || '[Unknown Object]' : typeof _checks$function2 === 'undefined' ? 'undefined' : _typeof(_checks$function2)));
          }
        }

      case 'MixedTypeAnnotation':
        {
          _checks$mixed = checks.mixed({ input: input });

          if (_checks$mixed == null || Node(_checks$mixed)) {
            return _checks$mixed;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$mixed === null ? 'null' : (typeof _checks$mixed === 'undefined' ? 'undefined' : _typeof(_checks$mixed)) === 'object' && _checks$mixed.constructor ? _checks$mixed.constructor.name || '[Unknown Object]' : typeof _checks$mixed === 'undefined' ? 'undefined' : _typeof(_checks$mixed)));
          }
        }

      case 'AnyTypeAnnotation':
      case 'ExistentialTypeParam':
        {
          _checks$any = checks.any({ input: input });

          if (_checks$any == null || Node(_checks$any)) {
            return _checks$any;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$any === null ? 'null' : (typeof _checks$any === 'undefined' ? 'undefined' : _typeof(_checks$any)) === 'object' && _checks$any.constructor ? _checks$any.constructor.name || '[Unknown Object]' : typeof _checks$any === 'undefined' ? 'undefined' : _typeof(_checks$any)));
          }
        }

      case 'NullableTypeAnnotation':
        {
          _checks$nullable = checks.nullable({ input: input, type: annotation.typeAnnotation, scope: scope });

          if (_checks$nullable == null || Node(_checks$nullable)) {
            return _checks$nullable;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$nullable === null ? 'null' : (typeof _checks$nullable === 'undefined' ? 'undefined' : _typeof(_checks$nullable)) === 'object' && _checks$nullable.constructor ? _checks$nullable.constructor.name || '[Unknown Object]' : typeof _checks$nullable === 'undefined' ? 'undefined' : _typeof(_checks$nullable)));
          }
        }

      case 'VoidTypeAnnotation':
        {
          _checks$void = checks.void({ input: input });

          if (_checks$void == null || Node(_checks$void)) {
            return _checks$void;
          } else {
            throw new TypeError('Function "checkAnnotation" return value violates contract, expected ?Node got ' + (_checks$void === null ? 'null' : (typeof _checks$void === 'undefined' ? 'undefined' : _typeof(_checks$void)) === 'object' && _checks$void.constructor ? _checks$void.constructor.name || '[Unknown Object]' : typeof _checks$void === 'undefined' ? 'undefined' : _typeof(_checks$void)));
          }
        }

    }
  }

  function staticCheckAnnotation(path, annotation) {
    var _staticCheckAnnotatio2, _compareAnnotations;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    var other = getAnnotation(path);
    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        {
          _staticCheckAnnotatio2 = staticCheckAnnotation(path, annotation.typeAnnotation);

          if (!(_staticCheckAnnotatio2 == null || typeof _staticCheckAnnotatio2 === 'boolean')) {
            throw new TypeError('Value of variable "_staticCheckAnnotatio2" violates contract, expected ?bool got ' + (_staticCheckAnnotatio2 === null ? 'null' : (typeof _staticCheckAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio2)) === 'object' && _staticCheckAnnotatio2.constructor ? _staticCheckAnnotatio2.constructor.name || '[Unknown Object]' : typeof _staticCheckAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio2)));
          }

          if (_staticCheckAnnotatio2 == null || typeof _staticCheckAnnotatio2 === 'boolean') {
            return _staticCheckAnnotatio2;
          } else {
            throw new TypeError('Function "staticCheckAnnotation" return value violates contract, expected ?bool got ' + (_staticCheckAnnotatio2 === null ? 'null' : (typeof _staticCheckAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio2)) === 'object' && _staticCheckAnnotatio2.constructor ? _staticCheckAnnotatio2.constructor.name || '[Unknown Object]' : typeof _staticCheckAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_staticCheckAnnotatio2)));
          }
        }

      case 'GenericTypeAnnotation':
        if (isTypeChecker(annotation.id, path.scope)) {
          var _staticChecks$type;

          _staticChecks$type = staticChecks.type({ path: path, type: annotation.id });

          if (_staticChecks$type == null || typeof _staticChecks$type === 'boolean') {
            return _staticChecks$type;
          } else {
            throw new TypeError('Function "staticCheckAnnotation" return value violates contract, expected ?bool got ' + (_staticChecks$type === null ? 'null' : (typeof _staticChecks$type === 'undefined' ? 'undefined' : _typeof(_staticChecks$type)) === 'object' && _staticChecks$type.constructor ? _staticChecks$type.constructor.name || '[Unknown Object]' : typeof _staticChecks$type === 'undefined' ? 'undefined' : _typeof(_staticChecks$type)));
          }
        } else if (isPolymorphicType(annotation.id, path.scope)) {
          return;
        } else if (annotation.id.name === 'Symbol') {
          var _staticChecks$symbol;

          _staticChecks$symbol = staticChecks.symbol(path);

          if (_staticChecks$symbol == null || typeof _staticChecks$symbol === 'boolean') {
            return _staticChecks$symbol;
          } else {
            throw new TypeError('Function "staticCheckAnnotation" return value violates contract, expected ?bool got ' + (_staticChecks$symbol === null ? 'null' : (typeof _staticChecks$symbol === 'undefined' ? 'undefined' : _typeof(_staticChecks$symbol)) === 'object' && _staticChecks$symbol.constructor ? _staticChecks$symbol.constructor.name || '[Unknown Object]' : typeof _staticChecks$symbol === 'undefined' ? 'undefined' : _typeof(_staticChecks$symbol)));
          }
        } else {
          var _staticChecks$instanc;

          _staticChecks$instanc = staticChecks.instanceof({ path: path, type: createTypeExpression(annotation.id) });

          if (_staticChecks$instanc == null || typeof _staticChecks$instanc === 'boolean') {
            return _staticChecks$instanc;
          } else {
            throw new TypeError('Function "staticCheckAnnotation" return value violates contract, expected ?bool got ' + (_staticChecks$instanc === null ? 'null' : (typeof _staticChecks$instanc === 'undefined' ? 'undefined' : _typeof(_staticChecks$instanc)) === 'object' && _staticChecks$instanc.constructor ? _staticChecks$instanc.constructor.name || '[Unknown Object]' : typeof _staticChecks$instanc === 'undefined' ? 'undefined' : _typeof(_staticChecks$instanc)));
          }
        }
    }

    _compareAnnotations = compareAnnotations(annotation, other);

    if (!(_compareAnnotations == null || typeof _compareAnnotations === 'boolean')) {
      throw new TypeError('Value of variable "_compareAnnotations" violates contract, expected ?bool got ' + (_compareAnnotations === null ? 'null' : (typeof _compareAnnotations === 'undefined' ? 'undefined' : _typeof(_compareAnnotations)) === 'object' && _compareAnnotations.constructor ? _compareAnnotations.constructor.name || '[Unknown Object]' : typeof _compareAnnotations === 'undefined' ? 'undefined' : _typeof(_compareAnnotations)));
    }

    if (_compareAnnotations == null || typeof _compareAnnotations === 'boolean') {
      return _compareAnnotations;
    } else {
      throw new TypeError('Function "staticCheckAnnotation" return value violates contract, expected ?bool got ' + (_compareAnnotations === null ? 'null' : (typeof _compareAnnotations === 'undefined' ? 'undefined' : _typeof(_compareAnnotations)) === 'object' && _compareAnnotations.constructor ? _compareAnnotations.constructor.name || '[Unknown Object]' : typeof _compareAnnotations === 'undefined' ? 'undefined' : _typeof(_compareAnnotations)));
    }
  }

  /**
   * Get the type annotation for a given node.
   */
  function getAnnotation(path) {
    var _ref23;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var annotation = undefined;
    try {
      annotation = getAnnotationShallow(path);

      if (!(annotation == null || TypeAnnotation(annotation))) {
        throw new TypeError('Value of variable "annotation" violates contract, expected ?TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
      }
    } catch (e) {}
    while (annotation && annotation.type === 'TypeAnnotation') {
      annotation = annotation.typeAnnotation;
    }
    _ref23 = annotation || t.anyTypeAnnotation();

    if (TypeAnnotation(_ref23)) {
      return _ref23;
    } else {
      throw new TypeError('Function "getAnnotation" return value violates contract, expected TypeAnnotation got ' + (_ref23 === null ? 'null' : (typeof _ref23 === 'undefined' ? 'undefined' : _typeof(_ref23)) === 'object' && _ref23.constructor ? _ref23.constructor.name || '[Unknown Object]' : typeof _ref23 === 'undefined' ? 'undefined' : _typeof(_ref23)));
    }
  }

  function getAnnotationShallow(path) {
    var _path$getTypeAnnotati, _path$getTypeAnnotati2, _getAssignmentExpress, _path$getTypeAnnotati3, _ref24;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;

    if (node.type === 'TypeAlias') {
      var _node$right;

      _node$right = node.right;

      if (_node$right == null || TypeAnnotation(_node$right)) {
        return _node$right;
      } else {
        throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_node$right === null ? 'null' : (typeof _node$right === 'undefined' ? 'undefined' : _typeof(_node$right)) === 'object' && _node$right.constructor ? _node$right.constructor.name || '[Unknown Object]' : typeof _node$right === 'undefined' ? 'undefined' : _typeof(_node$right)));
      }
    } else if (!node.typeAnnotation && !node.savedTypeAnnotation && !node.returnType) {
      switch (path.type) {
        case 'Identifier':
          var id = scope.getBindingIdentifier(node.name);
          if (!id) {
            break;
          }
          if (id.savedTypeAnnotation) {
            var _id$savedTypeAnnotati;

            _id$savedTypeAnnotati = id.savedTypeAnnotation;

            if (_id$savedTypeAnnotati == null || TypeAnnotation(_id$savedTypeAnnotati)) {
              return _id$savedTypeAnnotati;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_id$savedTypeAnnotati === null ? 'null' : (typeof _id$savedTypeAnnotati === 'undefined' ? 'undefined' : _typeof(_id$savedTypeAnnotati)) === 'object' && _id$savedTypeAnnotati.constructor ? _id$savedTypeAnnotati.constructor.name || '[Unknown Object]' : typeof _id$savedTypeAnnotati === 'undefined' ? 'undefined' : _typeof(_id$savedTypeAnnotati)));
            }
          } else if (id.returnType) {
            var _id$returnType;

            _id$returnType = id.returnType;

            if (_id$returnType == null || TypeAnnotation(_id$returnType)) {
              return _id$returnType;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_id$returnType === null ? 'null' : (typeof _id$returnType === 'undefined' ? 'undefined' : _typeof(_id$returnType)) === 'object' && _id$returnType.constructor ? _id$returnType.constructor.name || '[Unknown Object]' : typeof _id$returnType === 'undefined' ? 'undefined' : _typeof(_id$returnType)));
            }
          } else if (id.typeAnnotation) {
            var _id$typeAnnotation;

            _id$typeAnnotation = id.typeAnnotation;

            if (_id$typeAnnotation == null || TypeAnnotation(_id$typeAnnotation)) {
              return _id$typeAnnotation;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_id$typeAnnotation === null ? 'null' : (typeof _id$typeAnnotation === 'undefined' ? 'undefined' : _typeof(_id$typeAnnotation)) === 'object' && _id$typeAnnotation.constructor ? _id$typeAnnotation.constructor.name || '[Unknown Object]' : typeof _id$typeAnnotation === 'undefined' ? 'undefined' : _typeof(_id$typeAnnotation)));
            }
          } else if (isPolymorphicType(id, scope)) {
            var _t$anyTypeAnnotation;

            _t$anyTypeAnnotation = t.anyTypeAnnotation();

            if (_t$anyTypeAnnotation == null || TypeAnnotation(_t$anyTypeAnnotation)) {
              return _t$anyTypeAnnotation;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_t$anyTypeAnnotation === null ? 'null' : (typeof _t$anyTypeAnnotation === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation)) === 'object' && _t$anyTypeAnnotation.constructor ? _t$anyTypeAnnotation.constructor.name || '[Unknown Object]' : typeof _t$anyTypeAnnotation === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation)));
            }
          }
          {
            _path$getTypeAnnotati = path.getTypeAnnotation();

            if (_path$getTypeAnnotati == null || TypeAnnotation(_path$getTypeAnnotati)) {
              return _path$getTypeAnnotati;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_path$getTypeAnnotati === null ? 'null' : (typeof _path$getTypeAnnotati === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati)) === 'object' && _path$getTypeAnnotati.constructor ? _path$getTypeAnnotati.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati)));
            }
          }

        case 'NumericLiteral':
        case 'StringLiteral':
        case 'BooleanLiteral':
          {
            _path$getTypeAnnotati2 = path.getTypeAnnotation();

            if (_path$getTypeAnnotati2 == null || TypeAnnotation(_path$getTypeAnnotati2)) {
              return _path$getTypeAnnotati2;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_path$getTypeAnnotati2 === null ? 'null' : (typeof _path$getTypeAnnotati2 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati2)) === 'object' && _path$getTypeAnnotati2.constructor ? _path$getTypeAnnotati2.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati2 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati2)));
            }
          }

        case 'CallExpression':
          var callee = path.get('callee');
          if (callee.type === 'Identifier') {
            if (callee.name === 'Symbol') {
              var _t$genericTypeAnnotat;

              _t$genericTypeAnnotat = t.genericTypeAnnotation('Symbol');

              if (_t$genericTypeAnnotat == null || TypeAnnotation(_t$genericTypeAnnotat)) {
                return _t$genericTypeAnnotat;
              } else {
                throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_t$genericTypeAnnotat === null ? 'null' : (typeof _t$genericTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$genericTypeAnnotat)) === 'object' && _t$genericTypeAnnotat.constructor ? _t$genericTypeAnnotat.constructor.name || '[Unknown Object]' : typeof _t$genericTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$genericTypeAnnotat)));
              }
            }
            var fn = getFunctionForIdentifier(callee);
            if (fn) {
              return getAnnotation(fn);
            }
          }
          break;
        case 'AssignmentExpression':
          {
            _getAssignmentExpress = getAssignmentExpressionAnnotation(path);

            if (!(_getAssignmentExpress == null || TypeAnnotation(_getAssignmentExpress))) {
              throw new TypeError('Value of variable "_getAssignmentExpress" violates contract, expected ?TypeAnnotation got ' + (_getAssignmentExpress === null ? 'null' : (typeof _getAssignmentExpress === 'undefined' ? 'undefined' : _typeof(_getAssignmentExpress)) === 'object' && _getAssignmentExpress.constructor ? _getAssignmentExpress.constructor.name || '[Unknown Object]' : typeof _getAssignmentExpress === 'undefined' ? 'undefined' : _typeof(_getAssignmentExpress)));
            }

            if (_getAssignmentExpress == null || TypeAnnotation(_getAssignmentExpress)) {
              return _getAssignmentExpress;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_getAssignmentExpress === null ? 'null' : (typeof _getAssignmentExpress === 'undefined' ? 'undefined' : _typeof(_getAssignmentExpress)) === 'object' && _getAssignmentExpress.constructor ? _getAssignmentExpress.constructor.name || '[Unknown Object]' : typeof _getAssignmentExpress === 'undefined' ? 'undefined' : _typeof(_getAssignmentExpress)));
            }
          }

        case 'MemberExpression':
          return getMemberExpressionAnnotation(path);
        case 'ArrayExpression':
          return getArrayExpressionAnnotation(path);
        case 'ObjectExpression':
          return getObjectExpressionAnnotation(path);
        case 'BinaryExpression':
          return getBinaryExpressionAnnotation(path);
        case 'BinaryExpression':
          return getBinaryExpressionAnnotation(path);
        case 'LogicalExpression':
          return getLogicalExpressionAnnotation(path);
        case 'ConditionalExpression':
          return getConditionalExpressionAnnotation(path);
        default:
          {
            _path$getTypeAnnotati3 = path.getTypeAnnotation();

            if (_path$getTypeAnnotati3 == null || TypeAnnotation(_path$getTypeAnnotati3)) {
              return _path$getTypeAnnotati3;
            } else {
              throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_path$getTypeAnnotati3 === null ? 'null' : (typeof _path$getTypeAnnotati3 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati3)) === 'object' && _path$getTypeAnnotati3.constructor ? _path$getTypeAnnotati3.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati3 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati3)));
            }
          }

      }
    }
    _ref24 = node.savedTypeAnnotation || node.returnType || node.typeAnnotation || path.getTypeAnnotation();

    if (_ref24 == null || TypeAnnotation(_ref24)) {
      return _ref24;
    } else {
      throw new TypeError('Function "getAnnotationShallow" return value violates contract, expected ?TypeAnnotation got ' + (_ref24 === null ? 'null' : (typeof _ref24 === 'undefined' ? 'undefined' : _typeof(_ref24)) === 'object' && _ref24.constructor ? _ref24.constructor.name || '[Unknown Object]' : typeof _ref24 === 'undefined' ? 'undefined' : _typeof(_ref24)));
    }
  }

  function getObjectMethodAnnotation(path) {
    var _t$functionTypeAnnota;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    _t$functionTypeAnnota = t.functionTypeAnnotation(null, node.params.map(function (param) {
      return param.savedTypeAnnotation || param.typeAnnotation;
    }), null, node.savedTypeAnnotation || node.returnType || node.typeAnnotation || t.anyTypeAnnotation());

    if (_t$functionTypeAnnota == null || TypeAnnotation(_t$functionTypeAnnota)) {
      return _t$functionTypeAnnota;
    } else {
      throw new TypeError('Function "getObjectMethodAnnotation" return value violates contract, expected ?TypeAnnotation got ' + (_t$functionTypeAnnota === null ? 'null' : (typeof _t$functionTypeAnnota === 'undefined' ? 'undefined' : _typeof(_t$functionTypeAnnota)) === 'object' && _t$functionTypeAnnota.constructor ? _t$functionTypeAnnota.constructor.name || '[Unknown Object]' : typeof _t$functionTypeAnnota === 'undefined' ? 'undefined' : _typeof(_t$functionTypeAnnota)));
    }
  }

  function getAssignmentExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (path.node.operator === '=') {
      return getAnnotation(path.get('right'));
    }
  }

  function getBinaryExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;

    if (isBooleanExpression(node)) {
      var _t$booleanTypeAnnotat;

      _t$booleanTypeAnnotat = t.booleanTypeAnnotation();

      if (TypeAnnotation(_t$booleanTypeAnnotat)) {
        return _t$booleanTypeAnnotat;
      } else {
        throw new TypeError('Function "getBinaryExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$booleanTypeAnnotat === null ? 'null' : (typeof _t$booleanTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat)) === 'object' && _t$booleanTypeAnnotat.constructor ? _t$booleanTypeAnnotat.constructor.name || '[Unknown Object]' : typeof _t$booleanTypeAnnotat === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat)));
      }
    } else {
      var _t$anyTypeAnnotation2;

      _t$anyTypeAnnotation2 = t.anyTypeAnnotation();

      if (TypeAnnotation(_t$anyTypeAnnotation2)) {
        return _t$anyTypeAnnotation2;
      } else {
        throw new TypeError('Function "getBinaryExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$anyTypeAnnotation2 === null ? 'null' : (typeof _t$anyTypeAnnotation2 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation2)) === 'object' && _t$anyTypeAnnotation2.constructor ? _t$anyTypeAnnotation2.constructor.name || '[Unknown Object]' : typeof _t$anyTypeAnnotation2 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation2)));
      }
    }
  }

  function getLogicalExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;

    if (isBooleanExpression(node)) {
      var _t$booleanTypeAnnotat2;

      _t$booleanTypeAnnotat2 = t.booleanTypeAnnotation();

      if (TypeAnnotation(_t$booleanTypeAnnotat2)) {
        return _t$booleanTypeAnnotat2;
      } else {
        throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$booleanTypeAnnotat2 === null ? 'null' : (typeof _t$booleanTypeAnnotat2 === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat2)) === 'object' && _t$booleanTypeAnnotat2.constructor ? _t$booleanTypeAnnotat2.constructor.name || '[Unknown Object]' : typeof _t$booleanTypeAnnotat2 === 'undefined' ? 'undefined' : _typeof(_t$booleanTypeAnnotat2)));
      }
    } else {
      var _t$anyTypeAnnotation3;

      var left = path.get('left');
      var right = path.get('right');
      switch (node.operator) {
        case '&&':
        case '||':
          var _ref81 = [getAnnotation(left), getAnnotation(right)];
          left = _ref81[0];
          right = _ref81[1];

          if (t.isUnionTypeAnnotation(left)) {
            if (t.isUnionTypeAnnotation(right)) {
              var _t$unionTypeAnnotatio;

              _t$unionTypeAnnotatio = t.unionTypeAnnotation(left.types.concat(right.types));

              if (TypeAnnotation(_t$unionTypeAnnotatio)) {
                return _t$unionTypeAnnotatio;
              } else {
                throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio === null ? 'null' : (typeof _t$unionTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio)) === 'object' && _t$unionTypeAnnotatio.constructor ? _t$unionTypeAnnotatio.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio)));
              }
            } else {
              var _t$unionTypeAnnotatio2;

              _t$unionTypeAnnotatio2 = t.unionTypeAnnotation(left.types.concat(right));

              if (TypeAnnotation(_t$unionTypeAnnotatio2)) {
                return _t$unionTypeAnnotatio2;
              } else {
                throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio2 === null ? 'null' : (typeof _t$unionTypeAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio2)) === 'object' && _t$unionTypeAnnotatio2.constructor ? _t$unionTypeAnnotatio2.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio2)));
              }
            }
          } else {
            var _t$unionTypeAnnotatio3;

            _t$unionTypeAnnotatio3 = t.unionTypeAnnotation([left, right]);

            if (TypeAnnotation(_t$unionTypeAnnotatio3)) {
              return _t$unionTypeAnnotatio3;
            } else {
              throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio3 === null ? 'null' : (typeof _t$unionTypeAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio3)) === 'object' && _t$unionTypeAnnotatio3.constructor ? _t$unionTypeAnnotatio3.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio3)));
            }
          }
      }
      _t$anyTypeAnnotation3 = t.anyTypeAnnotation();

      if (TypeAnnotation(_t$anyTypeAnnotation3)) {
        return _t$anyTypeAnnotation3;
      } else {
        throw new TypeError('Function "getLogicalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$anyTypeAnnotation3 === null ? 'null' : (typeof _t$anyTypeAnnotation3 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation3)) === 'object' && _t$anyTypeAnnotation3.constructor ? _t$anyTypeAnnotation3.constructor.name || '[Unknown Object]' : typeof _t$anyTypeAnnotation3 === 'undefined' ? 'undefined' : _typeof(_t$anyTypeAnnotation3)));
      }
    }
  }

  function getConditionalExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;

    var consequent = getAnnotation(path.get('consequent'));
    var alternate = getAnnotation(path.get('alternate'));
    if (t.isUnionTypeAnnotation(consequent)) {
      if (t.isUnionTypeAnnotation(alternate)) {
        var _t$unionTypeAnnotatio4;

        _t$unionTypeAnnotatio4 = t.unionTypeAnnotation(consequent.types.concat(alternate.types));

        if (TypeAnnotation(_t$unionTypeAnnotatio4)) {
          return _t$unionTypeAnnotatio4;
        } else {
          throw new TypeError('Function "getConditionalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio4 === null ? 'null' : (typeof _t$unionTypeAnnotatio4 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio4)) === 'object' && _t$unionTypeAnnotatio4.constructor ? _t$unionTypeAnnotatio4.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio4 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio4)));
        }
      } else {
        var _t$unionTypeAnnotatio5;

        _t$unionTypeAnnotatio5 = t.unionTypeAnnotation(consequent.types.concat(alternate));

        if (TypeAnnotation(_t$unionTypeAnnotatio5)) {
          return _t$unionTypeAnnotatio5;
        } else {
          throw new TypeError('Function "getConditionalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio5 === null ? 'null' : (typeof _t$unionTypeAnnotatio5 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio5)) === 'object' && _t$unionTypeAnnotatio5.constructor ? _t$unionTypeAnnotatio5.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio5 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio5)));
        }
      }
    } else {
      var _t$unionTypeAnnotatio6;

      _t$unionTypeAnnotatio6 = t.unionTypeAnnotation([consequent, alternate]);

      if (TypeAnnotation(_t$unionTypeAnnotatio6)) {
        return _t$unionTypeAnnotatio6;
      } else {
        throw new TypeError('Function "getConditionalExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$unionTypeAnnotatio6 === null ? 'null' : (typeof _t$unionTypeAnnotatio6 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio6)) === 'object' && _t$unionTypeAnnotatio6.constructor ? _t$unionTypeAnnotatio6.constructor.name || '[Unknown Object]' : typeof _t$unionTypeAnnotatio6 === 'undefined' ? 'undefined' : _typeof(_t$unionTypeAnnotatio6)));
      }
    }
  }

  function getArrayExpressionAnnotation(path) {
    var _t$genericTypeAnnotat2;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    _t$genericTypeAnnotat2 = t.genericTypeAnnotation(t.identifier('Array'), t.typeParameters(path.get('elements').map(getAnnotation)));

    if (TypeAnnotation(_t$genericTypeAnnotat2)) {
      return _t$genericTypeAnnotat2;
    } else {
      throw new TypeError('Function "getArrayExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_t$genericTypeAnnotat2 === null ? 'null' : (typeof _t$genericTypeAnnotat2 === 'undefined' ? 'undefined' : _typeof(_t$genericTypeAnnotat2)) === 'object' && _t$genericTypeAnnotat2.constructor ? _t$genericTypeAnnotat2.constructor.name || '[Unknown Object]' : typeof _t$genericTypeAnnotat2 === 'undefined' ? 'undefined' : _typeof(_t$genericTypeAnnotat2)));
    }
  }

  function getObjectExpressionAnnotation(path) {
    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var annotation = t.objectTypeAnnotation(path.get('properties').map(function (property) {
      if (property.computed) {
        return;
      }
      switch (property.type) {
        case 'ObjectMethod':
          return t.objectTypeProperty(t.identifier(property.node.key.name), getObjectMethodAnnotation(property));
        case 'ObjectProperty':
          return t.objectTypeProperty(t.identifier(property.node.key.name), property.node.value.savedTypeAnnotation || property.node.value.typeAnnotation || t.anyTypeAnnotation());
      }
    }).filter(identity));

    if (TypeAnnotation(annotation)) {
      return annotation;
    } else {
      throw new TypeError('Function "getObjectExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }
  }

  function getMemberExpressionAnnotation(path) {
    var _path$getTypeAnnotati4;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (path.node.computed) {
      var _getComputedMemberExp;

      _getComputedMemberExp = getComputedMemberExpressionAnnotation(path);

      if (!TypeAnnotation(_getComputedMemberExp)) {
        throw new TypeError('Value of variable "_getComputedMemberExp" violates contract, expected TypeAnnotation got ' + (_getComputedMemberExp === null ? 'null' : (typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)) === 'object' && _getComputedMemberExp.constructor ? _getComputedMemberExp.constructor.name || '[Unknown Object]' : typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)));
      }

      if (TypeAnnotation(_getComputedMemberExp)) {
        return _getComputedMemberExp;
      } else {
        throw new TypeError('Function "getMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_getComputedMemberExp === null ? 'null' : (typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)) === 'object' && _getComputedMemberExp.constructor ? _getComputedMemberExp.constructor.name || '[Unknown Object]' : typeof _getComputedMemberExp === 'undefined' ? 'undefined' : _typeof(_getComputedMemberExp)));
      }
    }
    var object = path.get('object');

    var _path$get = path.get('property');

    var id = _path$get.node;
    var name = id.name;

    var annotation = getAnnotation(object);
    if (annotation.type === 'NullableTypeAnnotation') {
      annotation = annotation.typeAnnotation;
    }
    if (annotation.type === 'GenericTypeAnnotation') {
      var target = path.scope.getBinding(annotation.id.name);
      if (target) {
        annotation = getAnnotation(target.path);

        if (!TypeAnnotation(annotation)) {
          throw new TypeError('Value of variable "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
        }
      }
    }
    switch (annotation.type) {
      case 'ObjectTypeAnnotation':
        var _iteratorNormalCompletion5 = true;
        var _didIteratorError5 = false;
        var _iteratorError5 = undefined;

        try {
          for (var _iterator5 = annotation.properties[Symbol.iterator](), _step5; !(_iteratorNormalCompletion5 = (_step5 = _iterator5.next()).done); _iteratorNormalCompletion5 = true) {
            var _step5$value = _step5.value;
            var key = _step5$value.key;
            var value = _step5$value.value;

            if (key.name === id.name) {
              if (TypeAnnotation(value)) {
                return value;
              } else {
                throw new TypeError('Function "getMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (value === null ? 'null' : (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && value.constructor ? value.constructor.name || '[Unknown Object]' : typeof value === 'undefined' ? 'undefined' : _typeof(value)));
              }
            }
          }
        } catch (err) {
          _didIteratorError5 = true;
          _iteratorError5 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion5 && _iterator5.return) {
              _iterator5.return();
            }
          } finally {
            if (_didIteratorError5) {
              throw _iteratorError5;
            }
          }
        }

        break;
    }
    _path$getTypeAnnotati4 = path.getTypeAnnotation();

    if (TypeAnnotation(_path$getTypeAnnotati4)) {
      return _path$getTypeAnnotati4;
    } else {
      throw new TypeError('Function "getMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_path$getTypeAnnotati4 === null ? 'null' : (typeof _path$getTypeAnnotati4 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati4)) === 'object' && _path$getTypeAnnotati4.constructor ? _path$getTypeAnnotati4.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati4 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati4)));
    }
  }

  function getComputedMemberExpressionAnnotation(path) {
    var _path$getTypeAnnotati6;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var object = path.get('object');
    var property = path.get('property');
    var objectAnnotation = getAnnotation(object);
    if (objectAnnotation.type === 'TypeAnnotation' || objectAnnotation.type === 'NullableTypeAnnotation') {
      objectAnnotation = objectAnnotation.typeAnnotation;
    }
    var propertyAnnotation = getAnnotation(property);
    if (propertyAnnotation.type === 'TypeAnnotation' || propertyAnnotation.type === 'NullableTypeAnnotation') {
      propertyAnnotation = propertyAnnotation.typeAnnotation;
    }

    var _property$evaluate = property.evaluate();

    var confident = _property$evaluate.confident;
    var value = _property$evaluate.value;

    if (!confident) {
      var _path$getTypeAnnotati5;

      _path$getTypeAnnotati5 = path.getTypeAnnotation();

      if (TypeAnnotation(_path$getTypeAnnotati5)) {
        return _path$getTypeAnnotati5;
      } else {
        throw new TypeError('Function "getComputedMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_path$getTypeAnnotati5 === null ? 'null' : (typeof _path$getTypeAnnotati5 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati5)) === 'object' && _path$getTypeAnnotati5.constructor ? _path$getTypeAnnotati5.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati5 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati5)));
      }
    }
    switch (objectAnnotation.type) {
      case 'TupleTypeAnnotation':
        if (objectAnnotation.types.length === 0) {
          break;
        } else if (typeof value === 'number') {
          var _objectAnnotation$typ;

          if (!objectAnnotation.types[value]) {
            throw path.buildCodeFrameError('Invalid computed member expression for tuple: ' + humanReadableType(objectAnnotation, path.scope));
          }
          _objectAnnotation$typ = objectAnnotation.types[value];

          if (TypeAnnotation(_objectAnnotation$typ)) {
            return _objectAnnotation$typ;
          } else {
            throw new TypeError('Function "getComputedMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_objectAnnotation$typ === null ? 'null' : (typeof _objectAnnotation$typ === 'undefined' ? 'undefined' : _typeof(_objectAnnotation$typ)) === 'object' && _objectAnnotation$typ.constructor ? _objectAnnotation$typ.constructor.name || '[Unknown Object]' : typeof _objectAnnotation$typ === 'undefined' ? 'undefined' : _typeof(_objectAnnotation$typ)));
          }
        } else {
          throw path.buildCodeFrameError('Invalid computed member expression for tuple: ' + humanReadableType(objectAnnotation, path.scope));
        }
        break;
    }
    _path$getTypeAnnotati6 = path.getTypeAnnotation();

    if (TypeAnnotation(_path$getTypeAnnotati6)) {
      return _path$getTypeAnnotati6;
    } else {
      throw new TypeError('Function "getComputedMemberExpressionAnnotation" return value violates contract, expected TypeAnnotation got ' + (_path$getTypeAnnotati6 === null ? 'null' : (typeof _path$getTypeAnnotati6 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati6)) === 'object' && _path$getTypeAnnotati6.constructor ? _path$getTypeAnnotati6.constructor.name || '[Unknown Object]' : typeof _path$getTypeAnnotati6 === 'undefined' ? 'undefined' : _typeof(_path$getTypeAnnotati6)));
    }
  }

  function getFunctionForIdentifier(path) {
    var _ref25;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (path.type !== 'Identifier') {
      return false;
    }
    var ref = path.scope.getBinding(path.node.name);
    if (!ref) {
      return false;
    }
    _ref25 = t.isFunction(ref.path.parent) && ref.path.parentPath;

    if (typeof _ref25 === 'boolean' || Node(_ref25)) {
      return _ref25;
    } else {
      throw new TypeError('Function "getFunctionForIdentifier" return value violates contract, expected bool | Node got ' + (_ref25 === null ? 'null' : (typeof _ref25 === 'undefined' ? 'undefined' : _typeof(_ref25)) === 'object' && _ref25.constructor ? _ref25.constructor.name || '[Unknown Object]' : typeof _ref25 === 'undefined' ? 'undefined' : _typeof(_ref25)));
    }
  }

  /**
   * Returns `true` if the annotation is definitely for an array,
   * otherwise `false`.
   */
  function isStrictlyArrayAnnotation(annotation) {
    var _annotation$types$eve;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return isStrictlyArrayAnnotation(annotation.typeAnnotation);
      case 'GenericTypeAnnotation':
        return annotation.id.name === 'Array';
      case 'UnionTypeAnnotation':
        {
          _annotation$types$eve = annotation.types.every(isStrictlyArrayAnnotation);

          if (typeof _annotation$types$eve === 'boolean') {
            return _annotation$types$eve;
          } else {
            throw new TypeError('Function "isStrictlyArrayAnnotation" return value violates contract, expected bool got ' + (_annotation$types$eve === null ? 'null' : (typeof _annotation$types$eve === 'undefined' ? 'undefined' : _typeof(_annotation$types$eve)) === 'object' && _annotation$types$eve.constructor ? _annotation$types$eve.constructor.name || '[Unknown Object]' : typeof _annotation$types$eve === 'undefined' ? 'undefined' : _typeof(_annotation$types$eve)));
          }
        }

      default:
        return false;
    }
  }

  function compareMaybeUnion(annotation, comparator) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!(typeof comparator === 'function')) {
      throw new TypeError('Value of argument "comparator" violates contract, expected (node: TypeAnnotation) => ?bool got ' + (comparator === null ? 'null' : (typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)) === 'object' && comparator.constructor ? comparator.constructor.name || '[Unknown Object]' : typeof comparator === 'undefined' ? 'undefined' : _typeof(comparator)));
    }

    var falseCount = 0;
    var _iteratorNormalCompletion6 = true;
    var _didIteratorError6 = false;
    var _iteratorError6 = undefined;

    try {
      for (var _iterator6 = annotation.types[Symbol.iterator](), _step6; !(_iteratorNormalCompletion6 = (_step6 = _iterator6.next()).done); _iteratorNormalCompletion6 = true) {
        var _type7 = _step6.value;

        var result = comparator(_type7);
        if (result === true) {
          return true;
        } else if (result === false) {
          falseCount++;
        }
      }
    } catch (err) {
      _didIteratorError6 = true;
      _iteratorError6 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion6 && _iterator6.return) {
          _iterator6.return();
        }
      } finally {
        if (_didIteratorError6) {
          throw _iteratorError6;
        }
      }
    }

    if (falseCount === annotation.types.length) {
      return false;
    } else {
      var _ref27;

      _ref27 = null;

      if (!(_ref27 == null)) {
        throw new TypeError('Value of variable "_ref27" violates contract, expected void got ' + (_ref27 === null ? 'null' : (typeof _ref27 === 'undefined' ? 'undefined' : _typeof(_ref27)) === 'object' && _ref27.constructor ? _ref27.constructor.name || '[Unknown Object]' : typeof _ref27 === 'undefined' ? 'undefined' : _typeof(_ref27)));
      }

      if (_ref27 == null || typeof _ref27 === 'boolean') {
        return _ref27;
      } else {
        throw new TypeError('Function "compareMaybeUnion" return value violates contract, expected ?bool got ' + (_ref27 === null ? 'null' : (typeof _ref27 === 'undefined' ? 'undefined' : _typeof(_ref27)) === 'object' && _ref27.constructor ? _ref27.constructor.name || '[Unknown Object]' : typeof _ref27 === 'undefined' ? 'undefined' : _typeof(_ref27)));
      }
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a number,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeNumberAnnotation(annotation) {
    var _maybeNumberAnnotatio3, _ref28, _compareMaybeUnion, _ref29;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeNumberAnnotatio3 = maybeNumberAnnotation(annotation.typeAnnotation);

          if (!(_maybeNumberAnnotatio3 == null || typeof _maybeNumberAnnotatio3 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeNumberAnnotatio3" violates contract, expected ?bool got ' + (_maybeNumberAnnotatio3 === null ? 'null' : (typeof _maybeNumberAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio3)) === 'object' && _maybeNumberAnnotatio3.constructor ? _maybeNumberAnnotatio3.constructor.name || '[Unknown Object]' : typeof _maybeNumberAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio3)));
          }

          if (_maybeNumberAnnotatio3 == null || typeof _maybeNumberAnnotatio3 === 'boolean') {
            return _maybeNumberAnnotatio3;
          } else {
            throw new TypeError('Function "maybeNumberAnnotation" return value violates contract, expected ?bool got ' + (_maybeNumberAnnotatio3 === null ? 'null' : (typeof _maybeNumberAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio3)) === 'object' && _maybeNumberAnnotatio3.constructor ? _maybeNumberAnnotatio3.constructor.name || '[Unknown Object]' : typeof _maybeNumberAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeNumberAnnotatio3)));
          }
        }

      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Function':
          case 'Object':
          case 'String':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            {
              _ref28 = null;

              if (!(_ref28 == null)) {
                throw new TypeError('Value of variable "_ref28" violates contract, expected void got ' + (_ref28 === null ? 'null' : (typeof _ref28 === 'undefined' ? 'undefined' : _typeof(_ref28)) === 'object' && _ref28.constructor ? _ref28.constructor.name || '[Unknown Object]' : typeof _ref28 === 'undefined' ? 'undefined' : _typeof(_ref28)));
              }

              if (_ref28 == null || typeof _ref28 === 'boolean') {
                return _ref28;
              } else {
                throw new TypeError('Function "maybeNumberAnnotation" return value violates contract, expected ?bool got ' + (_ref28 === null ? 'null' : (typeof _ref28 === 'undefined' ? 'undefined' : _typeof(_ref28)) === 'object' && _ref28.constructor ? _ref28.constructor.name || '[Unknown Object]' : typeof _ref28 === 'undefined' ? 'undefined' : _typeof(_ref28)));
              }
            }

        }
      case 'UnionTypeAnnotation':
        {
          _compareMaybeUnion = compareMaybeUnion(annotation, maybeNumberAnnotation);

          if (!(_compareMaybeUnion == null || typeof _compareMaybeUnion === 'boolean')) {
            throw new TypeError('Value of variable "_compareMaybeUnion" violates contract, expected ?bool got ' + (_compareMaybeUnion === null ? 'null' : (typeof _compareMaybeUnion === 'undefined' ? 'undefined' : _typeof(_compareMaybeUnion)) === 'object' && _compareMaybeUnion.constructor ? _compareMaybeUnion.constructor.name || '[Unknown Object]' : typeof _compareMaybeUnion === 'undefined' ? 'undefined' : _typeof(_compareMaybeUnion)));
          }

          if (_compareMaybeUnion == null || typeof _compareMaybeUnion === 'boolean') {
            return _compareMaybeUnion;
          } else {
            throw new TypeError('Function "maybeNumberAnnotation" return value violates contract, expected ?bool got ' + (_compareMaybeUnion === null ? 'null' : (typeof _compareMaybeUnion === 'undefined' ? 'undefined' : _typeof(_compareMaybeUnion)) === 'object' && _compareMaybeUnion.constructor ? _compareMaybeUnion.constructor.name || '[Unknown Object]' : typeof _compareMaybeUnion === 'undefined' ? 'undefined' : _typeof(_compareMaybeUnion)));
          }
        }

      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        {
          _ref29 = null;

          if (!(_ref29 == null)) {
            throw new TypeError('Value of variable "_ref29" violates contract, expected void got ' + (_ref29 === null ? 'null' : (typeof _ref29 === 'undefined' ? 'undefined' : _typeof(_ref29)) === 'object' && _ref29.constructor ? _ref29.constructor.name || '[Unknown Object]' : typeof _ref29 === 'undefined' ? 'undefined' : _typeof(_ref29)));
          }

          if (_ref29 == null || typeof _ref29 === 'boolean') {
            return _ref29;
          } else {
            throw new TypeError('Function "maybeNumberAnnotation" return value violates contract, expected ?bool got ' + (_ref29 === null ? 'null' : (typeof _ref29 === 'undefined' ? 'undefined' : _typeof(_ref29)) === 'object' && _ref29.constructor ? _ref29.constructor.name || '[Unknown Object]' : typeof _ref29 === 'undefined' ? 'undefined' : _typeof(_ref29)));
          }
        }

      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a string,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeStringAnnotation(annotation) {
    var _maybeStringAnnotatio3, _ref30, _ref32;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeStringAnnotatio3 = maybeStringAnnotation(annotation.typeAnnotation);

          if (!(_maybeStringAnnotatio3 == null || typeof _maybeStringAnnotatio3 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeStringAnnotatio3" violates contract, expected ?bool got ' + (_maybeStringAnnotatio3 === null ? 'null' : (typeof _maybeStringAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio3)) === 'object' && _maybeStringAnnotatio3.constructor ? _maybeStringAnnotatio3.constructor.name || '[Unknown Object]' : typeof _maybeStringAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio3)));
          }

          if (_maybeStringAnnotatio3 == null || typeof _maybeStringAnnotatio3 === 'boolean') {
            return _maybeStringAnnotatio3;
          } else {
            throw new TypeError('Function "maybeStringAnnotation" return value violates contract, expected ?bool got ' + (_maybeStringAnnotatio3 === null ? 'null' : (typeof _maybeStringAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio3)) === 'object' && _maybeStringAnnotatio3.constructor ? _maybeStringAnnotatio3.constructor.name || '[Unknown Object]' : typeof _maybeStringAnnotatio3 === 'undefined' ? 'undefined' : _typeof(_maybeStringAnnotatio3)));
          }
        }

      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Function':
          case 'Object':
          case 'Number':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            {
              _ref30 = null;

              if (!(_ref30 == null)) {
                throw new TypeError('Value of variable "_ref30" violates contract, expected void got ' + (_ref30 === null ? 'null' : (typeof _ref30 === 'undefined' ? 'undefined' : _typeof(_ref30)) === 'object' && _ref30.constructor ? _ref30.constructor.name || '[Unknown Object]' : typeof _ref30 === 'undefined' ? 'undefined' : _typeof(_ref30)));
              }

              if (_ref30 == null || typeof _ref30 === 'boolean') {
                return _ref30;
              } else {
                throw new TypeError('Function "maybeStringAnnotation" return value violates contract, expected ?bool got ' + (_ref30 === null ? 'null' : (typeof _ref30 === 'undefined' ? 'undefined' : _typeof(_ref30)) === 'object' && _ref30.constructor ? _ref30.constructor.name || '[Unknown Object]' : typeof _ref30 === 'undefined' ? 'undefined' : _typeof(_ref30)));
              }
            }

        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion7 = true;
        var _didIteratorError7 = false;
        var _iteratorError7 = undefined;

        try {
          for (var _iterator7 = annotation.types[Symbol.iterator](), _step7; !(_iteratorNormalCompletion7 = (_step7 = _iterator7.next()).done); _iteratorNormalCompletion7 = true) {
            var _type8 = _step7.value;

            var result = maybeStringAnnotation(_type8);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError7 = true;
          _iteratorError7 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion7 && _iterator7.return) {
              _iterator7.return();
            }
          } finally {
            if (_didIteratorError7) {
              throw _iteratorError7;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref31;

          _ref31 = null;

          if (!(_ref31 == null)) {
            throw new TypeError('Value of variable "_ref31" violates contract, expected void got ' + (_ref31 === null ? 'null' : (typeof _ref31 === 'undefined' ? 'undefined' : _typeof(_ref31)) === 'object' && _ref31.constructor ? _ref31.constructor.name || '[Unknown Object]' : typeof _ref31 === 'undefined' ? 'undefined' : _typeof(_ref31)));
          }

          if (_ref31 == null || typeof _ref31 === 'boolean') {
            return _ref31;
          } else {
            throw new TypeError('Function "maybeStringAnnotation" return value violates contract, expected ?bool got ' + (_ref31 === null ? 'null' : (typeof _ref31 === 'undefined' ? 'undefined' : _typeof(_ref31)) === 'object' && _ref31.constructor ? _ref31.constructor.name || '[Unknown Object]' : typeof _ref31 === 'undefined' ? 'undefined' : _typeof(_ref31)));
          }
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        {
          _ref32 = null;

          if (!(_ref32 == null)) {
            throw new TypeError('Value of variable "_ref32" violates contract, expected void got ' + (_ref32 === null ? 'null' : (typeof _ref32 === 'undefined' ? 'undefined' : _typeof(_ref32)) === 'object' && _ref32.constructor ? _ref32.constructor.name || '[Unknown Object]' : typeof _ref32 === 'undefined' ? 'undefined' : _typeof(_ref32)));
          }

          if (_ref32 == null || typeof _ref32 === 'boolean') {
            return _ref32;
          } else {
            throw new TypeError('Function "maybeStringAnnotation" return value violates contract, expected ?bool got ' + (_ref32 === null ? 'null' : (typeof _ref32 === 'undefined' ? 'undefined' : _typeof(_ref32)) === 'object' && _ref32.constructor ? _ref32.constructor.name || '[Unknown Object]' : typeof _ref32 === 'undefined' ? 'undefined' : _typeof(_ref32)));
          }
        }

      default:
        return false;
    }
  }

  /**
     * Returns `true` if the annotation is compatible with a symbol,
     * `false` if it definitely isn't, or `null` if we're not sure.
     */
  function maybeSymbolAnnotation(annotation) {
    var _maybeSymbolAnnotatio2, _ref33, _ref35;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeSymbolAnnotatio2 = maybeSymbolAnnotation(annotation.typeAnnotation);

          if (!(_maybeSymbolAnnotatio2 == null || typeof _maybeSymbolAnnotatio2 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeSymbolAnnotatio2" violates contract, expected ?bool got ' + (_maybeSymbolAnnotatio2 === null ? 'null' : (typeof _maybeSymbolAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio2)) === 'object' && _maybeSymbolAnnotatio2.constructor ? _maybeSymbolAnnotatio2.constructor.name || '[Unknown Object]' : typeof _maybeSymbolAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio2)));
          }

          if (_maybeSymbolAnnotatio2 == null || typeof _maybeSymbolAnnotatio2 === 'boolean') {
            return _maybeSymbolAnnotatio2;
          } else {
            throw new TypeError('Function "maybeSymbolAnnotation" return value violates contract, expected ?bool got ' + (_maybeSymbolAnnotatio2 === null ? 'null' : (typeof _maybeSymbolAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio2)) === 'object' && _maybeSymbolAnnotatio2.constructor ? _maybeSymbolAnnotatio2.constructor.name || '[Unknown Object]' : typeof _maybeSymbolAnnotatio2 === 'undefined' ? 'undefined' : _typeof(_maybeSymbolAnnotatio2)));
          }
        }

      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Function':
          case 'Object':
          case 'Number':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          case 'Symbol':
            return true;
          default:
            {
              _ref33 = null;

              if (!(_ref33 == null)) {
                throw new TypeError('Value of variable "_ref33" violates contract, expected void got ' + (_ref33 === null ? 'null' : (typeof _ref33 === 'undefined' ? 'undefined' : _typeof(_ref33)) === 'object' && _ref33.constructor ? _ref33.constructor.name || '[Unknown Object]' : typeof _ref33 === 'undefined' ? 'undefined' : _typeof(_ref33)));
              }

              if (_ref33 == null || typeof _ref33 === 'boolean') {
                return _ref33;
              } else {
                throw new TypeError('Function "maybeSymbolAnnotation" return value violates contract, expected ?bool got ' + (_ref33 === null ? 'null' : (typeof _ref33 === 'undefined' ? 'undefined' : _typeof(_ref33)) === 'object' && _ref33.constructor ? _ref33.constructor.name || '[Unknown Object]' : typeof _ref33 === 'undefined' ? 'undefined' : _typeof(_ref33)));
              }
            }

        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion8 = true;
        var _didIteratorError8 = false;
        var _iteratorError8 = undefined;

        try {
          for (var _iterator8 = annotation.types[Symbol.iterator](), _step8; !(_iteratorNormalCompletion8 = (_step8 = _iterator8.next()).done); _iteratorNormalCompletion8 = true) {
            var _type9 = _step8.value;

            var result = maybeSymbolAnnotation(_type9);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError8 = true;
          _iteratorError8 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion8 && _iterator8.return) {
              _iterator8.return();
            }
          } finally {
            if (_didIteratorError8) {
              throw _iteratorError8;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref34;

          _ref34 = null;

          if (!(_ref34 == null)) {
            throw new TypeError('Value of variable "_ref34" violates contract, expected void got ' + (_ref34 === null ? 'null' : (typeof _ref34 === 'undefined' ? 'undefined' : _typeof(_ref34)) === 'object' && _ref34.constructor ? _ref34.constructor.name || '[Unknown Object]' : typeof _ref34 === 'undefined' ? 'undefined' : _typeof(_ref34)));
          }

          if (_ref34 == null || typeof _ref34 === 'boolean') {
            return _ref34;
          } else {
            throw new TypeError('Function "maybeSymbolAnnotation" return value violates contract, expected ?bool got ' + (_ref34 === null ? 'null' : (typeof _ref34 === 'undefined' ? 'undefined' : _typeof(_ref34)) === 'object' && _ref34.constructor ? _ref34.constructor.name || '[Unknown Object]' : typeof _ref34 === 'undefined' ? 'undefined' : _typeof(_ref34)));
          }
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        {
          _ref35 = null;

          if (!(_ref35 == null)) {
            throw new TypeError('Value of variable "_ref35" violates contract, expected void got ' + (_ref35 === null ? 'null' : (typeof _ref35 === 'undefined' ? 'undefined' : _typeof(_ref35)) === 'object' && _ref35.constructor ? _ref35.constructor.name || '[Unknown Object]' : typeof _ref35 === 'undefined' ? 'undefined' : _typeof(_ref35)));
          }

          if (_ref35 == null || typeof _ref35 === 'boolean') {
            return _ref35;
          } else {
            throw new TypeError('Function "maybeSymbolAnnotation" return value violates contract, expected ?bool got ' + (_ref35 === null ? 'null' : (typeof _ref35 === 'undefined' ? 'undefined' : _typeof(_ref35)) === 'object' && _ref35.constructor ? _ref35.constructor.name || '[Unknown Object]' : typeof _ref35 === 'undefined' ? 'undefined' : _typeof(_ref35)));
          }
        }

      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a boolean,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeBooleanAnnotation(annotation) {
    var _maybeBooleanAnnotati3, _ref36, _ref38;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeBooleanAnnotati3 = maybeBooleanAnnotation(annotation.typeAnnotation);

          if (!(_maybeBooleanAnnotati3 == null || typeof _maybeBooleanAnnotati3 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeBooleanAnnotati3" violates contract, expected ?bool got ' + (_maybeBooleanAnnotati3 === null ? 'null' : (typeof _maybeBooleanAnnotati3 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati3)) === 'object' && _maybeBooleanAnnotati3.constructor ? _maybeBooleanAnnotati3.constructor.name || '[Unknown Object]' : typeof _maybeBooleanAnnotati3 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati3)));
          }

          if (_maybeBooleanAnnotati3 == null || typeof _maybeBooleanAnnotati3 === 'boolean') {
            return _maybeBooleanAnnotati3;
          } else {
            throw new TypeError('Function "maybeBooleanAnnotation" return value violates contract, expected ?bool got ' + (_maybeBooleanAnnotati3 === null ? 'null' : (typeof _maybeBooleanAnnotati3 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati3)) === 'object' && _maybeBooleanAnnotati3.constructor ? _maybeBooleanAnnotati3.constructor.name || '[Unknown Object]' : typeof _maybeBooleanAnnotati3 === 'undefined' ? 'undefined' : _typeof(_maybeBooleanAnnotati3)));
          }
        }

      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Function':
          case 'Object':
          case 'String':
          case 'Number':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            {
              _ref36 = null;

              if (!(_ref36 == null)) {
                throw new TypeError('Value of variable "_ref36" violates contract, expected void got ' + (_ref36 === null ? 'null' : (typeof _ref36 === 'undefined' ? 'undefined' : _typeof(_ref36)) === 'object' && _ref36.constructor ? _ref36.constructor.name || '[Unknown Object]' : typeof _ref36 === 'undefined' ? 'undefined' : _typeof(_ref36)));
              }

              if (_ref36 == null || typeof _ref36 === 'boolean') {
                return _ref36;
              } else {
                throw new TypeError('Function "maybeBooleanAnnotation" return value violates contract, expected ?bool got ' + (_ref36 === null ? 'null' : (typeof _ref36 === 'undefined' ? 'undefined' : _typeof(_ref36)) === 'object' && _ref36.constructor ? _ref36.constructor.name || '[Unknown Object]' : typeof _ref36 === 'undefined' ? 'undefined' : _typeof(_ref36)));
              }
            }

        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion9 = true;
        var _didIteratorError9 = false;
        var _iteratorError9 = undefined;

        try {
          for (var _iterator9 = annotation.types[Symbol.iterator](), _step9; !(_iteratorNormalCompletion9 = (_step9 = _iterator9.next()).done); _iteratorNormalCompletion9 = true) {
            var _type10 = _step9.value;

            var result = maybeBooleanAnnotation(_type10);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError9 = true;
          _iteratorError9 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion9 && _iterator9.return) {
              _iterator9.return();
            }
          } finally {
            if (_didIteratorError9) {
              throw _iteratorError9;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref37;

          _ref37 = null;

          if (!(_ref37 == null)) {
            throw new TypeError('Value of variable "_ref37" violates contract, expected void got ' + (_ref37 === null ? 'null' : (typeof _ref37 === 'undefined' ? 'undefined' : _typeof(_ref37)) === 'object' && _ref37.constructor ? _ref37.constructor.name || '[Unknown Object]' : typeof _ref37 === 'undefined' ? 'undefined' : _typeof(_ref37)));
          }

          if (_ref37 == null || typeof _ref37 === 'boolean') {
            return _ref37;
          } else {
            throw new TypeError('Function "maybeBooleanAnnotation" return value violates contract, expected ?bool got ' + (_ref37 === null ? 'null' : (typeof _ref37 === 'undefined' ? 'undefined' : _typeof(_ref37)) === 'object' && _ref37.constructor ? _ref37.constructor.name || '[Unknown Object]' : typeof _ref37 === 'undefined' ? 'undefined' : _typeof(_ref37)));
          }
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        {
          _ref38 = null;

          if (!(_ref38 == null)) {
            throw new TypeError('Value of variable "_ref38" violates contract, expected void got ' + (_ref38 === null ? 'null' : (typeof _ref38 === 'undefined' ? 'undefined' : _typeof(_ref38)) === 'object' && _ref38.constructor ? _ref38.constructor.name || '[Unknown Object]' : typeof _ref38 === 'undefined' ? 'undefined' : _typeof(_ref38)));
          }

          if (_ref38 == null || typeof _ref38 === 'boolean') {
            return _ref38;
          } else {
            throw new TypeError('Function "maybeBooleanAnnotation" return value violates contract, expected ?bool got ' + (_ref38 === null ? 'null' : (typeof _ref38 === 'undefined' ? 'undefined' : _typeof(_ref38)) === 'object' && _ref38.constructor ? _ref38.constructor.name || '[Unknown Object]' : typeof _ref38 === 'undefined' ? 'undefined' : _typeof(_ref38)));
          }
        }

      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a function,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeFunctionAnnotation(annotation) {
    var _maybeFunctionAnnotat3, _ref39, _ref41;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeFunctionAnnotat3 = maybeFunctionAnnotation(annotation.typeAnnotation);

          if (!(_maybeFunctionAnnotat3 == null || typeof _maybeFunctionAnnotat3 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeFunctionAnnotat3" violates contract, expected ?bool got ' + (_maybeFunctionAnnotat3 === null ? 'null' : (typeof _maybeFunctionAnnotat3 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat3)) === 'object' && _maybeFunctionAnnotat3.constructor ? _maybeFunctionAnnotat3.constructor.name || '[Unknown Object]' : typeof _maybeFunctionAnnotat3 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat3)));
          }

          if (_maybeFunctionAnnotat3 == null || typeof _maybeFunctionAnnotat3 === 'boolean') {
            return _maybeFunctionAnnotat3;
          } else {
            throw new TypeError('Function "maybeFunctionAnnotation" return value violates contract, expected ?bool got ' + (_maybeFunctionAnnotat3 === null ? 'null' : (typeof _maybeFunctionAnnotat3 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat3)) === 'object' && _maybeFunctionAnnotat3.constructor ? _maybeFunctionAnnotat3.constructor.name || '[Unknown Object]' : typeof _maybeFunctionAnnotat3 === 'undefined' ? 'undefined' : _typeof(_maybeFunctionAnnotat3)));
          }
        }

      case 'FunctionTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Number':
          case 'Object':
          case 'String':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            {
              _ref39 = null;

              if (!(_ref39 == null)) {
                throw new TypeError('Value of variable "_ref39" violates contract, expected void got ' + (_ref39 === null ? 'null' : (typeof _ref39 === 'undefined' ? 'undefined' : _typeof(_ref39)) === 'object' && _ref39.constructor ? _ref39.constructor.name || '[Unknown Object]' : typeof _ref39 === 'undefined' ? 'undefined' : _typeof(_ref39)));
              }

              if (_ref39 == null || typeof _ref39 === 'boolean') {
                return _ref39;
              } else {
                throw new TypeError('Function "maybeFunctionAnnotation" return value violates contract, expected ?bool got ' + (_ref39 === null ? 'null' : (typeof _ref39 === 'undefined' ? 'undefined' : _typeof(_ref39)) === 'object' && _ref39.constructor ? _ref39.constructor.name || '[Unknown Object]' : typeof _ref39 === 'undefined' ? 'undefined' : _typeof(_ref39)));
              }
            }

        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion10 = true;
        var _didIteratorError10 = false;
        var _iteratorError10 = undefined;

        try {
          for (var _iterator10 = annotation.types[Symbol.iterator](), _step10; !(_iteratorNormalCompletion10 = (_step10 = _iterator10.next()).done); _iteratorNormalCompletion10 = true) {
            var _type11 = _step10.value;

            var result = maybeFunctionAnnotation(_type11);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError10 = true;
          _iteratorError10 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion10 && _iterator10.return) {
              _iterator10.return();
            }
          } finally {
            if (_didIteratorError10) {
              throw _iteratorError10;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref40;

          _ref40 = null;

          if (!(_ref40 == null)) {
            throw new TypeError('Value of variable "_ref40" violates contract, expected void got ' + (_ref40 === null ? 'null' : (typeof _ref40 === 'undefined' ? 'undefined' : _typeof(_ref40)) === 'object' && _ref40.constructor ? _ref40.constructor.name || '[Unknown Object]' : typeof _ref40 === 'undefined' ? 'undefined' : _typeof(_ref40)));
          }

          if (_ref40 == null || typeof _ref40 === 'boolean') {
            return _ref40;
          } else {
            throw new TypeError('Function "maybeFunctionAnnotation" return value violates contract, expected ?bool got ' + (_ref40 === null ? 'null' : (typeof _ref40 === 'undefined' ? 'undefined' : _typeof(_ref40)) === 'object' && _ref40.constructor ? _ref40.constructor.name || '[Unknown Object]' : typeof _ref40 === 'undefined' ? 'undefined' : _typeof(_ref40)));
          }
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        {
          _ref41 = null;

          if (!(_ref41 == null)) {
            throw new TypeError('Value of variable "_ref41" violates contract, expected void got ' + (_ref41 === null ? 'null' : (typeof _ref41 === 'undefined' ? 'undefined' : _typeof(_ref41)) === 'object' && _ref41.constructor ? _ref41.constructor.name || '[Unknown Object]' : typeof _ref41 === 'undefined' ? 'undefined' : _typeof(_ref41)));
          }

          if (_ref41 == null || typeof _ref41 === 'boolean') {
            return _ref41;
          } else {
            throw new TypeError('Function "maybeFunctionAnnotation" return value violates contract, expected ?bool got ' + (_ref41 === null ? 'null' : (typeof _ref41 === 'undefined' ? 'undefined' : _typeof(_ref41)) === 'object' && _ref41.constructor ? _ref41.constructor.name || '[Unknown Object]' : typeof _ref41 === 'undefined' ? 'undefined' : _typeof(_ref41)));
          }
        }

      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with an undefined or null type,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeNullableAnnotation(annotation) {
    var _maybeNullableAnnotat, _ref42;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'NullableTypeAnnotation':
      case 'VoidTypeAnnotation':
      case 'MixedTypeAnnotation':
        return true;
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        {
          _maybeNullableAnnotat = maybeNullableAnnotation(annotation.typeAnnotation);

          if (!(_maybeNullableAnnotat == null || typeof _maybeNullableAnnotat === 'boolean')) {
            throw new TypeError('Value of variable "_maybeNullableAnnotat" violates contract, expected ?bool got ' + (_maybeNullableAnnotat === null ? 'null' : (typeof _maybeNullableAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeNullableAnnotat)) === 'object' && _maybeNullableAnnotat.constructor ? _maybeNullableAnnotat.constructor.name || '[Unknown Object]' : typeof _maybeNullableAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeNullableAnnotat)));
          }

          if (_maybeNullableAnnotat == null || typeof _maybeNullableAnnotat === 'boolean') {
            return _maybeNullableAnnotat;
          } else {
            throw new TypeError('Function "maybeNullableAnnotation" return value violates contract, expected ?bool got ' + (_maybeNullableAnnotat === null ? 'null' : (typeof _maybeNullableAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeNullableAnnotat)) === 'object' && _maybeNullableAnnotat.constructor ? _maybeNullableAnnotat.constructor.name || '[Unknown Object]' : typeof _maybeNullableAnnotat === 'undefined' ? 'undefined' : _typeof(_maybeNullableAnnotat)));
          }
        }

      case 'GenericTypeAnnotation':
        switch (annotation.id.name) {
          case 'Array':
          case 'Number':
          case 'Object':
          case 'String':
          case 'Boolean':
          case 'Date':
          case 'RegExp':
            return false;
          default:
            {
              _ref42 = null;

              if (!(_ref42 == null)) {
                throw new TypeError('Value of variable "_ref42" violates contract, expected void got ' + (_ref42 === null ? 'null' : (typeof _ref42 === 'undefined' ? 'undefined' : _typeof(_ref42)) === 'object' && _ref42.constructor ? _ref42.constructor.name || '[Unknown Object]' : typeof _ref42 === 'undefined' ? 'undefined' : _typeof(_ref42)));
              }

              if (_ref42 == null || typeof _ref42 === 'boolean') {
                return _ref42;
              } else {
                throw new TypeError('Function "maybeNullableAnnotation" return value violates contract, expected ?bool got ' + (_ref42 === null ? 'null' : (typeof _ref42 === 'undefined' ? 'undefined' : _typeof(_ref42)) === 'object' && _ref42.constructor ? _ref42.constructor.name || '[Unknown Object]' : typeof _ref42 === 'undefined' ? 'undefined' : _typeof(_ref42)));
              }
            }

        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion11 = true;
        var _didIteratorError11 = false;
        var _iteratorError11 = undefined;

        try {
          for (var _iterator11 = annotation.types[Symbol.iterator](), _step11; !(_iteratorNormalCompletion11 = (_step11 = _iterator11.next()).done); _iteratorNormalCompletion11 = true) {
            var _type12 = _step11.value;

            var result = maybeNullableAnnotation(_type12);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError11 = true;
          _iteratorError11 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion11 && _iterator11.return) {
              _iterator11.return();
            }
          } finally {
            if (_didIteratorError11) {
              throw _iteratorError11;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref43;

          _ref43 = null;

          if (!(_ref43 == null)) {
            throw new TypeError('Value of variable "_ref43" violates contract, expected void got ' + (_ref43 === null ? 'null' : (typeof _ref43 === 'undefined' ? 'undefined' : _typeof(_ref43)) === 'object' && _ref43.constructor ? _ref43.constructor.name || '[Unknown Object]' : typeof _ref43 === 'undefined' ? 'undefined' : _typeof(_ref43)));
          }

          if (_ref43 == null || typeof _ref43 === 'boolean') {
            return _ref43;
          } else {
            throw new TypeError('Function "maybeNullableAnnotation" return value violates contract, expected ?bool got ' + (_ref43 === null ? 'null' : (typeof _ref43 === 'undefined' ? 'undefined' : _typeof(_ref43)) === 'object' && _ref43.constructor ? _ref43.constructor.name || '[Unknown Object]' : typeof _ref43 === 'undefined' ? 'undefined' : _typeof(_ref43)));
          }
        }
      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with an object type,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeInstanceOfAnnotation(annotation, expected) {
    var _maybeInstanceOfAnnot2, _ref46;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Identifier(expected)) {
      throw new TypeError('Value of argument "expected" violates contract, expected Identifier got ' + (expected === null ? 'null' : (typeof expected === 'undefined' ? 'undefined' : _typeof(expected)) === 'object' && expected.constructor ? expected.constructor.name || '[Unknown Object]' : typeof expected === 'undefined' ? 'undefined' : _typeof(expected)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeInstanceOfAnnot2 = maybeInstanceOfAnnotation(annotation.typeAnnotation);

          if (!(_maybeInstanceOfAnnot2 == null || typeof _maybeInstanceOfAnnot2 === 'boolean')) {
            throw new TypeError('Value of variable "_maybeInstanceOfAnnot2" violates contract, expected ?bool got ' + (_maybeInstanceOfAnnot2 === null ? 'null' : (typeof _maybeInstanceOfAnnot2 === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot2)) === 'object' && _maybeInstanceOfAnnot2.constructor ? _maybeInstanceOfAnnot2.constructor.name || '[Unknown Object]' : typeof _maybeInstanceOfAnnot2 === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot2)));
          }

          if (_maybeInstanceOfAnnot2 == null || typeof _maybeInstanceOfAnnot2 === 'boolean') {
            return _maybeInstanceOfAnnot2;
          } else {
            throw new TypeError('Function "maybeInstanceOfAnnotation" return value violates contract, expected ?bool got ' + (_maybeInstanceOfAnnot2 === null ? 'null' : (typeof _maybeInstanceOfAnnot2 === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot2)) === 'object' && _maybeInstanceOfAnnot2.constructor ? _maybeInstanceOfAnnot2.constructor.name || '[Unknown Object]' : typeof _maybeInstanceOfAnnot2 === 'undefined' ? 'undefined' : _typeof(_maybeInstanceOfAnnot2)));
          }
        }

      case 'GenericTypeAnnotation':
        if (annotation.id.name === expected.name) {
          return true;
        } else {
          var _ref44;

          _ref44 = null;

          if (!(_ref44 == null)) {
            throw new TypeError('Value of variable "_ref44" violates contract, expected void got ' + (_ref44 === null ? 'null' : (typeof _ref44 === 'undefined' ? 'undefined' : _typeof(_ref44)) === 'object' && _ref44.constructor ? _ref44.constructor.name || '[Unknown Object]' : typeof _ref44 === 'undefined' ? 'undefined' : _typeof(_ref44)));
          }

          if (_ref44 == null || typeof _ref44 === 'boolean') {
            return _ref44;
          } else {
            throw new TypeError('Function "maybeInstanceOfAnnotation" return value violates contract, expected ?bool got ' + (_ref44 === null ? 'null' : (typeof _ref44 === 'undefined' ? 'undefined' : _typeof(_ref44)) === 'object' && _ref44.constructor ? _ref44.constructor.name || '[Unknown Object]' : typeof _ref44 === 'undefined' ? 'undefined' : _typeof(_ref44)));
          }
        }
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion12 = true;
        var _didIteratorError12 = false;
        var _iteratorError12 = undefined;

        try {
          for (var _iterator12 = annotation.types[Symbol.iterator](), _step12; !(_iteratorNormalCompletion12 = (_step12 = _iterator12.next()).done); _iteratorNormalCompletion12 = true) {
            var _type13 = _step12.value;

            var result = maybeInstanceOfAnnotation(_type13, expected);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError12 = true;
          _iteratorError12 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion12 && _iterator12.return) {
              _iterator12.return();
            }
          } finally {
            if (_didIteratorError12) {
              throw _iteratorError12;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref45;

          _ref45 = null;

          if (!(_ref45 == null)) {
            throw new TypeError('Value of variable "_ref45" violates contract, expected void got ' + (_ref45 === null ? 'null' : (typeof _ref45 === 'undefined' ? 'undefined' : _typeof(_ref45)) === 'object' && _ref45.constructor ? _ref45.constructor.name || '[Unknown Object]' : typeof _ref45 === 'undefined' ? 'undefined' : _typeof(_ref45)));
          }

          if (_ref45 == null || typeof _ref45 === 'boolean') {
            return _ref45;
          } else {
            throw new TypeError('Function "maybeInstanceOfAnnotation" return value violates contract, expected ?bool got ' + (_ref45 === null ? 'null' : (typeof _ref45 === 'undefined' ? 'undefined' : _typeof(_ref45)) === 'object' && _ref45.constructor ? _ref45.constructor.name || '[Unknown Object]' : typeof _ref45 === 'undefined' ? 'undefined' : _typeof(_ref45)));
          }
        }
      case 'VoidTypeAnnotation':
      case 'BooleanTypeAnnotation':
      case 'BooleanLiteralTypeAnnotation':
      case 'StringTypeAnnotation':
      case 'StringLiteralTypeAnnotation':
      case 'NumberTypeAnnotation':
      case 'NumericLiteralTypeAnnotation':
      case 'FunctionTypeAnnotation':
        return false;
      default:
        {
          _ref46 = null;

          if (!(_ref46 == null)) {
            throw new TypeError('Value of variable "_ref46" violates contract, expected void got ' + (_ref46 === null ? 'null' : (typeof _ref46 === 'undefined' ? 'undefined' : _typeof(_ref46)) === 'object' && _ref46.constructor ? _ref46.constructor.name || '[Unknown Object]' : typeof _ref46 === 'undefined' ? 'undefined' : _typeof(_ref46)));
          }

          if (_ref46 == null || typeof _ref46 === 'boolean') {
            return _ref46;
          } else {
            throw new TypeError('Function "maybeInstanceOfAnnotation" return value violates contract, expected ?bool got ' + (_ref46 === null ? 'null' : (typeof _ref46 === 'undefined' ? 'undefined' : _typeof(_ref46)) === 'object' && _ref46.constructor ? _ref46.constructor.name || '[Unknown Object]' : typeof _ref46 === 'undefined' ? 'undefined' : _typeof(_ref46)));
          }
        }

    }
  }

  /**
   * Returns `true` if the annotation is compatible with an array,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeArrayAnnotation(annotation) {
    var _maybeArrayAnnotation, _ref49;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeArrayAnnotation = maybeArrayAnnotation(annotation.typeAnnotation);

          if (!(_maybeArrayAnnotation == null || typeof _maybeArrayAnnotation === 'boolean')) {
            throw new TypeError('Value of variable "_maybeArrayAnnotation" violates contract, expected ?bool got ' + (_maybeArrayAnnotation === null ? 'null' : (typeof _maybeArrayAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeArrayAnnotation)) === 'object' && _maybeArrayAnnotation.constructor ? _maybeArrayAnnotation.constructor.name || '[Unknown Object]' : typeof _maybeArrayAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeArrayAnnotation)));
          }

          if (_maybeArrayAnnotation == null || typeof _maybeArrayAnnotation === 'boolean') {
            return _maybeArrayAnnotation;
          } else {
            throw new TypeError('Function "maybeArrayAnnotation" return value violates contract, expected ?bool got ' + (_maybeArrayAnnotation === null ? 'null' : (typeof _maybeArrayAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeArrayAnnotation)) === 'object' && _maybeArrayAnnotation.constructor ? _maybeArrayAnnotation.constructor.name || '[Unknown Object]' : typeof _maybeArrayAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeArrayAnnotation)));
          }
        }

      case 'TupleTypeAnnotation':
      case 'ArrayTypeAnnotation':
        return true;
      case 'GenericTypeAnnotation':
        return annotation.id.name === 'Array' ? true : null;
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion13 = true;
        var _didIteratorError13 = false;
        var _iteratorError13 = undefined;

        try {
          for (var _iterator13 = annotation.types[Symbol.iterator](), _step13; !(_iteratorNormalCompletion13 = (_step13 = _iterator13.next()).done); _iteratorNormalCompletion13 = true) {
            var _type14 = _step13.value;

            var result = maybeArrayAnnotation(_type14);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError13 = true;
          _iteratorError13 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion13 && _iterator13.return) {
              _iterator13.return();
            }
          } finally {
            if (_didIteratorError13) {
              throw _iteratorError13;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref48;

          _ref48 = null;

          if (!(_ref48 == null)) {
            throw new TypeError('Value of variable "_ref48" violates contract, expected void got ' + (_ref48 === null ? 'null' : (typeof _ref48 === 'undefined' ? 'undefined' : _typeof(_ref48)) === 'object' && _ref48.constructor ? _ref48.constructor.name || '[Unknown Object]' : typeof _ref48 === 'undefined' ? 'undefined' : _typeof(_ref48)));
          }

          if (_ref48 == null || typeof _ref48 === 'boolean') {
            return _ref48;
          } else {
            throw new TypeError('Function "maybeArrayAnnotation" return value violates contract, expected ?bool got ' + (_ref48 === null ? 'null' : (typeof _ref48 === 'undefined' ? 'undefined' : _typeof(_ref48)) === 'object' && _ref48.constructor ? _ref48.constructor.name || '[Unknown Object]' : typeof _ref48 === 'undefined' ? 'undefined' : _typeof(_ref48)));
          }
        }
      case 'AnyTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        {
          _ref49 = null;

          if (!(_ref49 == null)) {
            throw new TypeError('Value of variable "_ref49" violates contract, expected void got ' + (_ref49 === null ? 'null' : (typeof _ref49 === 'undefined' ? 'undefined' : _typeof(_ref49)) === 'object' && _ref49.constructor ? _ref49.constructor.name || '[Unknown Object]' : typeof _ref49 === 'undefined' ? 'undefined' : _typeof(_ref49)));
          }

          if (_ref49 == null || typeof _ref49 === 'boolean') {
            return _ref49;
          } else {
            throw new TypeError('Function "maybeArrayAnnotation" return value violates contract, expected ?bool got ' + (_ref49 === null ? 'null' : (typeof _ref49 === 'undefined' ? 'undefined' : _typeof(_ref49)) === 'object' && _ref49.constructor ? _ref49.constructor.name || '[Unknown Object]' : typeof _ref49 === 'undefined' ? 'undefined' : _typeof(_ref49)));
          }
        }

      default:
        return false;
    }
  }

  /**
   * Returns `true` if the annotation is compatible with a tuple,
   * `false` if it definitely isn't, or `null` if we're not sure.
   */
  function maybeTupleAnnotation(annotation) {
    var _maybeTupleAnnotation, _ref51;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
      case 'NullableTypeAnnotation':
        {
          _maybeTupleAnnotation = maybeTupleAnnotation(annotation.typeAnnotation);

          if (!(_maybeTupleAnnotation == null || typeof _maybeTupleAnnotation === 'boolean')) {
            throw new TypeError('Value of variable "_maybeTupleAnnotation" violates contract, expected ?bool got ' + (_maybeTupleAnnotation === null ? 'null' : (typeof _maybeTupleAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeTupleAnnotation)) === 'object' && _maybeTupleAnnotation.constructor ? _maybeTupleAnnotation.constructor.name || '[Unknown Object]' : typeof _maybeTupleAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeTupleAnnotation)));
          }

          if (_maybeTupleAnnotation == null || typeof _maybeTupleAnnotation === 'boolean') {
            return _maybeTupleAnnotation;
          } else {
            throw new TypeError('Function "maybeTupleAnnotation" return value violates contract, expected ?bool got ' + (_maybeTupleAnnotation === null ? 'null' : (typeof _maybeTupleAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeTupleAnnotation)) === 'object' && _maybeTupleAnnotation.constructor ? _maybeTupleAnnotation.constructor.name || '[Unknown Object]' : typeof _maybeTupleAnnotation === 'undefined' ? 'undefined' : _typeof(_maybeTupleAnnotation)));
          }
        }

      case 'TupleTypeAnnotation':
        return true;
      case 'UnionTypeAnnotation':
        var falseCount = 0;
        var _iteratorNormalCompletion14 = true;
        var _didIteratorError14 = false;
        var _iteratorError14 = undefined;

        try {
          for (var _iterator14 = annotation.types[Symbol.iterator](), _step14; !(_iteratorNormalCompletion14 = (_step14 = _iterator14.next()).done); _iteratorNormalCompletion14 = true) {
            var _type15 = _step14.value;

            var result = maybeTupleAnnotation(_type15);
            if (result === true) {
              return true;
            } else if (result === false) {
              falseCount++;
            }
          }
        } catch (err) {
          _didIteratorError14 = true;
          _iteratorError14 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion14 && _iterator14.return) {
              _iterator14.return();
            }
          } finally {
            if (_didIteratorError14) {
              throw _iteratorError14;
            }
          }
        }

        if (falseCount === annotation.types.length) {
          return false;
        } else {
          var _ref50;

          _ref50 = null;

          if (!(_ref50 == null)) {
            throw new TypeError('Value of variable "_ref50" violates contract, expected void got ' + (_ref50 === null ? 'null' : (typeof _ref50 === 'undefined' ? 'undefined' : _typeof(_ref50)) === 'object' && _ref50.constructor ? _ref50.constructor.name || '[Unknown Object]' : typeof _ref50 === 'undefined' ? 'undefined' : _typeof(_ref50)));
          }

          if (_ref50 == null || typeof _ref50 === 'boolean') {
            return _ref50;
          } else {
            throw new TypeError('Function "maybeTupleAnnotation" return value violates contract, expected ?bool got ' + (_ref50 === null ? 'null' : (typeof _ref50 === 'undefined' ? 'undefined' : _typeof(_ref50)) === 'object' && _ref50.constructor ? _ref50.constructor.name || '[Unknown Object]' : typeof _ref50 === 'undefined' ? 'undefined' : _typeof(_ref50)));
          }
        }
      case 'GenericTypeAnnotation':
      case 'AnyTypeAnnotation':
      case 'ArrayTypeAnnotation':
      case 'MixedTypeAnnotation':
      case 'IntersectionTypeAnnotation':
        {
          _ref51 = null;

          if (!(_ref51 == null)) {
            throw new TypeError('Value of variable "_ref51" violates contract, expected void got ' + (_ref51 === null ? 'null' : (typeof _ref51 === 'undefined' ? 'undefined' : _typeof(_ref51)) === 'object' && _ref51.constructor ? _ref51.constructor.name || '[Unknown Object]' : typeof _ref51 === 'undefined' ? 'undefined' : _typeof(_ref51)));
          }

          if (_ref51 == null || typeof _ref51 === 'boolean') {
            return _ref51;
          } else {
            throw new TypeError('Function "maybeTupleAnnotation" return value violates contract, expected ?bool got ' + (_ref51 === null ? 'null' : (typeof _ref51 === 'undefined' ? 'undefined' : _typeof(_ref51)) === 'object' && _ref51.constructor ? _ref51.constructor.name || '[Unknown Object]' : typeof _ref51 === 'undefined' ? 'undefined' : _typeof(_ref51)));
          }
        }

      default:
        return false;
    }
  }

  function humanReadableType(annotation) {
    var _generate$code;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    switch (annotation.type) {
      case 'TypeAnnotation':
      case 'FunctonTypeParam':
        return humanReadableType(annotation.typeAnnotation);

      case 'FunctionTypeAnnotation':
        // @fixme babel doesn't seem to like generating FunctionTypeAnnotations yet
        return '(' + annotation.params.map(humanReadableType).join(', ') + ') => ' + humanReadableType(annotation.returnType);
      default:
        {
          _generate$code = (0, _babelGenerator2.default)(annotation).code;

          if (typeof _generate$code === 'string') {
            return _generate$code;
          } else {
            throw new TypeError('Function "humanReadableType" return value violates contract, expected string got ' + (_generate$code === null ? 'null' : (typeof _generate$code === 'undefined' ? 'undefined' : _typeof(_generate$code)) === 'object' && _generate$code.constructor ? _generate$code.constructor.name || '[Unknown Object]' : typeof _generate$code === 'undefined' ? 'undefined' : _typeof(_generate$code)));
          }
        }

    }
  }

  function humanReadableObject(annotation, scope) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    if (annotation.properties.length === 0) {
      return 'an object';
    } else {
      var shape = (0, _babelGenerator2.default)(annotation).code;
      return 'an object with shape ' + shape;
    }
  }

  function humanReadableArray(annotation, scope) {
    var _generate$code2;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    _generate$code2 = (0, _babelGenerator2.default)(annotation).code;

    if (typeof _generate$code2 === 'string') {
      return _generate$code2;
    } else {
      throw new TypeError('Function "humanReadableArray" return value violates contract, expected string got ' + (_generate$code2 === null ? 'null' : (typeof _generate$code2 === 'undefined' ? 'undefined' : _typeof(_generate$code2)) === 'object' && _generate$code2.constructor ? _generate$code2.constructor.name || '[Unknown Object]' : typeof _generate$code2 === 'undefined' ? 'undefined' : _typeof(_generate$code2)));
    }
  }

  function humanReadableTuple(annotation, scope) {
    var _generate$code3;

    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    _generate$code3 = (0, _babelGenerator2.default)(annotation).code;

    if (typeof _generate$code3 === 'string') {
      return _generate$code3;
    } else {
      throw new TypeError('Function "humanReadableTuple" return value violates contract, expected string got ' + (_generate$code3 === null ? 'null' : (typeof _generate$code3 === 'undefined' ? 'undefined' : _typeof(_generate$code3)) === 'object' && _generate$code3.constructor ? _generate$code3.constructor.name || '[Unknown Object]' : typeof _generate$code3 === 'undefined' ? 'undefined' : _typeof(_generate$code3)));
    }
  }

  function isTypeChecker(id, scope) {
    if (!(Identifier(id) || QualifiedTypeIdentifier(id))) {
      throw new TypeError('Value of argument "id" violates contract, expected Identifier | QualifiedTypeIdentifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    var binding = scope.getBinding(id.name);
    if (binding === undefined) {
      return false;
    }
    var path = binding.path;

    if (path == null) {
      return false;
    } else if (path.type === 'TypeAlias' || path.type === 'VariableDeclaration' && path.node.isTypeChecker) {
      return true;
    } else if (path.isImportSpecifier() && path.parent.importKind === 'type') {
      return true;
    }
    return false;
  }

  function isPolymorphicType(id, scope) {
    if (!(Identifier(id) || QualifiedTypeIdentifier(id))) {
      throw new TypeError('Value of argument "id" violates contract, expected Identifier | QualifiedTypeIdentifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    var binding = scope.getBinding(id.name);
    if (binding !== undefined) {
      return false;
    }
    var path = scope.path;

    while (path && path.type !== 'Program') {
      var _path = path;
      var _node = _path.node;

      if ((t.isFunction(_node) || t.isClass(_node)) && _node.typeParameters) {
        var _iteratorNormalCompletion15 = true;
        var _didIteratorError15 = false;
        var _iteratorError15 = undefined;

        try {
          for (var _iterator15 = _node.typeParameters.params[Symbol.iterator](), _step15; !(_iteratorNormalCompletion15 = (_step15 = _iterator15.next()).done); _iteratorNormalCompletion15 = true) {
            var param = _step15.value;

            param.isPolymorphicType = true;
            if (param.name === id.name) {
              return true;
            }
          }
        } catch (err) {
          _didIteratorError15 = true;
          _iteratorError15 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion15 && _iterator15.return) {
              _iterator15.return();
            }
          } finally {
            if (_didIteratorError15) {
              throw _iteratorError15;
            }
          }
        }
      }
      path = path.parentPath;
    }
    return false;
  }

  function getPolymorphicType(id, scope) {
    var _ref55;

    if (!(Identifier(id) || QualifiedTypeIdentifier(id))) {
      throw new TypeError('Value of argument "id" violates contract, expected Identifier | QualifiedTypeIdentifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    var binding = scope.getBinding(id.name);
    if (binding !== undefined) {
      var _false42;

      _false42 = false;

      if (_false42 == null || Node(_false42)) {
        return _false42;
      } else {
        throw new TypeError('Function "getPolymorphicType" return value violates contract, expected ?Node got ' + (_false42 === null ? 'null' : (typeof _false42 === 'undefined' ? 'undefined' : _typeof(_false42)) === 'object' && _false42.constructor ? _false42.constructor.name || '[Unknown Object]' : typeof _false42 === 'undefined' ? 'undefined' : _typeof(_false42)));
      }
    }
    var path = scope.path;

    while (path && path.type !== 'Program') {
      var _path2 = path;
      var _node2 = _path2.node;

      if (t.isFunction(_node2) && _node2.typeParameters) {
        var _iteratorNormalCompletion16 = true;
        var _didIteratorError16 = false;
        var _iteratorError16 = undefined;

        try {
          for (var _iterator16 = _node2.typeParameters.params[Symbol.iterator](), _step16; !(_iteratorNormalCompletion16 = (_step16 = _iterator16.next()).done); _iteratorNormalCompletion16 = true) {
            var param = _step16.value;

            param.isPolymorphicType = true;
            if (param.name === id.name) {
              if (param == null || Node(param)) {
                return param;
              } else {
                throw new TypeError('Function "getPolymorphicType" return value violates contract, expected ?Node got ' + (param === null ? 'null' : (typeof param === 'undefined' ? 'undefined' : _typeof(param)) === 'object' && param.constructor ? param.constructor.name || '[Unknown Object]' : typeof param === 'undefined' ? 'undefined' : _typeof(param)));
              }
            }
          }
        } catch (err) {
          _didIteratorError16 = true;
          _iteratorError16 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion16 && _iterator16.return) {
              _iterator16.return();
            }
          } finally {
            if (_didIteratorError16) {
              throw _iteratorError16;
            }
          }
        }
      }
      path = path.parent;
    }
    _ref55 = null;

    if (!(_ref55 == null)) {
      throw new TypeError('Value of variable "_ref55" violates contract, expected void got ' + (_ref55 === null ? 'null' : (typeof _ref55 === 'undefined' ? 'undefined' : _typeof(_ref55)) === 'object' && _ref55.constructor ? _ref55.constructor.name || '[Unknown Object]' : typeof _ref55 === 'undefined' ? 'undefined' : _typeof(_ref55)));
    }

    if (_ref55 == null || Node(_ref55)) {
      return _ref55;
    } else {
      throw new TypeError('Function "getPolymorphicType" return value violates contract, expected ?Node got ' + (_ref55 === null ? 'null' : (typeof _ref55 === 'undefined' ? 'undefined' : _typeof(_ref55)) === 'object' && _ref55.constructor ? _ref55.constructor.name || '[Unknown Object]' : typeof _ref55 === 'undefined' ? 'undefined' : _typeof(_ref55)));
    }
  }

  function collectParamChecks(path) {
    var _path$get$map$filter;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    _path$get$map$filter = path.get('params').map(function (param) {
      var node = param.node;

      if (node.type === 'AssignmentPattern') {
        if (node.left.typeAnnotation) {
          return createDefaultParamGuard(param);
        }
      } else if (node.type === 'RestElement') {
        if (node.typeAnnotation) {
          return createRestParamGuard(param);
        }
      } else if (node.typeAnnotation) {
        return createParamGuard(param);
      }
    }).filter(identity);

    if (Array.isArray(_path$get$map$filter) && _path$get$map$filter.every(function (item) {
      return Node(item);
    })) {
      return _path$get$map$filter;
    } else {
      throw new TypeError('Function "collectParamChecks" return value violates contract, expected Node[] got ' + (_path$get$map$filter === null ? 'null' : (typeof _path$get$map$filter === 'undefined' ? 'undefined' : _typeof(_path$get$map$filter)) === 'object' && _path$get$map$filter.constructor ? _path$get$map$filter.constructor.name || '[Unknown Object]' : typeof _path$get$map$filter === 'undefined' ? 'undefined' : _typeof(_path$get$map$filter)));
    }
  }

  function createParamGuard(path) {
    var _guard;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;

    node.hasBeenTypeChecked = true;
    node.savedTypeAnnotation = node.typeAnnotation;
    var check = checkAnnotation(node, node.typeAnnotation, scope);
    if (!check) {
      return;
    }
    if (node.optional) {
      check = t.logicalExpression('||', checks.undefined({ input: node }), check);
    }
    var message = paramTypeErrorMessage(node, scope);
    _guard = guard({
      check: check,
      message: message
    });

    if (_guard == null || Node(_guard)) {
      return _guard;
    } else {
      throw new TypeError('Function "createParamGuard" return value violates contract, expected ?Node got ' + (_guard === null ? 'null' : (typeof _guard === 'undefined' ? 'undefined' : _typeof(_guard)) === 'object' && _guard.constructor ? _guard.constructor.name || '[Unknown Object]' : typeof _guard === 'undefined' ? 'undefined' : _typeof(_guard)));
    }
  }

  function createDefaultParamGuard(path) {
    var _createParamGuard;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.left;
    var value = node.right;

    var ok = staticCheckAnnotation(path.get('right'), id.typeAnnotation);
    if (ok === false) {
      throw path.buildCodeFrameError('Invalid default value for argument "' + id.name + '", expected ' + humanReadableType(id.typeAnnotation, scope) + '.');
    }
    _createParamGuard = createParamGuard(path.get('left'));

    if (!(_createParamGuard == null || Node(_createParamGuard))) {
      throw new TypeError('Value of variable "_createParamGuard" violates contract, expected ?Node got ' + (_createParamGuard === null ? 'null' : (typeof _createParamGuard === 'undefined' ? 'undefined' : _typeof(_createParamGuard)) === 'object' && _createParamGuard.constructor ? _createParamGuard.constructor.name || '[Unknown Object]' : typeof _createParamGuard === 'undefined' ? 'undefined' : _typeof(_createParamGuard)));
    }

    if (_createParamGuard == null || Node(_createParamGuard)) {
      return _createParamGuard;
    } else {
      throw new TypeError('Function "createDefaultParamGuard" return value violates contract, expected ?Node got ' + (_createParamGuard === null ? 'null' : (typeof _createParamGuard === 'undefined' ? 'undefined' : _typeof(_createParamGuard)) === 'object' && _createParamGuard.constructor ? _createParamGuard.constructor.name || '[Unknown Object]' : typeof _createParamGuard === 'undefined' ? 'undefined' : _typeof(_createParamGuard)));
    }
  }

  function createRestParamGuard(path) {
    var _guard2;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    var node = path.node;
    var scope = path.scope;
    var id = node.argument;

    id.hasBeenTypeChecked = true;
    node.savedTypeAnnotation = node.typeAnnotation;
    if (!isStrictlyArrayAnnotation(node.typeAnnotation)) {
      throw path.buildCodeFrameError('Invalid type annotation for rest argument "' + id.name + '", expected an Array, got: ' + humanReadableType(node.typeAnnotation, scope) + '.');
    }
    var check = checkAnnotation(id, node.typeAnnotation, scope);
    if (!check) {
      return;
    }
    if (node.optional) {
      check = t.logicalExpression('||', checks.undefined({ input: id }), check);
    }
    var message = paramTypeErrorMessage(id, scope, node.typeAnnotation);
    _guard2 = guard({
      check: check,
      message: message
    });

    if (_guard2 == null || Node(_guard2)) {
      return _guard2;
    } else {
      throw new TypeError('Function "createRestParamGuard" return value violates contract, expected ?Node got ' + (_guard2 === null ? 'null' : (typeof _guard2 === 'undefined' ? 'undefined' : _typeof(_guard2)) === 'object' && _guard2.constructor ? _guard2.constructor.name || '[Unknown Object]' : typeof _guard2 === 'undefined' ? 'undefined' : _typeof(_guard2)));
    }
  }

  function returnTypeErrorMessage(path, fn, id) {
    var _t$binaryExpression;

    if (!NodePath(path)) {
      throw new TypeError('Value of argument "path" violates contract, expected NodePath got ' + (path === null ? 'null' : (typeof path === 'undefined' ? 'undefined' : _typeof(path)) === 'object' && path.constructor ? path.constructor.name || '[Unknown Object]' : typeof path === 'undefined' ? 'undefined' : _typeof(path)));
    }

    if (!Node(fn)) {
      throw new TypeError('Value of argument "fn" violates contract, expected Node got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    if (!(id == null || Identifier(id))) {
      throw new TypeError('Value of argument "id" violates contract, expected ?Identifier got ' + (id === null ? 'null' : (typeof id === 'undefined' ? 'undefined' : _typeof(id)) === 'object' && id.constructor ? id.constructor.name || '[Unknown Object]' : typeof id === 'undefined' ? 'undefined' : _typeof(id)));
    }

    var node = path.node;
    var scope = path.scope;

    var name = fn.id ? fn.id.name : '';
    var message = 'Function ' + (name ? '"' + name + '" ' : '') + 'return value violates contract, expected ' + humanReadableType(fn.returnType, scope) + ' got ';

    _t$binaryExpression = t.binaryExpression('+', t.stringLiteral(message), node.argument ? readableName({ input: id || node.argument }) : t.stringLiteral('undefined'));

    if (Node(_t$binaryExpression)) {
      return _t$binaryExpression;
    } else {
      throw new TypeError('Function "returnTypeErrorMessage" return value violates contract, expected Node got ' + (_t$binaryExpression === null ? 'null' : (typeof _t$binaryExpression === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression)) === 'object' && _t$binaryExpression.constructor ? _t$binaryExpression.constructor.name || '[Unknown Object]' : typeof _t$binaryExpression === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression)));
    }
  }

  function paramTypeErrorMessage(node, scope) {
    var _t$binaryExpression2;

    var typeAnnotation = arguments.length <= 2 || arguments[2] === undefined ? node.typeAnnotation : arguments[2];

    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    if (!TypeAnnotation(typeAnnotation)) {
      throw new TypeError('Value of argument "typeAnnotation" violates contract, expected TypeAnnotation got ' + (typeAnnotation === null ? 'null' : (typeof typeAnnotation === 'undefined' ? 'undefined' : _typeof(typeAnnotation)) === 'object' && typeAnnotation.constructor ? typeAnnotation.constructor.name || '[Unknown Object]' : typeof typeAnnotation === 'undefined' ? 'undefined' : _typeof(typeAnnotation)));
    }

    var name = node.name;
    var message = 'Value of ' + (node.optional ? 'optional ' : '') + 'argument "' + name + '" violates contract, expected ' + humanReadableType(typeAnnotation, scope) + ' got ';

    _t$binaryExpression2 = t.binaryExpression('+', t.stringLiteral(message), readableName({ input: node }));

    if (Node(_t$binaryExpression2)) {
      return _t$binaryExpression2;
    } else {
      throw new TypeError('Function "paramTypeErrorMessage" return value violates contract, expected Node got ' + (_t$binaryExpression2 === null ? 'null' : (typeof _t$binaryExpression2 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression2)) === 'object' && _t$binaryExpression2.constructor ? _t$binaryExpression2.constructor.name || '[Unknown Object]' : typeof _t$binaryExpression2 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression2)));
    }
  }

  function varTypeErrorMessage(node, scope, annotation) {
    var _t$binaryExpression3;

    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (!Scope(scope)) {
      throw new TypeError('Value of argument "scope" violates contract, expected Scope got ' + (scope === null ? 'null' : (typeof scope === 'undefined' ? 'undefined' : _typeof(scope)) === 'object' && scope.constructor ? scope.constructor.name || '[Unknown Object]' : typeof scope === 'undefined' ? 'undefined' : _typeof(scope)));
    }

    if (!(annotation === undefined || TypeAnnotation(annotation))) {
      throw new TypeError('Value of optional argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    var name = node.name;
    var message = 'Value of variable "' + name + '" violates contract, expected ' + humanReadableType(annotation || node.typeAnnotation, scope) + ' got ';
    _t$binaryExpression3 = t.binaryExpression('+', t.stringLiteral(message), readableName({ input: node }));

    if (Node(_t$binaryExpression3)) {
      return _t$binaryExpression3;
    } else {
      throw new TypeError('Function "varTypeErrorMessage" return value violates contract, expected Node got ' + (_t$binaryExpression3 === null ? 'null' : (typeof _t$binaryExpression3 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression3)) === 'object' && _t$binaryExpression3.constructor ? _t$binaryExpression3.constructor.name || '[Unknown Object]' : typeof _t$binaryExpression3 === 'undefined' ? 'undefined' : _typeof(_t$binaryExpression3)));
    }
  }

  /**
   * Determine whether the given node can produce purely boolean results.
   */
  function isBooleanExpression(node) {
    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (node.type === 'BinaryExpression' && BOOLEAN_BINARY_OPERATORS.indexOf(node.operator) > -1) {
      return true;
    } else if (node.type === 'LogicalExpression') {
      return isBooleanExpression(node.left) && isBooleanExpression(node.right);
    } else {
      return false;
    }
  }

  /**
   * Convert type specifier to expression.
   */
  function createTypeExpression(node) {
    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (node.type == 'Identifier') {
      if (node instanceof Object) {
        return node;
      } else {
        throw new TypeError('Function "createTypeExpression" return value violates contract, expected Object got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
      }
    } else if (node.type == 'QualifiedTypeIdentifier') {
      var _t$memberExpression;

      _t$memberExpression = t.memberExpression(createTypeExpression(node.qualification), createTypeExpression(node.id));

      if (_t$memberExpression instanceof Object) {
        return _t$memberExpression;
      } else {
        throw new TypeError('Function "createTypeExpression" return value violates contract, expected Object got ' + (_t$memberExpression === null ? 'null' : (typeof _t$memberExpression === 'undefined' ? 'undefined' : _typeof(_t$memberExpression)) === 'object' && _t$memberExpression.constructor ? _t$memberExpression.constructor.name || '[Unknown Object]' : typeof _t$memberExpression === 'undefined' ? 'undefined' : _typeof(_t$memberExpression)));
      }
    }

    throw this.errorWithNode('Unsupported type: ' + node.type);
  }

  /**
   * Get name of a type as a string.
   */
  function getTypeName(node) {
    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (node.type == 'Identifier') {
      var _node$name;

      _node$name = node.name;

      if (typeof _node$name === 'string') {
        return _node$name;
      } else {
        throw new TypeError('Function "getTypeName" return value violates contract, expected string got ' + (_node$name === null ? 'null' : (typeof _node$name === 'undefined' ? 'undefined' : _typeof(_node$name)) === 'object' && _node$name.constructor ? _node$name.constructor.name || '[Unknown Object]' : typeof _node$name === 'undefined' ? 'undefined' : _typeof(_node$name)));
      }
    } else if (node.type == 'QualifiedTypeIdentifier') {
      var _ref56;

      _ref56 = getTypeName(node.qualification) + '.' + getTypeName(node.id);

      if (typeof _ref56 === 'string') {
        return _ref56;
      } else {
        throw new TypeError('Function "getTypeName" return value violates contract, expected string got ' + (_ref56 === null ? 'null' : (typeof _ref56 === 'undefined' ? 'undefined' : _typeof(_ref56)) === 'object' && _ref56.constructor ? _ref56.constructor.name || '[Unknown Object]' : typeof _ref56 === 'undefined' ? 'undefined' : _typeof(_ref56)));
      }
    }

    throw this.errorWithNode('Unsupported type: ' + node.type);
  }

  /**
   * Union two arrays.
   */
  function union(arr1, arr2) {
    if (!Array.isArray(arr1)) {
      throw new TypeError('Value of argument "arr1" violates contract, expected Array got ' + (arr1 === null ? 'null' : (typeof arr1 === 'undefined' ? 'undefined' : _typeof(arr1)) === 'object' && arr1.constructor ? arr1.constructor.name || '[Unknown Object]' : typeof arr1 === 'undefined' ? 'undefined' : _typeof(arr1)));
    }

    if (!Array.isArray(arr2)) {
      throw new TypeError('Value of argument "arr2" violates contract, expected Array got ' + (arr2 === null ? 'null' : (typeof arr2 === 'undefined' ? 'undefined' : _typeof(arr2)) === 'object' && arr2.constructor ? arr2.constructor.name || '[Unknown Object]' : typeof arr2 === 'undefined' ? 'undefined' : _typeof(arr2)));
    }

    for (var i = 0; i < arr2.length; i++) {
      var item = arr2[i];
      if (arr1.indexOf(item) === -1) {
        arr1.push(item);
      }
    }
    return arr1;
  }

  /**
   * Determine whether the given annotation allows any value.
   */
  function allowsAny(annotation) {
    if (!TypeAnnotation(annotation)) {
      throw new TypeError('Value of argument "annotation" violates contract, expected TypeAnnotation got ' + (annotation === null ? 'null' : (typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)) === 'object' && annotation.constructor ? annotation.constructor.name || '[Unknown Object]' : typeof annotation === 'undefined' ? 'undefined' : _typeof(annotation)));
    }

    if (annotation.type === 'TypeAnnotation' || annotation.type === 'NullableTypeAnnotation') {
      return allowsAny(annotation.typeAnnotation);
    } else if (annotation.type === 'AnyTypeAnnotation' || annotation.type === 'MixedTypeAnnotation') {
      return true;
    } else if (annotation.type === 'UnionTypeAnnotation') {
      var _annotation$types$som;

      _annotation$types$som = annotation.types.some(allowsAny);

      if (typeof _annotation$types$som === 'boolean') {
        return _annotation$types$som;
      } else {
        throw new TypeError('Function "allowsAny" return value violates contract, expected bool got ' + (_annotation$types$som === null ? 'null' : (typeof _annotation$types$som === 'undefined' ? 'undefined' : _typeof(_annotation$types$som)) === 'object' && _annotation$types$som.constructor ? _annotation$types$som.constructor.name || '[Unknown Object]' : typeof _annotation$types$som === 'undefined' ? 'undefined' : _typeof(_annotation$types$som)));
      }
    } else {
      return false;
    }
  }

  /**
   * Determine whether a given node is nully (null or undefined).
   */
  function isNodeNully(node) {
    if (!(node == null || Node(node))) {
      throw new TypeError('Value of argument "node" violates contract, expected ?Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    if (node == null) {
      return true;
    } else if (node.type === 'Identifier' && node.name === 'undefined') {
      return true;
    } else if (node.type === 'Literal' && node.value === null) {
      return true;
    } else if (node.type === 'UnaryExpression' && node.operator === 'void') {
      return true;
    } else {
      return false;
    }
  }

  /**
   * A function that returns its first argument, useful when filtering.
   */
  function identity(input) {
    return input;
  }

  function getExpression(node) {
    var _ref57;

    if (!Node(node)) {
      throw new TypeError('Value of argument "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
    }

    _ref57 = t.isExpressionStatement(node) ? node.expression : node;

    if (Node(_ref57)) {
      return _ref57;
    } else {
      throw new TypeError('Function "getExpression" return value violates contract, expected Node got ' + (_ref57 === null ? 'null' : (typeof _ref57 === 'undefined' ? 'undefined' : _typeof(_ref57)) === 'object' && _ref57.constructor ? _ref57.constructor.name || '[Unknown Object]' : typeof _ref57 === 'undefined' ? 'undefined' : _typeof(_ref57)));
    }
  }

  function expression(input) {
    var _ref58;

    if (!(typeof input === 'string')) {
      throw new TypeError('Value of argument "input" violates contract, expected string got ' + (input === null ? 'null' : (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && input.constructor ? input.constructor.name || '[Unknown Object]' : typeof input === 'undefined' ? 'undefined' : _typeof(input)));
    }

    var fn = template(input);

    if (!(typeof fn === 'function')) {
      throw new TypeError('Value of variable "fn" violates contract, expected Function got ' + (fn === null ? 'null' : (typeof fn === 'undefined' ? 'undefined' : _typeof(fn)) === 'object' && fn.constructor ? fn.constructor.name || '[Unknown Object]' : typeof fn === 'undefined' ? 'undefined' : _typeof(fn)));
    }

    _ref58 = function () {
      var node = fn.apply(undefined, arguments);

      if (!Node(node)) {
        throw new TypeError('Value of variable "node" violates contract, expected Node got ' + (node === null ? 'null' : (typeof node === 'undefined' ? 'undefined' : _typeof(node)) === 'object' && node.constructor ? node.constructor.name || '[Unknown Object]' : typeof node === 'undefined' ? 'undefined' : _typeof(node)));
      }

      return getExpression(node);
    };

    if (typeof _ref58 === 'function') {
      return _ref58;
    } else {
      throw new TypeError('Function "expression" return value violates contract, expected Function got ' + (_ref58 === null ? 'null' : (typeof _ref58 === 'undefined' ? 'undefined' : _typeof(_ref58)) === 'object' && _ref58.constructor ? _ref58.constructor.name || '[Unknown Object]' : typeof _ref58 === 'undefined' ? 'undefined' : _typeof(_ref58)));
    }
  }
};

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

var Node = function Node(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string';
};

var Identifier = function Identifier(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string' && typeof input.name === 'string';
};

var QualifiedTypeIdentifier = function QualifiedTypeIdentifier(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && Identifier(input.id) && (Identifier(input.qualification) || QualifiedTypeIdentifier(input.qualification));
};

var TypeAnnotation = function TypeAnnotation(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string';
};

var Scope = function Scope(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object';
};

var NodePath = function NodePath(input) {
  return input != null && (typeof input === 'undefined' ? 'undefined' : _typeof(input)) === 'object' && typeof input.type === 'string' && Node(input.node) && Scope(input.scope);
};

/**
 * # Typecheck Transformer
 */